﻿-----------------------------------------------
---- Raeli's Spell Announcer Hunter Module ----
-----------------------------------------------
local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
local RSA_Hunter = RSA:NewModule("Hunter")
function RSA_Hunter:OnInitialize()
	if RSA.db.profile.General.Class == "HUNTER" then
		RSA_Hunter:SetEnabledState(true)
	else
		RSA_Hunter:SetEnabledState(false)
	end
end -- End OnInitialize
function RSA_Hunter:OnEnable()
RSA.db.profile.Modules.Hunter = true -- Set state to loaded, to know if we should announce when a spell is refreshed.
local pName = UnitName("player")
local function Hunter_Spells(_, _, _, event, _, _, source, _, destGUID, dest, _, spellID, spellName, _, missType)
	local petName = UnitName("pet")
	if source == pName or source == petName then
		if (event == "SPELL_CAST_SUCCESS" and RSA.db.profile.Modules.Reminders_Loaded == true) then -- Reminder Refreshed
			local ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
			if spellName == ReminderSpell and (dest == pName or dest == nil) then
				RSA_Reminder:SetScript("OnUpdate", nil)
				if RSA.db.profile.Reminders.RemindChannels.Chat == true then
					RSA_Print_Self(ReminderSpell .. L[" Refreshed!"])
				end
				if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
					RSA_Print_Self_RW(ReminderSpell .. L[" Refreshed!"])
				end
			end
		end -- BUFF REMINDER
		if event == "SPELL_AURA_APPLIED" then
			if spellID == 20736 then -- DISTRACTING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.DistractingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.DistractingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- DISTRACTING SHOT		
			if spellID == 3355 then -- FREEZING TRAP
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.FreezingTrap.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Party == true then
						if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Raid == true then
						if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- FREEZING TRAP
			if spellID == 19386 then -- WYVERN STING
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.WyvernSting.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.WyvernSting.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Party == true then
						if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Raid == true then
						if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WYVERN STING	
		end -- IF EVENT IS SPELL_AURA_APPLIED
		if event == "SPELL_CREATE" then
			if spellID == 1499 or spellID == 60202 then -- FREEZING TRAP
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement ~= "" then
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.FreezingTrap.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Party == true then
						if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Raid == true then
						if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.Placement, ".%a+.", RSA_String_Replace))
					end
				end
			end -- FREEZING TRAP			
		end -- IF EVENT IS SPELL_CREATE
		if event == "SPELL_CAST_SUCCESS" then
			if spellID == 82654 then -- WIDOW VENOM
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.WidowVenom.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.WidowVenom.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Party == true then
						if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Raid == true then
						if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WIDOW VENOM		
			if spellID == 19503 then -- SCATTER SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.ScatterShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.ScatterShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Party == true then
						if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- SCATTER SHOT			
			if spellID == 5116 then -- CONCUSSIVE SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.ConcussiveShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Party == true then
						if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- CONCUSSIVE SHOT			
			if spellID == 19263 then -- DETERRENCE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.Deterrence.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.Deterrence.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Party == true then
						if RSA.db.profile.Hunter.Spells.Deterrence.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Raid == true then
						if RSA.db.profile.Hunter.Spells.Deterrence.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- DETERRENCE
			if spellID == 51753 then -- CAMOFLAGE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.Camoflage.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.Camoflage.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Party == true then
						if RSA.db.profile.Hunter.Spells.Camoflage.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Raid == true then
						if RSA.db.profile.Hunter.Spells.Camoflage.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- CAMOFLAGE
		end -- IF EVENT IS SPELL_CAST_SUCCESS
		if event == "SPELL_INTERRUPT" then
			if spellID == 34490 then -- SILENCING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[TARCAST]"] = extraspellinfo, ["[TARLINK]"] = extraspellinfolink,}
				if RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.SilencingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.SilencingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- SILENCING SHOT
		end -- IF EVENT IS SPELL_INTERRUPT
		if event == "SPELL_DISPEL" then
			if spellID == 19801 then -- TRANQUILIZING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start ~= "" then
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.TranquilizingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- TRANQUILIZING SHOT
		end -- IF EVENT IS SPELL_DISPEL
		if event == "SPELL_DISPEL_FAILED" then
			if spellID == 19801 then -- TRANQUILIZING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.TranquilizingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.TranquilizingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.TranquilizingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.TranquilizingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- TRANQUILIZING SHOT
		end -- IF EVENT IS SPELL_DISPEL_FAILED		
		if event == "SPELL_AURA_REMOVED" then
			if spellID == 82654 then -- WIDOW VENOM
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.WidowVenom.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.WidowVenom.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Party == true then
						if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WidowVenom.Raid == true then
						if RSA.db.profile.Hunter.Spells.WidowVenom.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.WidowVenom.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WIDOW VENOM		
			if spellID == 19503 then -- SCATTER SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.ScatterShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.ScatterShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Party == true then
						if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ScatterShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.ScatterShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.ScatterShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- SCATTER SHOT
			if spellID == 5116 then -- CONCUSSIVE SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.ConcussiveShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Party == true then
						if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.ConcussiveShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.ConcussiveShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.ConcussiveShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- CONCUSSIVE SHOT				
			if spellID == 3355 then -- FREEZING TRAP
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.FreezingTrap.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Party == true then
						if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.FreezingTrap.Raid == true then
						if RSA.db.profile.Hunter.Spells.FreezingTrap.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.FreezingTrap.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- FREEZING TRAP		
			if spellID == 19263 then -- DETERRENCE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Hunter.Spells.Deterrence.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.Deterrence.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.Deterrence.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Party == true then
						if RSA.db.profile.Hunter.Spells.Deterrence.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Deterrence.Raid == true then
						if RSA.db.profile.Hunter.Spells.Deterrence.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.Deterrence.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- DETERRENCE
			if spellID == 51755 then -- CAMOFLAGE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Hunter.Spells.Camoflage.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.Camoflage.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.Camoflage.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Party == true then
						if RSA.db.profile.Hunter.Spells.Camoflage.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.Camoflage.Raid == true then
						if RSA.db.profile.Hunter.Spells.Camoflage.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.Camoflage.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- CAMOFLAGE		
			if spellID == 19386 then -- WYVERN STING
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.WyvernSting.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.WyvernSting.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Party == true then
						if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.WyvernSting.Raid == true then
						if RSA.db.profile.Hunter.Spells.WyvernSting.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.WyvernSting.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WYVERN STING
		end -- IF EVENT IS SPELL_AURA_REMOVED
		if event == "SPELL_MISSED" and missType ~= "IMMUNE" then
			if spellID == 20736 then -- DISTRACTING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = L["missed"]
				elseif missType ~= "MISS" then
					missinfo = L["was resisted by"]
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.DistractingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.DistractingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- DISTRACTING SHOT		
			if spellID == 34490 then -- SILENCING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = L["missed"]
				elseif missType ~= "MISS" then
					missinfo = L["was resisted by"]
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End ~= "" then
					if RSA.db.profile.Hunter.Spells.SilencingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.SilencingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- SILENCING SHOT
		end -- IF EVENT IS SPELL_MISSED AND NOT IMMUNE
		if event == "SPELL_MISSED" and missType == "IMMUNE" then
			if spellID == 20736 then -- DISTRACTING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = L["Immune"],}
				if RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune ~= "" then
					if RSA.db.profile.Hunter.Spells.DistractingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.DistractingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.DistractingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.DistractingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.DistractingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
				end
			end -- DISTRACTING SHOT		
			if spellID == 34490 then -- SILENCING SHOT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = L["Immune"],}
				if RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune ~= "" then
					if RSA.db.profile.Hunter.Spells.SilencingShot.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.Hunter.Spells.SilencingShot.CustomChannel.Channel)
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Party == true then
						if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Hunter.Spells.SilencingShot.Raid == true then
						if RSA.db.profile.Hunter.Spells.SilencingShot.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Hunter.Spells.SilencingShot.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
				end
			end -- SILENCING SHOT
		end -- IF EVENT IS SPELL_MISSED AND IS IMMUNE
	end -- IF SOURCE IS PLAYER
end -- END ENTIRELY
RSA_CombatLogMonitor:SetScript("OnEvent", Hunter_Spells)
end -- END ON ENABLED
function RSA_Hunter:OnDisable()
RSA_CombatLogMonitor:SetScript("OnEvent", nil)
end