﻿-----------------------------------------------
---- Raeli's Spell Announcer Shaman Module ----
-----------------------------------------------
local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
local RSA_Shaman = RSA:NewModule("Shaman")
function RSA_Shaman:OnInitialize()
	if RSA.db.profile.General.Class == "SHAMAN" then
		RSA_Shaman:SetEnabledState(true)
	else
		RSA_Shaman:SetEnabledState(false)
	end
end -- End OnInitialize
function RSA_Shaman:OnEnable()
RSA.db.profile.Modules.Shaman = true -- Set state to loaded, to know if we should announce when a spell is refreshed.
local pName = UnitName("player")
local function Shaman_Spells(_, _, _, event, _, _, source, _, destGUID, dest, _, spellID, spellName, _, missType)
	local petName = UnitName("pet")
	if source == pName or source == petName then
		if (event == "SPELL_CAST_SUCCESS" and RSA.db.profile.Modules.Reminders_Loaded == true) then -- Reminder Refreshed
			local ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
			if spellName == ReminderSpell and (dest == pName or dest == nil) then
				RSA_Reminder:SetScript("OnUpdate", nil)
				if RSA.db.profile.Reminders.RemindChannels.Chat == true then
					RSA_Print_Self(ReminderSpell .. L[" Refreshed!"])
				end
				if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
					RSA_Print_Self_RW(ReminderSpell .. L[" Refreshed!"])
				end
			end
		end -- BUFF REMINDER
		if event == "SPELL_AURA_APPLIED" then
			if spellID == 51514 then -- HEX
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Shaman.Spells.Hex.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.Hex.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.Hex.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.Hex.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.Party == true then
						if RSA.db.profile.Shaman.Spells.Hex.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.Raid == true then
						if RSA.db.profile.Shaman.Spells.Hex.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- HEX
			if spellID == 76780 then -- BIND ELEMENTAL
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.BindElemental.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.BindElemental.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Party == true then
						if RSA.db.profile.Shaman.Spells.BindElemental.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Raid == true then
						if RSA.db.profile.Shaman.Spells.BindElemental.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- BIND ELEMENTAL
		end -- IF EVENT IS SPELL_AURA_APPLIED
		if event == "SPELL_CAST_SUCCESS" then
			if spellID == 32182 or spellID == 2825 then -- BLOODLUST / HEROISM
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Shaman.Spells.Heroism.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.Heroism.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.Heroism.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Party == true then
						if RSA.db.profile.Shaman.Spells.Heroism.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Raid == true then
						if RSA.db.profile.Shaman.Spells.Heroism.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- BLOODLUST / HEROISM
		end -- IF EVENT IS SPELL_CAST_SUCCESS
		if event == "SPELL_INTERRUPT" then
			if spellID == 57994 then -- WIND SHEAR
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[TARCAST]"] = extraspellinfo, ["[TARLINK]"] = extraspellinfolink,}
				if RSA.db.profile.Shaman.Spells.WindShear.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.WindShear.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.WindShear.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Party == true then
						if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Raid == true then
						if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WIND SHEAR
		end -- IF EVENT IS SPELL_INTERRUPT
		if event == "SPELL_AURA_REMOVED" then
			if spellID == 76780 then -- BIND ELEMENTAL
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Shaman.Spells.BindElemental.Messages.End ~= "" then
					if RSA.db.profile.Shaman.Spells.BindElemental.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.BindElemental.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Party == true then
						if RSA.db.profile.Shaman.Spells.BindElemental.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.BindElemental.Raid == true then
						if RSA.db.profile.Shaman.Spells.BindElemental.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.BindElemental.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- BIND ELEMENTAL
			if spellID == 51514 then -- HEX
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Shaman.Spells.Hex.Messages.End ~= "" then
					if RSA.db.profile.Shaman.Spells.Hex.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.Hex.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.Hex.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.Party == true then
						if RSA.db.profile.Shaman.Spells.Hex.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Hex.Raid == true then
						if RSA.db.profile.Shaman.Spells.Hex.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.Hex.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- HEX
			if (spellID == 32182 or spellID == 2825) and dest == pName then -- BLOODLUST / HEROISM
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Shaman.Spells.Heroism.Messages.End ~= "" then
					if RSA.db.profile.Shaman.Spells.Heroism.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.Heroism.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Party == true then
						if RSA.db.profile.Shaman.Spells.Heroism.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Heroism.Raid == true then
						if RSA.db.profile.Shaman.Spells.Heroism.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.Heroism.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- BLOODLUST / HEROISM
		end -- IF EVENT IS SPELL_AURA_REMOVED
		if event == "SPELL_DISPEL" then
			if spellID == 370 then -- PURGE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Shaman.Spells.Purge.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.Purge.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.Purge.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.Purge.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.Party == true then
						if RSA.db.profile.Shaman.Spells.Purge.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.Raid == true then
						if RSA.db.profile.Shaman.Spells.Purge.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- PURGE
			if spellID == 51886 or spellID == 77130 then -- CLEANSE SPIRIT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.CleanseSpirit.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.Party == true then
						if RSA.db.profile.Shaman.Spells.CleanseSpirit.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.CleanseSpirit.Raid == true then
						if RSA.db.profile.Shaman.Spells.CleanseSpirit.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.CleanseSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- CLEANSE SPIRIT
		end -- IF EVENT IS SPELL_DISPEL
		if event == "SPELL_DISPEL_FAILED" then
			if spellID == 370 then -- PURGE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Shaman.Spells.Purge.Messages.End ~= "" then
					if RSA.db.profile.Shaman.Spells.Purge.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.Purge.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.Purge.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.Party == true then
						if RSA.db.profile.Shaman.Spells.Purge.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.Purge.Raid == true then
						if RSA.db.profile.Shaman.Spells.Purge.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.Purge.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- PURGE
		end -- IF EVENT IS SPELL_DISPEL_FAILED
		if event == "SPELL_MISSED" and missType ~= "IMMUNE" then
			if spellID == 57994 then -- WIND SHEAR
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = L["missed"]
				elseif missType ~= "MISS" then
					missinfo = L["was resisted by"]
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.Shaman.Spells.WindShear.Messages.End ~= "" then
					if RSA.db.profile.Shaman.Spells.WindShear.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.WindShear.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Party == true then
						if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Raid == true then
						if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WIND SHEAR
		end -- IF EVENT IS SPELL_MISSED AND NOT IMMUNE
		if event == "SPELL_MISSED" and missType == "IMMUNE" then
			if spellID == 57994 then -- WIND SHEAR
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = L["Immune"],}
				if RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune ~= "" then
					if RSA.db.profile.Shaman.Spells.WindShear.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.WindShear.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Party == true then
						if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.WindShear.Raid == true then
						if RSA.db.profile.Shaman.Spells.WindShear.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.WindShear.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
				end
			end -- WIND SHEAR
		end -- IF EVENT IS SPELL_MISSED AND IS IMMUNE
		if event == "SPELL_SUMMON" then
			if spellID == 16190 then -- MANA TIDE TOTEM
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_MT_GUID = destGUID
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start ~= "" then
					if RSA.db.profile.Shaman.Spells.ManaTide.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.ManaTide.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Party == true then
						if RSA.db.profile.Shaman.Spells.ManaTide.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Raid == true then
						if RSA.db.profile.Shaman.Spells.ManaTide.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.Start, ".%a+.", RSA_String_Replace))
					end
				end
			end -- MANA TIDE TOTEM		
		end -- IF EVENT IS SPELL_SUMMON
		if event == "UNIT_DESTROYED" then		
			if dest == "Mana Tide Totem" and destGUID == RSA_MT_GUID then -- MANA TIDE TOTEM
				spellinfo = GetSpellInfo(16190) spelllinkinfo = GetSpellLink(16190)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Shaman.Spells.ManaTide.Messages.End ~= "" then
					if RSA.db.profile.Shaman.Spells.ManaTide.Local == true then
						RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.ManaTide.CustomChannel.Channel)
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Smart.RaidParty == true then
						RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Party == true then
						if RSA.db.profile.Shaman.Spells.ManaTide.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
							RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.Shaman.Spells.ManaTide.Raid == true then
						if RSA.db.profile.Shaman.Spells.ManaTide.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
						RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.ManaTide.Messages.End, ".%a+.", RSA_String_Replace))
					end
				end
			end -- MANA TIDE TOTEM
		end -- IF EVENT IS UNIT_DESTROYED
	end -- IF SOURCE IS PLAYER
end -- END ENTIRELY
RSA_CombatLogMonitor:SetScript("OnEvent", Shaman_Spells)
------------------------------
---- Resurrection Monitor ----
------------------------------
local function Shaman_AncestralSpirit(self, event, unitID, spell, _, dest)
			if spell == GetSpellInfo(2008) then -- ANCESTRAL SPIRIT
				if (dest == L["Unknown"] or dest == nil) then
					dest = string.gsub(GameTooltipTextLeft1:GetText(), L["Corpse of "], "")
				end
				spellinfo = GetSpellInfo(spell) spelllinkinfo = GetSpellLink(spell)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if event == "UNIT_SPELLCAST_SENT" then
					if RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start ~= "" then
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Local == true then
							RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Whisper == true and dest ~= pName then
							RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
							RSA_Print_Whisper(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace), dest)
							RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.CustomChannel.Enabled == true then
							RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.AncestralSpirit.CustomChannel.Channel)
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.Say == true then
							RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Party == true then
							if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
								RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Raid == true then
							if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
							RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
					if RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End ~= "" then
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Local == true then
							RSA_Print_LibSink(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Whisper == true and dest ~= pName then
							RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
							RSA_Print_Whisper(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace), dest)
							RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.CustomChannel.Enabled == true then
							RSA_Print_Channel(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Shaman.Spells.AncestralSpirit.CustomChannel.Channel)
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.Say == true then
							RSA_Print_Say(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Party == true then
							if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.RaidParty == true and GetNumRaidMembers() == 0 and InstanceType ~= "arena" then return end
								RSA_Print_Party(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Shaman.Spells.AncestralSpirit.Raid == true then
							if RSA.db.profile.Shaman.Spells.AncestralSpirit.Smart.RaidParty == true and GetNumRaidMembers() > 0 then return end
							RSA_Print_Raid(string.gsub(RSA.db.profile.Shaman.Spells.AncestralSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- ANCESTRAL SPIRIT
end -- END FUNCTION
RSA_ResMon:SetScript("OnEvent", Shaman_AncestralSpirit)
end -- END ON ENABLED
function RSA_Shaman:OnDisable()
RSA_CombatLogMonitor:SetScript("OnEvent", nil)
RSA_ResMon:SetScript("OnEvent", nil)
end