-----------------------------------------------------------
--  FreierGeist_InstanceTime - Version 4.01
--    by Dhana (started: 06/25/2006)
--	       (actually changed: 03/11/2011)
--
--  Shows how long it took to complete the instance.
--  Accepts either "/instancetime", "/InstanceTime",
--                 "/it" or "/IT" slashcommands
--  Type
--     /it help
--  for further details.
--
-----------------------------------------------------------
-- german conventions:
-- ä = \195\164
-- Ä = \195\132
-- ü = \195\188
-- Ü = \195\156
-- ö = \195\182
-- Ö = \195\150
-- ß = \195\159 
-----------------------------------------------------------
-- blizzards item colors
--
-- grey	 	- 	|cff9d9d9d
-- white 	- 	|cffffffff
-- green 	- 	|cff1eff00
-- blue 		- 	|cff0070dd
-- orange 	-	|cffa335ee
-- red		- 	|cffff8000
-----------------------------------------------------------

-- global update interval
FreierGeist_IT_UpdateInterval = 1.0;

-- variables which WILL NOT be saved at session end
local InstanceTime_ListVisibility = false;
local InstanceTime_OptionsVisibility = false;
local startTime = 0;
local stopTime = 0;
local my_startTime = "";
local timerHasStarted = false;
local instanceFinished = false;
local zoneName = "";
local mode = INSTANCETIME_INTERN_DUNGEON_MODE1;
local actualDate = "";
local playerHasControl = true;
local alreadyDoneThis = false;
local showButtons = false;
local addRepairCosts = false;
local repairCostsString = "";
local repairStartTime = 0;
local lastBossStartTime = 0;
local repairStopTime = 0;
local lastBossStopTime = 0;
local FreierGeist_IT_Debug = false;
local FreierGeist_IT_DebugCombat = false;
local FreierGeist_IT_Debug_Once = 0;
local selectedEntry = 0;
local lastSelectedEntry = 0;
local anEntryIsColoured = false;
local toggleFraction = false;
local scrollBarHeight = 1;
local classScrollBarHeight = 1;
local bossScrollBarHeight = 1;
local XP = 0;
local deaths = 0;
local justice_points = 0;
local valor_points = 0;
local justice_points_label;
local current_justice_points_amount;
local valor_points_label;
local current_valor_points_amount;
local reputation = {};
reputation[1] = 0;
reputation[2] = 0;
reputation[3] = 0;
local fraction = {};
fraction[1] = "-";
fraction[2] = "-";
fraction[3] = "-";
local channelNames = {};
local channelIndex = 0;
local gold = 0;
local silver = 0;
local copper = 0;
local gold_repair = 0;
local silver_repair = 0;
local copper_repair = 0;
local classes = "";
local bosslist = "";
local classesArray = {};
local bosslistArray = {};
local INSTANCETIME_CHAT_REALLY_DELETE_ENTRY_QUESTION_TEXT = "";
local sorted = {};
sorted["date"] = true;
sorted["start"] = false;
sorted["stop"] = false;
sorted["duration"] = false;
sorted["mode"] = false;
sorted["zone"] = false;
local markedIndexToMerge = {};
markedIndexToMerge[1] = 0;
markedIndexToMerge[2] = 0;
local all_gold = 0;
local all_silver = 0;
local all_copper = 0;
local all_gold_repair = 0;
local all_silver_repair = 0;
local all_copper_repair = 0;
local all_reputation = {};
all_reputation[1] = 0;
all_reputation[2] = 0;
all_reputation[3] = 0;
local all_fraction = {};
all_fraction[1] = "";
all_fraction[2] = "";
all_fraction[3] = "";
local all_xp = 0;
local all_zone = "";
local all_mode = "";
local instance_count = 0;
local _instance_count = 0;
local _postAllOfThisInstance = 0;
local NumberForItemLink = 0;
local rollCount = 0;
local sItemDisenchanted = "---";
local rollStatus = {};
local rollItem = {};
local rollplayer = {};

local unit = "---";
local race = "---";
local B;


-- to handle which entry was selected, even if list was scrolled
local tmp_EntryDate = "";
local tmp_EntryStart = "";
local tmp_EntryStop = "";
local tmp_EntryDuration = "";
local tmp_EntryMode = INSTANCETIME_INTERN_DUNGEON_MODE1;
local tmp_EntryZone = "";



-- variables which WILL be saved at session end
-- set this as first value (if some variables are not found in the saved file)
FreierGeist_IT_DataArraySize = 50;
FreierGeist_IT_DataOutput = {};
FreierGeist_IT_DataOutput[1] = "";
FreierGeist_IT_DataOutput[2] = "";
FreierGeist_IT_DataOutput[3] = "";
FreierGeist_IT_DataOutput[4] = "";
FreierGeist_IT_DataOutput[5] = "";
FreierGeist_IT_DataOutput[6] = "";
FreierGeist_IT_DataOutput[7] = "";
FreierGeist_IT_DataOutput[8] = "";
FreierGeist_IT_DataOutput[9] = "";
FreierGeist_IT_Exclude = {};
FreierGeist_IT_Exclude[1] = "";
FreierGeist_IT_Exclude[2] = "";
FreierGeist_IT_Exclude[3] = "";
FreierGeist_IT_Exclude[4] = "";
FreierGeist_IT_Exclude[5] = "";
FreierGeist_IT_Exclude[6] = "";
FreierGeist_IT_Exclude[7] = "";
FreierGeist_IT_Exclude[8] = "";
FreierGeist_IT_Exclude[9] = "";
FreierGeist_IT_Exclude[10] = "";
FreierGeist_IT_TextMessage = INSTANCETIME_OPTIONS_MESSAGE_TEXT;
FreierGeist_IT_DateFormat = INSTANCETIME_OPTIONS_DATE_FORMAT_MESSAGE_TEXT;
FreierGeist_IT_GlobalVisibility = true;
FreierGeist_IT_XPVisibility = true;
FreierGeist_IT_RepVisibility = true;
FreierGeist_IT_Config = {};
FreierGeist_IT_Config["FreierGeist_IT_TimerLocked"] = false;
FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"] = true;
FreierGeist_IT_Config["FreierGeist_IT_Reverse"] = false;
FreierGeist_IT_Config["FreierGeist_IT_FirstPull"] = false;
FreierGeist_IT_Config["FreierGeist_IT_FinalBossKill"] = false;
FreierGeist_IT_Config["FreierGeist_IT_ReverseButtons"] = true;
FreierGeist_IT_Config["FreierGeist_IT_XPOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_ReputationOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_MoneyOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_RepairOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_DeathsOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_XPInBar"] = true;
FreierGeist_IT_Config["FreierGeist_IT_ReputationInBar"] = true;
FreierGeist_IT_Config["FreierGeist_IT_MoneyInBar"] = true;
FreierGeist_IT_Config["FreierGeist_IT_ForceNewEntry"] = false;
FreierGeist_IT_Config["FreierGeist_IT_StandardClipboardOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_BosslistClipboardOutput"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveRaidInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveGroupInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveNormalRaidInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicRaidInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveNormalGroupInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicGroupInstances"] = true;
FreierGeist_IT_Config["FreierGeist_IT_ExcludeGreen"] = false;
FreierGeist_IT_Config["FreierGeist_IT_ExcludeBlue"] = false;
FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] = 1;
FreierGeist_IT_Config["FreierGeist_IT_StartTimeSaved"] = 0;
FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"] = 0;
FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"] = 30;	-- saved in minutes
FreierGeist_IT_Config["FreierGeist_IT_LeaveChannels"] = "";
FreierGeist_IT_Config["FreierGeist_IT_RepairUntil"] = 5;		-- saved in minutes
FreierGeist_IT_Data = {};
FreierGeist_IT_Loot = {};


-- add LDB support
local IT_dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("InstanceTime", {type = "data source", icon = "Interface\\Addons\\FreierGeist_InstanceTime\\icons\\icon_off", text = "|cffffffffInstanceTime|r"})



---------------------------------------
--  OnLoad for Blizz Interface frame --
---------------------------------------
function InstanceTime_IT_Panel_OnLoad()
	InstanceTime_Interface_Panel_Main.name = INSTANCETIME_INTERFACE_PANEL_GENERAL_TITLE;
	InterfaceOptions_AddCategory(InstanceTime_Interface_Panel_Main);

	InstanceTime_Interface_Panel_Options_And_Help.name = INSTANCETIME_INTERFACE_PANEL_OPTIONS_AND_HELP_TITLE;
	InstanceTime_Interface_Panel_Options_And_Help.parent = INSTANCETIME_INTERFACE_PANEL_GENERAL_TITLE;
	InterfaceOptions_AddCategory(InstanceTime_Interface_Panel_Options_And_Help);

	InstanceTime_Interface_Panel_SlashCommands.name = INSTANCETIME_INTERFACE_PANEL_SLASH_COMMANDS_TITLE;
	InstanceTime_Interface_Panel_SlashCommands.parent = INSTANCETIME_INTERFACE_PANEL_GENERAL_TITLE;
	InterfaceOptions_AddCategory(InstanceTime_Interface_Panel_SlashCommands);
	
	InstanceTime_Interface_Panel_Thanks.name = INSTANCETIME_INTERFACE_PANEL_THANKS_TITLE;
	InstanceTime_Interface_Panel_Thanks.parent = INSTANCETIME_INTERFACE_PANEL_GENERAL_TITLE;
	InterfaceOptions_AddCategory(InstanceTime_Interface_Panel_Thanks);
end


--------------------------------
--           OnLoad           --
--------------------------------
function FreierGeist_IT_OnLoad()
	-- prompt functions
	SLASH_InstanceTime1 = "/InstanceTime";
	SLASH_InstanceTime2 = "/instancetime";
	SLASH_InstanceTime3= "/it";
	SLASH_InstanceTime4= "/IT";
	SlashCmdList["InstanceTime"] = FreierGeist_IT_OnSlashCmd;
		
 	
 	-- info during startup
	if(DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200Freier Geist - InstanceTime "..INSTANCETIME_INFO_TEXT.."|r|ccceebbbb "..INSTANCETIME_LOADED_TEXT.."|r", 0.1, 0.8, 0.1);
	end


	-- register events
	InstanceTimeFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	InstanceTimeFrame:RegisterEvent("PLAYER_LEAVING_WORLD");
	InstanceTimeFrame:RegisterEvent("PLAYER_CONTROL_GAINED");
	InstanceTimeFrame:RegisterEvent("PLAYER_CONTROL_LOST");
	InstanceTimeFrame:RegisterEvent("PLAYER_UNGHOST");
	InstanceTimeFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
--	InstanceTimeFrame:RegisterEvent("ZONE_CHANGED_INDOORS");		-- obsolet
	InstanceTimeFrame:RegisterEvent("VARIABLES_LOADED");
	InstanceTimeFrame:RegisterEvent("ADDON_ACTION_BLOCKED");
	InstanceTimeFrame:RegisterEvent("ADDON_ACTION_FORBIDDEN");
	InstanceTimeFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
	InstanceTimeFrame:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
	InstanceTimeFrame:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	InstanceTimeFrame:RegisterEvent("CHAT_MSG_MONEY");
	InstanceTimeFrame:RegisterEvent("CHAT_MSG_LOOT");
	InstanceTimeFrame:RegisterEvent("MERCHANT_SHOW");
	InstanceTimeFrame:RegisterEvent("UPDATE_INVENTORY_DURABILITY");
	InstanceTimeFrame:RegisterEvent("PLAYER_DEAD");
	InstanceTimeFrame:RegisterEvent("LFG_COMPLETION_REWARD");		-- for checking, if instance is finished
	
	

	-- this is done in FreierGeist_IT_Start()
--	InstanceTimeFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
--	InstanceTimeFrame:RegisterEvent("CHAT_MSG_COMBAT_MISC_INFO");
-- InstanceTimeFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE");		-- for getting justice/valor points
end



--------------------------------------
--              OnEvent             --
--------------------------------------
function FreierGeist_IT_OnEvent(frame, event, ...)

	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19 = ...;

	if(event == "VARIABLES_LOADED") then
		-- init all
		FreierGeist_IT_Init();
		-- set textures
		FreierGeist_IT_SetTexture();
		
		-- at myself to blizzards interface
		InstanceTime_IT_Panel_OnLoad();
	end
	
	
	
	if(event == "PLAYER_REGEN_DISABLED") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("PLAYER_REGEN_DISABLED", 0.1, 0.8, 0.1);
		end
		
		InstanceTimeFrame:UnregisterEvent("PLAYER_REGEN_DISABLED");		-- for entering combat (will be enabled if entering an instance)
		FreierGeist_IT_Start();
	end
	
	
	if(event == "LFG_COMPLETION_REWARD") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("LFG_COMPLETION_REWARD", 0.1, 0.8, 0.1);
		end
		
		if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
			FreierGeist_IT_Stop();
		else
			StaticPopup_Show("END_INSTANCE");
		end
	end
	
	
	if(event == "PARTY_MEMBERS_CHANGED") then
		FreierGeist_IT_Event_PartyMembersChanged();
		
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("PARTY_MEMBERS_CHANGED", 0.1, 0.8, 0.1);
		end
	end
	
	
	if(event == "MERCHANT_SHOW") then
		-- set stop for repair interval
		repairStopTime = time();
		
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("MERCHANT_SHOW", 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage("repairStartTime: "..repairStartTime, 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage("repairStopTime: "..repairStopTime, 0.1, 0.8, 0.1);
		end


		-- only add the repair costs, if not more than 'FreierGeist_IT_Config["FreierGeist_IT_RepairUntil"]' minutes are elapsed after instance run
		if( ( (repairStopTime - repairStartTime) <= (FreierGeist_IT_Config["FreierGeist_IT_RepairUntil"]*60) ) or (timerHasStarted)) then
			local repair_costs, merchant_can_repair = GetRepairAllCost();
			if(merchant_can_repair) then
				addRepairCosts = true;
				repairCostsString = repair_costs;
			end
		end
	end
	
	
	if(event == "UPDATE_INVENTORY_DURABILITY") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("UPDATE_INVENTORY_DURABILITY", 0.1, 0.8, 0.1);
		end
		
		local repair_costs, merchant_can_repair = GetRepairAllCost();
		if( (addRepairCosts) and (repair_costs == 0) ) then
			FreierGeist_IT_AddRepairCosts(repairCostsString);
			repairCostsString = "";
			addRepairCosts = false;
		end
	end


	
	if(event == "PLAYER_DEAD") then
		-- tried to figure out deaths of other players
--		if(GetNumRaidMembers() > 0) then
--			for i=1, GetNumRaidMembers(), 1 do
--				if( (UnitIsConnected("raid"..i) == 1) and (UnitIsFeignDeath("raid"..i) == nil) and (UnitIsDeadOrGhost("raid"..i) == 1) ) then
--					playerName = UnitName("raid"..i);
--					deaths = deaths + 1;
--					
--					DEFAULT_CHAT_FRAME:AddMessage("Raid PLAYER_DEAD", 0.1, 0.8, 0.1);
--					DEFAULT_CHAT_FRAME:AddMessage("Deaths:"..deaths, 0.1, 0.8, 0.1);
--					DEFAULT_CHAT_FRAME:AddMessage("Unit:"..playerName, 0.1, 0.8, 0.1); 
--				end
--			end
--		elseif(GetNumPartyMembers() > 0) then 
--			for i=1, GetNumPartyMembers(), 1 do
--				if( (UnitIsConnected("party"..i) == 1) and (UnitIsFeignDeath("party"..i) == nil) and (UnitIsDeadOrGhost("party"..i) == 1) ) then
--					playerName = UnitName("party"..i);
--					deaths = deaths + 1;
--
--					DEFAULT_CHAT_FRAME:AddMessage("Party PLAYER_DEAD", 0.1, 0.8, 0.1);
--					DEFAULT_CHAT_FRAME:AddMessage("Deaths:"..deaths, 0.1, 0.8, 0.1);
--					DEFAULT_CHAT_FRAME:AddMessage("Unit:"..playerName, 0.1, 0.8, 0.1);
--				end
--			end
--		else
			if( (UnitIsConnected("player") == 1) and (UnitIsFeignDeath("player") == nil) and (UnitIsDeadOrGhost("player") == 1) ) then
				playerName = UnitName("player");
				deaths = deaths + 1;
				FreierGeist_IT_SetDeaths(deaths, mode, zone);
			end
--		end
	end
	
	
	if(event == "CHAT_MSG_MONEY") then
		-- set stop for last loot interval
		-- (needed if timer stops automatically when end boss was killed)
		lastBossStopTime = time();
	
		if(((lastBossStopTime - lastBossStartTime) <= 300) or (timerHasStarted)) then
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight-1; end
			FreierGeist_IT_Event_ChatMsgMoney(arg1);
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight+1; end
		
			if(FreierGeist_IT_Debug) then
				DEFAULT_CHAT_FRAME:AddMessage("CHAT_MSG_MONEY", 0.1, 0.8, 0.1);
			end
		end
	end
	
	
	
	if(event == "CHAT_MSG_LOOT") then
	-- LOOT_ROLL_ROLLED_GREED = "Wurf für Gier: %d für %s von %s"; -- First %s is item, second %s is player name
	-- LOOT_ROLL_ROLLED_NEED = "Wurf für Bedarf: %d für %s von %s"; -- First %s is item, second %s is player name
	-- LOOT_ROLL_ROLLED_GREED = "Greed Roll - %d for %s by %s"; -- First %s is item, second %s is player name
	-- LOOT_ROLL_ROLLED_NEED = "Need Roll - %d for %s by %s"; -- First %s is item, second %s is player name
	-- "Entzauberungswurf - %d für %s von %s";
	-- "Disenchant roll for partymember A: 52";
	
	
		local _, _, tmp_roll, tmp_item, tmp_player;
		local tmp_status;
			
		if(string.find(arg1, GREED) ~= nil) then
			if ( GetLocale() == "deDE" ) then
				_, _, tmp_roll, tmp_item, tmp_player = string.find(arg1, "Wurf f\195\188r Gier%: (%d+) f\195\188r (.+) von (.+)");
			else
				_, _, tmp_roll, tmp_item, tmp_player = string.find(arg1, "Greed Roll %- (%d+) for (.+) by (.+)");
			end
			tmp_status = GREED;
		elseif(string.find(arg1, NEED) ~= nil) then
			if ( GetLocale() == "deDE" ) then
				_, _, tmp_roll, tmp_item, tmp_player = string.find(arg1, "Wurf f\195\188r Bedarf%: (%d+) f\195\188r (.+) von (.+)");
			else
				_, _, tmp_roll, tmp_item, tmp_player = string.find(arg1, "Need Roll %- (%d+) for (.+) by (.+)");
			end
			tmp_status = NEED;
		elseif( (string.find(arg1, "Entzauberungswurf") ~= nil) or (string.find(arg1, "Disenchant roll") ~= nil) ) then
			if ( GetLocale() == "deDE" ) then
				_, _, tmp_roll, tmp_item, tmp_player = string.find(arg1, "Entzauberungswurf %- (%d+) f\195\188r (.+) von (.+)");
			else
				_, _, tmp_roll, tmp_item, tmp_player = string.find(arg1, "Disenchant roll for partymember (.+)%: (%d+)");
			end
			tmp_status = 'Disenchant';
		end
					
			
		if((tmp_roll ~= nil) and (tmp_item ~= nil) and (tmp_player ~= nil) and (tmp_status ~= nil)) then
			rollCount = rollCount + 1;
			rollStatus[rollCount] = tmp_status;
			rollItem[rollCount] = tmp_item;
			rollplayer[rollCount] = tmp_player;
			
			tmp_roll = nil;
			tmp_item = nil;
			tmp_player = nil;
			tmp_status = nil;
		end
		
		
		-- Greed roll for you: 75
		-- Disenchant roll for partymember A: 52
		-- Disenchant roll for partymember B: 16
		-- Disenchant roll for partymember C: 84
		-- Disenchant roll for partymember D: 3
		-- Partymember C wins the roll.
		-- Partymember C receives loot: [Abyss Crystal]
			
		-- bei "gewinnt"-Meldung pruefen, ob derjenige Entzaubern gewaehlt hat. falls ja, item speichern
		-- zum anhängen später in FreierGeist_IT_Event_ChatMsgLoot
		if(string.find(arg1, INSTANCETIME_PARSER_WON) ~= nil) then
			for i=1, rollCount, 1 do	
				-- filter the 'Item' string
				--	DEFAULT_CHAT_FRAME:AddMessage("tmp_Item 1 vorher: "..arg1);
				local tmp_Item = string.gsub(arg1, "([^%s]+) "..INSTANCETIME_PARSER_WON, "");
				tmp_Item = string.gsub(tmp_Item, "%:%s", "");			-- filter : mit Leerzeichen
				--	DEFAULT_CHAT_FRAME:AddMessage("tmp_Item 1 nachher: "..tmp_Item);
		
				if((string.find(arg1, rollplayer[i]) ~= nil) and (tmp_Item == rollItem[i]))then
					if(rollStatus[i] == "Disenchant") then
						sItemDisenchanted = tmp_Item;
					end
				end
			end
		end
		
		
	
	
		-- set stop for last loot interval
		-- (needed if timer stops automatically when end boss was killed)
		lastBossStopTime = time();
	
		if(((lastBossStopTime - lastBossStartTime) <= 300) or (timerHasStarted)) then
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight-1; end
			FreierGeist_IT_Event_ChatMsgLoot(arg1);
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight+1; end
			
			if(FreierGeist_IT_Debug) then
				DEFAULT_CHAT_FRAME:AddMessage("CHAT_MSG_LOOT", 0.1, 0.8, 0.1);
			end
		end
	end	
	
	
	if(event == "CHAT_MSG_COMBAT_MISC_INFO") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("CHAT_MSG_COMBAT_MISC_INFO", 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage(arg1, 0.1, 0.8, 0.1);
		end
		
		
		-- DURABILITYDAMAGE_DEATH in GlobalStrings = "Eure angelegten Gegenstände verlieren 10% Haltbarkeit."
		if(string.find(arg1, DURABILITYDAMAGE_DEATH) ~= nil) then
			died = died + 1;
			DEFAULT_CHAT_FRAME:AddMessage("Du bist "..died.." Mal gestorben.", 0.1, 0.8, 0.1);
			InstanceTime_ClassFrameTextDeath:SetText(INSTANCETIME_MAIN_DEATH.." |cff19dd87"..died.."|r");
			InstanceTime_LootFrameTextDeath:SetText(INSTANCETIME_MAIN_DEATH.." |cff19dd87"..died.."|r");
		end
	end
	
	
	if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
		if(FreierGeist_IT_DebugCombat) then
			if(arg1 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("-------------------------", 0.1, 0.8, 0.1); end
			if(arg1 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg1  "..arg1, 0.1, 0.8, 0.1); end
			if(arg2 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg2  "..arg2, 0.1, 0.8, 0.1); end
			if(arg3 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg3  "..arg3, 0.1, 0.8, 0.1); end
			if(arg4 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg4  "..arg4, 0.1, 0.8, 0.1); end
			if(arg5 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg5  "..arg5, 0.1, 0.8, 0.1); end
			if(arg6 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg6  "..arg6, 0.1, 0.8, 0.1); end
			if(arg7 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg7  "..arg7, 0.1, 0.8, 0.1); end
			if(arg8 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg8  "..arg8, 0.1, 0.8, 0.1); end
			if(arg9 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg9  "..arg9, 0.1, 0.8, 0.1); end
			if(arg10 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg10 "..arg10, 0.1, 0.8, 0.1); end
			if(arg11 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg11 "..arg11, 0.1, 0.8, 0.1); end
			if(arg12 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg12 "..arg12, 0.1, 0.8, 0.1); end
			if(arg13 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg13 "..arg13, 0.1, 0.8, 0.1); end
			if(arg14 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg14 "..arg14, 0.1, 0.8, 0.1); end
			if(arg15 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg15 "..arg15, 0.1, 0.8, 0.1); end
			if(arg16 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg16 "..arg16, 0.1, 0.8, 0.1); end
			if(arg17 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg17 "..arg17, 0.1, 0.8, 0.1); end
			if(arg18 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg18 "..arg18, 0.1, 0.8, 0.1); end
			if(arg19 ~= nil) then DEFAULT_CHAT_FRAME:AddMessage("arg19 "..arg19, 0.1, 0.8, 0.1); end
		end
			

		if(arg2 == "PARTY_KILL") or (arg2 == "UNIT_DIED") then
			unit = arg7;


			if (IsAddOnLoaded("LibBabble-Boss-3.0")) then
				local BR = B:GetReverseLookupTable();
			
				if(BR[unit] ~= nil) then
					if(FreierGeist_IT_Debug) then
						DEFAULT_CHAT_FRAME:AddMessage("BabbelBoss-UnitName found:"..BR[unit], 0.1, 0.8, 0.1);
						DEFAULT_CHAT_FRAME:AddMessage("BabbelBoss-UnitName found:"..unit, 0.1, 0.8, 0.1);
					end
					
					if(string.find(bosslist, unit) == nil) then

						-- to get the correct instance name
						-- eventually if not set, "GetInstanceInfo" messes up
						SetMapToCurrentZone();
				
						local ini_name, ini_type, ini_difficultyIndex, ini_difficultyName, ini_maxPlayers, ini_dynamicDifficulty, ini_isDynamic = GetInstanceInfo();
						
						-- get and correct instance name
						ini_name = FreierGeist_IT_CorrectZone(ini_name);
						
						
						--			raid
						--				=> difficultyIndex = 1, 2 => normal
						--				=> difficultyIndex = 3, 4 => heroic
						--			no raid == party
						--				=> difficultyIndex = 1 => normal
						--				=> difficultyIndex = 2 => heroic
						local tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
						if(ini_isDynamic) then
							if(ini_type == 'raid') then
								if((ini_difficultyIndex == 1) or (ini_difficultyIndex == 2)) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
								elseif((ini_difficultyIndex == 3) or (ini_difficultyIndex == 4)) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
								end
							elseif(ini_type == 'party') then
								if(ini_difficultyIndex == 1) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
								elseif(ini_difficultyIndex == 2) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
								end
							end
							
						-- seems to doesn't work anymore:
						--	if(ini_dynamicDifficulty == 0) then
						--		tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
						--	else
						--		tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
						--	end
						else
							if(ini_type == 'raid') then
								if((ini_difficultyIndex == 1) or (ini_difficultyIndex == 2)) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
								elseif((ini_difficultyIndex == 3) or (ini_difficultyIndex == 4)) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
								end
							elseif(ini_type == 'party') then
								if(ini_difficultyIndex == 1) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
								elseif(ini_difficultyIndex == 2) then
									tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
								end
							end
						end
				
				
						bosslist = bosslist.."\n".."("..tmp_difficulty..") ".."|cccff3232"..unit.."|r   |cccc8b4c6"..INSTANCETIME_MAIN_BOSS_KILLED_STRING.." "..SecondsToTime(time() - startTime).."  ("..date("%H:%M")..")|r";
					end
					
					if (FreierGeist_IT_Config["FreierGeist_IT_FinalBossKill"]) then
						if(InstanceTime_Endbosses[BR[unit]] == "true") then
							if(FreierGeist_IT_Debug) then
								DEFAULT_CHAT_FRAME:AddMessage("Endboss gefunden: Timer wird beendet.", 0.1, 0.8, 0.1);
							end
						
							if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
								FreierGeist_IT_Stop();
							else
								StaticPopup_Show("END_INSTANCE");
							end
						end
					end
				end
			else
				bosslist = "|cffffd200 In order to detect boss-kills you have to install LibBabble-Boss-3.0.|r";
			end
			
			FreierGeist_IT_SetBosslist(bosslist);
		end
	end


	if(event == "CHAT_MSG_COMBAT_FACTION_CHANGE") then
		-- set stop for last loot interval
		-- (needed if timer stops automatically when end boss was killed)
		lastBossStopTime = time();
		
		if(((lastBossStopTime - lastBossStartTime) <= 300) or (timerHasStarted)) then
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight-1; end
			FreierGeist_IT_Event_ChatMsgCombatFactionChange(arg1);
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight+1; end
		
			if(FreierGeist_IT_Debug) then
				DEFAULT_CHAT_FRAME:AddMessage("CHAT_MSG_COMBAT_FACTION_CHANGE", 0.1, 0.8, 0.1);
			end
		end
	end


	if(event == "CHAT_MSG_COMBAT_XP_GAIN") then
		-- set stop for last loot interval
		-- (needed if timer stops automatically when end boss was killed)
		lastBossStopTime = time();
		
		if(((lastBossStopTime - lastBossStartTime) <= 300) or (timerHasStarted)) then
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight-1; end
			FreierGeist_IT_Event_ChatMsgCombatXPGain(arg1);
			if(((lastBossStopTime - lastBossStartTime) <= 300) and (not timerHasStarted)) then scrollBarHeight = scrollBarHeight+1; end
			
			if(FreierGeist_IT_Debug) then
				DEFAULT_CHAT_FRAME:AddMessage("CHAT_MSG_COMBAT_XP_GAIN", 0.1, 0.8, 0.1);
			end
		end
	end
	

	if(event == "CURRENCY_DISPLAY_UPDATE") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("CURRENCY_DISPLAY_UPDATE", 0.1, 0.8, 0.1);
		end
		
		
		-- From: http://wowprogramming.com/docs/api/GetCurrencyInfo
		-- Returns information about a currency by ID. Note that nothing will be 
		-- returned if the currency is not known by the player (visible in the currency panel).
		-- 
		-- Signature:
		-- name, amount, texture, unknown, weeklyMax, totalMax = GetCurrencyInfo(id)
		-- 
		-- Arguments:
    	-- * id - A number representing a currencyId. The following currency values are known: (number)
      --     o 61 - Dalaran Jewelcrafting Token
      --     o 81 - Dalaran Cooking Award
      --     o 241 - Champion's Seal
      --     o 361 - Illustrious Jewelcrafter's Token
      --     o 390 - Conquest Points
      --     o 391 - Tol Barad Commendation
      --     o 392 - Honor Points
      --     o 395 - Justice Points
      --     o 396 - Valor Points
      --     o 402 - Chef's Award
          
		local new_justice_points_amount, new_valor_points_amount;
		justice_points_label, new_justice_points_amount = GetCurrencyInfo(395);
		valor_points_label, new_valor_points_amount = GetCurrencyInfo(396);
		
				
		if(new_justice_points_amount == nil) then
			new_justice_points_amount = 0;
		end
		if(new_valor_points_amount == nil) then
			new_valor_points_amount = 0;
		end
		
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("GetCurrencyInfo - justice points:"..new_justice_points_amount, 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage("GetCurrencyInfo - valor points:"..new_valor_points_amount, 0.1, 0.8, 0.1);
		end
		
		
		-- add the diff to justice/valor points
		justice_points = justice_points + (new_justice_points_amount - current_justice_points_amount);
		valor_points = valor_points + (new_valor_points_amount - current_valor_points_amount);
	end
	
	
	if(event == "PLAYER_CONTROL_LOST") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("PLAYER_CONTROL_LOST", 0.1, 0.8, 0.1);
		end
		playerHasControl = false;
	end


	if(event == "PLAYER_CONTROL_GAINED") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("PLAYER_CONTROL_GAINED", 0.1, 0.8, 0.1);
		end
		playerHasControl = true;
	end
	
	
	if(event == "PLAYER_LEAVING_WORLD") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("PLAYER_LEAVING_WORLD", 0.1, 0.8, 0.1);
		end

		if(timerHasStarted) then
			if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
				FreierGeist_IT_Stop();
			else
				StaticPopup_Show("END_INSTANCE");
			end
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_SAVED_TEXT);
		end
	end
	
	
	-- for handling upper and lower blackrock, UD and HU, etc
	-- obsolet
--	if(event == "ZONE_CHANGED_INDOORS") then
--		if(timerHasStarted) then
--			FreierGeist_IT_SetZone();
--		
--			if(FreierGeist_IT_Debug) then
--				DEFAULT_CHAT_FRAME:AddMessage("ZONE_CHANGED_INDOORS", 0.1, 0.8, 0.1);
--			end
--		end
--	end


	if(playerHasControl) then
		if( (event == "ZONE_CHANGED_NEW_AREA") or (event == "PLAYER_ENTERING_WORLD") ) then
			inInstance, instanceType = IsInInstance();
			if(FreierGeist_IT_Debug) then
				DEFAULT_CHAT_FRAME:AddMessage("ZONE_CHANGED_NEW_AREA", 0.1, 0.8, 0.1);
			end

			

			if( ((inInstance == 1) or (inInstance == true)) and not UnitIsDeadOrGhost("player") ) then
				if((not IsFlying()) 
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_DARKSHORE)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_SOUTHFURY)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_NORTH_SEA)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_GREAT_SEA)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_TRAM)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_HALL_OF_LEGENDS)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_HALL_OF_HEROES)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_ZONE_TEXT_HALL_OF_CHAMPIONS)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PLAGUELANDS)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_GHOSTLANDS)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PORTAL)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_REAL_ZONE_TEXT_IF)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_REAL_ZONE_TEXT_SW)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_REAL_ZONE_TEXT_DA)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_REAL_ZONE_TEXT_SA)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_REAL_ZONE_TEXT_UC)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_REAL_ZONE_TEXT_OG)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP1)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP2)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP3)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP4)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP5)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP6)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP7)
					and (GetRealZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP8)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP1)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP2)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP3)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP4)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP5)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP6)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP7)
					and (GetMinimapZoneText() ~= INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_PVP8) ) then

					if(FreierGeist_IT_Config["FreierGeist_IT_FirstPull"]) then
						InstanceTimeFrame:RegisterEvent("PLAYER_REGEN_DISABLED");		-- for entering combat (will be disabled if first time in combat)
					else
						FreierGeist_IT_Start();
					end
				end
			elseif( ((inInstance == 0) or (inInstance == false)) and not UnitIsDeadOrGhost("player") ) then
				if(GetMinimapZoneText() == INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_NORTH_SEA) then
					InstanceTimeFrameText:SetText("InstanceTime");
					InstanceTime_TellToFrame:Hide();
					InstanceTime_ListFrameButtonClassLoot:Hide();
					InstanceTime_ListFrameButtonClipboard:Hide();
					InstanceTime_ClipFrame:Hide();
					if(showButtons) then
						InstanceTime_MenuFrameButtonStartTimer:Show();
						InstanceTime_MenuFrameButtonStopTimer:Hide();
					end
					FreierGeist_IT_ResetStartTime();
					FreierGeist_IT_ResetStopTime();
				end
			
			
				if(timerHasStarted) then
					-- end volitional started timer
					if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
						FreierGeist_IT_Stop();
					else
						StaticPopup_Show("END_INSTANCE");
					end
					
					-- post data to channel (is set in the option dialogue)
					if( (event == "ZONE_CHANGED_NEW_AREA") and (instanceFinished) ) then
						-- set this to false for the next instance
						instanceFinished = false;
						
						if (FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == 1) then
							-- do nothing
						elseif (FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == 2) then
							FreierGeist_IT_Output("PARTY");
						elseif (FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == 3) then
							FreierGeist_IT_Output("RAID");
						elseif (FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == 4) then
							FreierGeist_IT_Output("GUILD");
						elseif (FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == 5) then
							FreierGeist_IT_Output("SELF");
						end
					end
				else
					-- end unmeant started timer
					InstanceTimeFrameText:SetText("InstanceTime");
					InstanceTime_TellToFrame:Hide();
					InstanceTime_ListFrameButtonClassLoot:Hide();
					InstanceTime_ListFrameButtonClipboard:Hide();
					InstanceTime_ClipFrame:Hide();
					if(showButtons) then
						InstanceTime_MenuFrameButtonStartTimer:Show();
						InstanceTime_MenuFrameButtonStopTimer:Hide();
					end
					FreierGeist_IT_ResetStartTime();
					FreierGeist_IT_ResetStopTime();
				end
			end
		end
	end


	if(event == "PLAYER_UNGHOST") then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("PLAYER_UNGHOST", 0.1, 0.8, 0.1);
		end

		SetMapToCurrentZone();
		local posX, posY = GetPlayerMapPosition("player");
		if(posX > 0 and posY > 0 and timerHasStarted) then
			-- end volitional started timer
			if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
				FreierGeist_IT_Stop();
			else
				StaticPopup_Show("END_INSTANCE");
			end
		end
	end
end


---------------------------------------
--       OnSlashCmd: global          --
---------------------------------------
function FreierGeist_IT_OnSlashCmd(msg)
	local _, _, command, args = string.find(msg, "(%w+)%s?(.*)");
	
	
	if(command) then
		command = strlower(command);
	end
	

	-- english version (should always work)
	-- clients language should work too
	if (command == "start") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_START) then
		FreierGeist_IT_Start();
	elseif (command == "stop") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_STOP) then
		FreierGeist_IT_Stop();
	elseif (command == "list") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_LIST) then
		FreierGeist_IT_ShowList();
	elseif (command == "options") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_OPTIONS) then
		FreierGeist_IT_ShowOptions();
	elseif (command == "rep") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_REPUTATION) then
		FreierGeist_IT_ShowRep();
	elseif (command == "xp") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_EXPERIENCE) then
		FreierGeist_IT_ShowXP();		
	elseif (command == "forceentry") or (command == INSTANCETIME_SLASH_COMMAND_LOCALIZED_FORCE_ENTRY) then
		FreierGeist_IT_SetCreateNewEntry();
	elseif (command == "debugon") then
		FreierGeist_IT_Debug = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime>  |r|ccceebbbbDebug on.|r");
	elseif (command == "debugoff") then
		FreierGeist_IT_Debug = false;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime>  |r|ccceebbbbDebug off.|r");
	elseif (command == "debugcombaton") then
		FreierGeist_IT_DebugCombat = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime>  |r|ccceebbbbCombat-Debug on.|r");
	elseif (command == "debugcombatoff") then
		FreierGeist_IT_DebugCombat = false;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime>  |r|ccceebbbbCombat-Debug off.|r");
	elseif (command == nil) then
		FreierGeist_IT_ShowTimer();
	else
		FreierGeist_IT_Help();
	end
end


------------------------------
--         Init             --
------------------------------
function FreierGeist_IT_Init()
	local line = 1;
	
	
	if (IsAddOnLoaded("LibBabble-Boss-3.0")) then
		B = LibStub("LibBabble-Boss-3.0");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r|ccceebbbb In order to detect boss-kills you have to install LibBabbel-Boss-3.0.|r");
	end
	
		
	-- set init text
	InstanceTimeFrameText:SetText("InstanceTime");

	if (FreierGeist_IT_DataArraySize == nil) then
		FreierGeist_IT_DataArraySize = 50;
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"] == nil) then
		FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"] = 30;
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_LeaveChannels"] == nil) then
		FreierGeist_IT_Config["FreierGeist_IT_LeaveChannels"] = "";
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_RepairUntil"] == nil) then
		FreierGeist_IT_Config["FreierGeist_IT_RepairUntil"] = 5;
	end

	-- init list
	FreierGeist_IT_InitList(FreierGeist_IT_DataArraySize);
	
	-- show/hide timer-dialog
	if (FreierGeist_IT_GlobalVisibility) then
		InstanceTimeFrame:Show();
	else
		InstanceTimeFrame:Hide();
	end	
	
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		InstanceTimeOptionsFrameReverseList:SetChecked(true);
	else
		InstanceTimeOptionsFrameReverseList:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_FirstPull"]) then
		InstanceTimeOptionsFrameFirstPull:SetChecked(true);
	else
		InstanceTimeOptionsFrameFirstPull:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_FinalBossKill"]) then
		InstanceTimeOptionsFrameFinalBossKill:SetChecked(true);
	else
		InstanceTimeOptionsFrameFinalBossKill:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_ReverseButtons"]) then
		InstanceTimeOptionsFrameReverseButtonPosition:SetChecked(true);
	else
		InstanceTimeOptionsFrameReverseButtonPosition:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_StandardClipboardOutput"]) then
		InstanceTimeOptionsFrameStandardClipboardOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameStandardClipboardOutput:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"]) then
		InstanceTimeOptionsFrameGrouplistClipboardOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameGrouplistClipboardOutput:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"]) then
		InstanceTimeOptionsFrameLootlistClipboardOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameLootlistClipboardOutput:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_BosslistClipboardOutput"]) then
		InstanceTimeOptionsFrameBosslistClipboardOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameBosslistClipboardOutput:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"]) then
		InstanceTimeOptionsFrameSaveDynamicInstances:SetChecked(true);
	else
		InstanceTimeOptionsFrameSaveDynamicInstances:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveRaidInstances"]) then
		InstanceTimeOptionsFrameSaveNormalRaidInstances:Enable();
		InstanceTimeOptionsFrameSaveHeroicRaidInstances:Enable();
		InstanceTimeOptionsFrameSaveRaidInstances:SetChecked(true);
	else
		InstanceTimeOptionsFrameSaveRaidInstances:SetChecked(false);
		InstanceTimeOptionsFrameSaveNormalRaidInstances:Disable();
		InstanceTimeOptionsFrameSaveHeroicRaidInstances:Disable();
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveGroupInstances"]) then
		InstanceTimeOptionsFrameSaveGroupInstances:SetChecked(true);
		InstanceTimeOptionsFrameSaveNormalGroupInstances:Enable();
		InstanceTimeOptionsFrameSaveHeroicGroupInstances:Enable();
	else
		InstanceTimeOptionsFrameSaveGroupInstances:SetChecked(false);
		InstanceTimeOptionsFrameSaveNormalGroupInstances:Disable();
		InstanceTimeOptionsFrameSaveHeroicGroupInstances:Disable();
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveNormalRaidInstances"]) then
		InstanceTimeOptionsFrameSaveNormalRaidInstances:SetChecked(true);
	else
		InstanceTimeOptionsFrameSaveNormalRaidInstances:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicRaidInstances"]) then
		InstanceTimeOptionsFrameSaveHeroicRaidInstances:SetChecked(true);
	else
		InstanceTimeOptionsFrameSaveHeroicRaidInstances:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveNormalGroupInstances"]) then
		InstanceTimeOptionsFrameSaveNormalGroupInstances:SetChecked(true);
		
	else
		InstanceTimeOptionsFrameSaveNormalGroupInstances:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicGroupInstances"]) then
		InstanceTimeOptionsFrameSaveHeroicGroupInstances:SetChecked(true);
	else
		InstanceTimeOptionsFrameSaveHeroicGroupInstances:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_ExcludeGreen"]) then
		InstanceTimeOptionsFrameExcludeGreen:SetChecked(true);
	else
		InstanceTimeOptionsFrameExcludeGreen:SetChecked(false);
	end
	
	if (FreierGeist_IT_Config["FreierGeist_IT_ExcludeBlue"]) then
		InstanceTimeOptionsFrameExcludeBlue:SetChecked(true);
	else
		InstanceTimeOptionsFrameExcludeBlue:SetChecked(false);
	end
	
	
	-- show/hide XP-dialog
	if (FreierGeist_IT_XPVisibility) then
		InstanceTime_TimerFrameXP:ClearAllPoints();
		if(InstanceTime_TimerFrameRep:IsVisible()) then
			InstanceTime_TimerFrameXP:SetPoint("TOPLEFT", "InstanceTime_TimerFrameRep", 0, -22);
		else
			InstanceTime_TimerFrameXP:SetPoint("TOPLEFT", "InstanceTimeFrame", 0, -22);
		end
		InstanceTime_TimerFrameXP:Show();
		InstanceTimeOptionsFrameShowXP:SetChecked(true);
	else
		InstanceTime_TimerFrameXP:Hide();
		InstanceTimeOptionsFrameShowXP:SetChecked(false);
	end
	
	-- show/hide Rep-dialog
	if (FreierGeist_IT_RepVisibility) then
		InstanceTime_TimerFrameRep:ClearAllPoints();
		if(InstanceTime_TimerFrameXP:IsVisible()) then
			InstanceTime_TimerFrameRep:SetPoint("TOPLEFT", "InstanceTime_TimerFrameXP", 0, -22);
		else
			InstanceTime_TimerFrameRep:SetPoint("TOPLEFT", "InstanceTimeFrame", 0, -22);
		end
		InstanceTime_TimerFrameRep:Show();
		InstanceTimeOptionsFrameShowReputation:SetChecked(true);
	else
		InstanceTime_TimerFrameRep:Hide();
		InstanceTimeOptionsFrameShowReputation:SetChecked(false);
	end
	
	-- in list: display the first rep/fraction
	InstanceTime_ListFrameTextReputation1:Hide();
	InstanceTime_ListFrameTextReputation3:Hide();
	InstanceTime_ListFrameTextReputation2:Show();
	FreierGeist_IT_ToggleReputationFraction();
	
	-- check/uncheck 'automatically manage timer'
	if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
		InstanceTimeOptionsFrameManageTimerAutomatically:SetChecked(true);
	else
		InstanceTimeOptionsFrameManageTimerAutomatically:SetChecked(false);
	end
	
	-- check/uncheck 'XP output'
	if (FreierGeist_IT_Config["FreierGeist_IT_XPOutput"]) then
		InstanceTimeOptionsFrameXPOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameXPOutput:SetChecked(false);
	end
	
	-- check/uncheck 'reputation output'
	if (FreierGeist_IT_Config["FreierGeist_IT_ReputationOutput"]) then
		InstanceTimeOptionsFrameReputationOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameReputationOutput:SetChecked(false);
	end
	
	-- check/uncheck 'money output'
	if (FreierGeist_IT_Config["FreierGeist_IT_MoneyOutput"]) then
		InstanceTimeOptionsFrameMoneyOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameMoneyOutput:SetChecked(false);
	end
	
	-- check/uncheck 'repair output'
	if (FreierGeist_IT_Config["FreierGeist_IT_RepairOutput"]) then
		InstanceTimeOptionsFrameRepairOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameRepairOutput:SetChecked(false);
	end
	
	-- check/uncheck 'deaths output'
	if (FreierGeist_IT_Config["FreierGeist_IT_DeathsOutput"]) then
		InstanceTimeOptionsFrameDeathsOutput:SetChecked(true);
	else
		InstanceTimeOptionsFrameDeathsOutput:SetChecked(false);
	end
	
	
	-- check/uncheck 'XP in bar'
	if (FreierGeist_IT_Config["FreierGeist_IT_XPInBar"]) then
		InstanceTimeOptionsFrameShowXPInBar:SetChecked(true);
	else
		InstanceTimeOptionsFrameShowXPInBar:SetChecked(false);
	end
	
	-- check/uncheck 'Reputation in bar'
	if (FreierGeist_IT_Config["FreierGeist_IT_ReputationInBar"]) then
		InstanceTimeOptionsFrameShowReputationInBar:SetChecked(true);
	else
		InstanceTimeOptionsFrameShowReputationInBar:SetChecked(false);
	end
	
	-- check/uncheck 'Money in bar'
	if (FreierGeist_IT_Config["FreierGeist_IT_MoneyInBar"]) then
		InstanceTimeOptionsFrameShowMoneyInBar:SetChecked(true);
	else
		InstanceTimeOptionsFrameShowMoneyInBar:SetChecked(false);
	end
	
	-- check/uncheck 'force new entry'
	if (FreierGeist_IT_Config["FreierGeist_IT_ForceNewEntry"]) then
		InstanceTimeOptionsFrameForceNewEntry:SetChecked(true);
	else
		InstanceTimeOptionsFrameForceNewEntry:SetChecked(false);
	end
	
	
	if((FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == nil) or (FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] == 0)) then
		FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] = 1;
	end
		

	-- lock/unlock saved from last session
	InstanceTimeFrame.isLocked = FreierGeist_IT_Config["FreierGeist_IT_TimerLocked"];
	if(not FreierGeist_IT_Config["FreierGeist_IT_TimerLocked"]) then
		InstanceTime_MenuFrame:Hide();
		FreierGeist_IT_ShowButtons();
		FreierGeist_IT_TimerLocked = false
	end




		
	-- get the scrollBarHeight (for sizing the scrollbar-list)
	while (FreierGeist_IT_Data[scrollBarHeight]["date"] ~= "" and scrollBarHeight < FreierGeist_IT_DataArraySize) do
		scrollBarHeight = scrollBarHeight+1;
	end
	
	
	-- to correct old versions
	for i=1, FreierGeist_IT_DataArraySize, 1 do
		if(FreierGeist_IT_Data[i]["mode"] == nil) then
			FreierGeist_IT_Data[i]["mode"] = INSTANCETIME_INTERN_DUNGEON_MODE1;
		end
		
		if(FreierGeist_IT_Data[i]["classes"] == nil) then
			FreierGeist_IT_Data[i]["classes"] = "";
		end
		
		if(FreierGeist_IT_Data[i]["bosslist"] == nil) then
			FreierGeist_IT_Data[i]["bosslist"] = "";
		end
	end

	race = UnitRace("player");
	FreierGeist_IT_SetDefaults();
end


---------------------------------------------------------------
--                      Init the list                        --
---------------------------------------------------------------
function FreierGeist_IT_InitList(_FreierGeist_IT_DataArraySize)
	local mytype;
	-- alt:  FreierGeist_IT_DataArraySize = 150;
	-- neu:  _FreierGeist_IT_DataArraySize = 50
	-- angenommen: ersten 50 behalten
	-- set all but the first entries to nil
	for i=_FreierGeist_IT_DataArraySize, FreierGeist_IT_DataArraySize, 1 do
		FreierGeist_IT_Data[i] = nil;
	end

	for i=1, _FreierGeist_IT_DataArraySize, 1 do
		if(FreierGeist_IT_Data[i] == nil) then
			FreierGeist_IT_Data[i] = {};
			FreierGeist_IT_Data[i]["date"] = "";
			FreierGeist_IT_Data[i]["start"] = "";
			FreierGeist_IT_Data[i]["stop"] = "";
			FreierGeist_IT_Data[i]["starttime"] = 0;
			FreierGeist_IT_Data[i]["stoptime"] = 0;
			FreierGeist_IT_Data[i]["zone"] = "";
			FreierGeist_IT_Data[i]["mode"] = INSTANCETIME_INTERN_DUNGEON_MODE1;
			FreierGeist_IT_Data[i]["XP"] = 0;
			FreierGeist_IT_Data[i]["deaths"] = 0;
			FreierGeist_IT_Data[i]["justice_points"] = 0;
			FreierGeist_IT_Data[i]["valor_points"] = 0;
			FreierGeist_IT_Data[i]["reputation"] = {};
			FreierGeist_IT_Data[i]["reputation"][1] = 0;
			FreierGeist_IT_Data[i]["reputation"][2] = 0;
			FreierGeist_IT_Data[i]["reputation"][3] = 0;
			FreierGeist_IT_Data[i]["fraction"] = {};
			FreierGeist_IT_Data[i]["fraction"][1] = "-";
			FreierGeist_IT_Data[i]["fraction"][2] = "-";
			FreierGeist_IT_Data[i]["fraction"][3] = "-";
			FreierGeist_IT_Data[i]["gold"] = 0;
			FreierGeist_IT_Data[i]["silver"] = 0;
			FreierGeist_IT_Data[i]["copper"] = 0;
			FreierGeist_IT_Data[i]["gold_repair"] = 0;
			FreierGeist_IT_Data[i]["silver_repair"] = 0;
			FreierGeist_IT_Data[i]["copper_repair"] = 0;
			FreierGeist_IT_Data[i]["classes"] = "";
			FreierGeist_IT_Data[i]["bosslist"] = "";
		end
			
		
		
		-- table   or   string
		mytype = type(FreierGeist_IT_Data[i]["fraction"]); 
		
		
		-- correct change from version 3.2 to 3.21
		if(string.find(mytype, "string") ~= nil) then
			if(FreierGeist_IT_Data[i]["fraction"][3] == nil) then
				FreierGeist_IT_Data[i]["fraction"][3] = "-";
			end
			if(FreierGeist_IT_Data[i]["reputation"][3] == nil) then
				FreierGeist_IT_Data[i]["reputation"][3] = "-";
			end
		end
		
		
		-- correct change from version 2.3 to 3.x
		if(string.find(mytype, "string") ~= nil) then
			local tmp_fraction = "-";
			local tmp_reputation = 0;
			
			if(FreierGeist_IT_Data[i]["fraction"] ~= nil) then
				tmp_fraction = FreierGeist_IT_Data[i]["fraction"];
			end
			if(FreierGeist_IT_Data[i]["reputation"] ~= nil) then
				tmp_reputation = FreierGeist_IT_Data[i]["reputation"];
			end

			FreierGeist_IT_Data[i]["fraction"] = nil;
			FreierGeist_IT_Data[i]["fraction"] = {};
			FreierGeist_IT_Data[i]["fraction"][1] = tmp_fraction;
			FreierGeist_IT_Data[i]["fraction"][2] = "-";
			FreierGeist_IT_Data[i]["fraction"][3] = "-";
			FreierGeist_IT_Data[i]["reputation"] = nil;
			FreierGeist_IT_Data[i]["reputation"] = {};
			FreierGeist_IT_Data[i]["reputation"][1] = tmp_reputation;
			FreierGeist_IT_Data[i]["reputation"][2] = 0;
			FreierGeist_IT_Data[i]["reputation"][3] = 0;
		end
		
		-- correct change from version 2.0.x to 3.x
		mytype = type(FreierGeist_IT_Data[i]["starttime"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["starttime"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["stoptime"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["stoptime"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["gold"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["gold"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["silver"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["silver"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["copper"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["copper"] = 0;
		end
		
		mytype = type(FreierGeist_IT_Data[i]["gold_repair"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["gold_repair"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["silver_repair"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["silver_repair"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["copper_repair"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["copper_repair"] = 0;
		end
		
		mytype = type(FreierGeist_IT_Data[i]["fraction"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["fraction"] = {};
			FreierGeist_IT_Data[i]["fraction"][1] = "-";
			FreierGeist_IT_Data[i]["fraction"][2] = "-";
			FreierGeist_IT_Data[i]["fraction"][3] = "-";
		end
		mytype = type(FreierGeist_IT_Data[i]["reputation"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["reputation"] = {};
			FreierGeist_IT_Data[i]["reputation"][1] = 0;
			FreierGeist_IT_Data[i]["reputation"][2] = 0;
			FreierGeist_IT_Data[i]["reputation"][3] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["mode"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["mode"] = INSTANCETIME_INTERN_DUNGEON_MODE1;
		end
		mytype = type(FreierGeist_IT_Data[i]["XP"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["XP"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["deaths"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["deaths"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["justice_points"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["justice_points"] = 0;
		end
		mytype = type(FreierGeist_IT_Data[i]["valor_points"]);
		if(mytype == "nil") then
			FreierGeist_IT_Data[i]["valor_points"] = 0;
		end
		
		
		if(FreierGeist_IT_Data[i]["classes"] == nil) then
			FreierGeist_IT_Data[i]["classes"] = "";
		end
		if(FreierGeist_IT_Data[i]["bosslist"] == nil) then
			FreierGeist_IT_Data[i]["bosslist"] = "";
		end
		
		

		
		-- correct entries which doesn't have starttime and/or stoptime
		if((FreierGeist_IT_Data[i]["starttime"] == 0) or (FreierGeist_IT_Data[i]["stoptime"] == 0)) then
			if((FreierGeist_IT_Data[i]["start"] ~= "") and (FreierGeist_IT_Data[i]["stop"] ~= "")) then
				local tmp_start_hour = string.sub(FreierGeist_IT_Data[i]["start"], 1, 2);
				local tmp_start_min = string.sub(FreierGeist_IT_Data[i]["start"], 4, 5);		
				local tmp_stop_hour = string.sub(FreierGeist_IT_Data[i]["stop"], 1, 2);
				local tmp_stop_min = string.sub(FreierGeist_IT_Data[i]["stop"], 4, 5);
				local tmptest_start;
				local tmptest_stop;
				
				
				-- if hour and min from start and stop are the same: assume that there are at least 5 second difference
				if(tmp_start_hour == tmp_stop_hour) then
					if(tmp_start_min == tmp_stop_min) then
						tmptest_start = time({year=2000, month=1, day=1, hour=tmp_start_hour, min=tmp_start_min, sec=1});
						tmptest_stop = time({year=2000, month=1, day=1, hour=tmp_stop_hour, min=tmp_stop_min, sec=6});
					else
						tmptest_start = time({year=2000, month=1, day=1, hour=tmp_start_hour, min=tmp_start_min});
						tmptest_stop = time({year=2000, month=1, day=1, hour=tmp_stop_hour, min=tmp_stop_min});
					end
				elseif(tmp_start_hour < tmp_stop_hour) then
					tmptest_start = time({year=2000, month=1, day=1, hour=tmp_start_hour, min=tmp_start_min});
					tmptest_stop = time({year=2000, month=1, day=1, hour=tmp_stop_hour, min=tmp_stop_min});
				else
					tmptest_start = time({year=2000, month=1, day=1, hour=tmp_start_hour, min=tmp_start_min});
					tmptest_stop = time({year=2000, month=1, day=2, hour=tmp_stop_hour, min=tmp_stop_min});
				end
	
				FreierGeist_IT_Data[i]["starttime"] = tmptest_start;
				FreierGeist_IT_Data[i]["stoptime"] = tmptest_stop;
			end
		end
		
		
		-- correct change from version 3.4.x to 3.5+
		-- delete this, 'cos it isn't needed any more
		FreierGeist_IT_Data[i]["duration"] = nil;
		
				
		mytype = type(FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"]);
		if(mytype == "nil") then
			FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"] = true;
		end
	end
end


------------------------------------
--          SetTexture            --
------------------------------------
function FreierGeist_IT_SetTexture()
	FreierGeist_IT_NormalTex(InstanceTime_MenuFrameButtonStartTimer, 0.2, 0.2, 0.2, 0.5);
	FreierGeist_IT_PushedTex(InstanceTime_MenuFrameButtonStartTimer, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_MenuFrameButtonStartTimer, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTime_MenuFrameButtonStartTimer, 0.5, 0.5, 0.5, 0.4);
	
	FreierGeist_IT_NormalTex(InstanceTime_MenuFrameButtonStopTimer, 0.2, 0.2, 0.2, 0.5);
	FreierGeist_IT_PushedTex(InstanceTime_MenuFrameButtonStopTimer, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_MenuFrameButtonStopTimer, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTime_MenuFrameButtonStopTimer, 0.5, 0.5, 0.5, 0.4);
	
	FreierGeist_IT_NormalTex(InstanceTime_MenuFrameButtonOptions, 0.2, 0.2, 0.2, 0.5);
	FreierGeist_IT_PushedTex(InstanceTime_MenuFrameButtonOptions, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_MenuFrameButtonOptions, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTime_MenuFrameButtonOptions, 0.5, 0.5, 0.5, 0.4);
	
	FreierGeist_IT_NormalTex(InstanceTime_MenuFrameButtonList, 0.2, 0.2, 0.2, 0.5);
	FreierGeist_IT_PushedTex(InstanceTime_MenuFrameButtonList, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_MenuFrameButtonList, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTime_MenuFrameButtonList, 0.5, 0.5, 0.5, 0.4);
	
	FreierGeist_IT_NormalTex(InstanceTime_MenuFrameButtonHelp, 0.2, 0.2, 0.2, 0.5);
	FreierGeist_IT_PushedTex(InstanceTime_MenuFrameButtonHelp, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_MenuFrameButtonHelp, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTime_MenuFrameButtonHelp, 0.5, 0.5, 0.5, 0.4);
	
	FreierGeist_IT_NormalTex(InstanceTime_MenuFrameButtonCloseDialogue, 0.2, 0.2, 0.2, 0.5);
	FreierGeist_IT_PushedTex(InstanceTime_MenuFrameButtonCloseDialogue, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_MenuFrameButtonCloseDialogue, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTime_MenuFrameButtonCloseDialogue, 0.5, 0.5, 0.5, 0.4);
	


	FreierGeist_IT_NormalTex(InstanceTimeFrameButtonMainDialogue, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTimeFrameButtonMainDialogue, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_DisabledTex(InstanceTimeFrameButtonMainDialogue, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_HighlightTex(InstanceTimeFrameButtonMainDialogue, 0.5, 0.5, 0.5, 0.0);

	FreierGeist_IT_NormalTex(InstanceTime_TellToFrameButtonSelbst, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_TellToFrameButtonSelbst, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_TellToFrameButtonSelbst, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_TellToFrameButtonSelbst, 0.5, 0.5, 0.5, 0.3);

	FreierGeist_IT_NormalTex(InstanceTime_TellToFrameButtonGruppe, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_TellToFrameButtonGruppe, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_TellToFrameButtonGruppe, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_TellToFrameButtonGruppe, 0.5, 0.5, 0.5, 0.3);
		
	FreierGeist_IT_NormalTex(InstanceTime_TellToFrameButtonRaid, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_TellToFrameButtonRaid, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_TellToFrameButtonRaid, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_TellToFrameButtonRaid, 0.5, 0.5, 0.5, 0.3);
		
	FreierGeist_IT_NormalTex(InstanceTime_TellToFrameButtonGuild, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_TellToFrameButtonGuild, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_TellToFrameButtonGuild, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_TellToFrameButtonGuild, 0.5, 0.5, 0.5, 0.3);
		
	FreierGeist_IT_NormalTex(InstanceTime_TellToFrameButtonWhisper, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_TellToFrameButtonWhisper, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_TellToFrameButtonWhisper, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_TellToFrameButtonWhisper, 0.5, 0.5, 0.5, 0.3);

	FreierGeist_IT_NormalTex(InstanceTime_ListFrameButtonDeleteList, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_ListFrameButtonDeleteList, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_ListFrameButtonDeleteList, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_ListFrameButtonDeleteList, 0.5, 0.5, 0.5, 0.3);
	
	FreierGeist_IT_NormalTex(InstanceTime_ListFrameButtonShowHelp, 0.5, 0.5, 0.5, 0.0);
	FreierGeist_IT_PushedTex(InstanceTime_ListFrameButtonShowHelp, 0.5, 0.5, 0.5, 0.5);
	FreierGeist_IT_DisabledTex(InstanceTime_ListFrameButtonShowHelp, 0.5, 0.5, 0.5, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_ListFrameButtonShowHelp, 0.5, 0.5, 0.5, 0.3);


	FreierGeist_IT_NormalTex(InstanceTime_ListFrameButtonClassLoot, 0.52, 0.33, 0.2, 1.0);
	FreierGeist_IT_PushedTex(InstanceTime_ListFrameButtonClassLoot, 0.4, 0.2, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTime_ListFrameButtonClassLoot, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_ListFrameButtonClassLoot, 0.5, 0.5, 0.0, 0.5);
	
	FreierGeist_IT_NormalTex(InstanceTime_ListFrameButtonClipboard, 0.52, 0.33, 0.2, 1.0);
	FreierGeist_IT_PushedTex(InstanceTime_ListFrameButtonClipboard, 0.4, 0.2, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTime_ListFrameButtonClipboard, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_ListFrameButtonClipboard, 0.5, 0.5, 0.0, 0.5);
		
	FreierGeist_IT_NormalTex(InstanceTime_ListFrameButtonTellActual, 0.52, 0.33, 0.2, 1.0);
	FreierGeist_IT_PushedTex(InstanceTime_ListFrameButtonTellActual, 0.4, 0.2, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTime_ListFrameButtonTellActual, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_ListFrameButtonTellActual, 0.5, 0.5, 0.0, 0.5);
	
	FreierGeist_IT_NormalTex(InstanceTime_ListFrameButtonTellAll, 0.52, 0.33, 0.2, 1.0);
	FreierGeist_IT_PushedTex(InstanceTime_ListFrameButtonTellAll, 0.4, 0.2, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTime_ListFrameButtonTellAll, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTime_ListFrameButtonTellAll, 0.5, 0.5, 0.0, 0.5);

	FreierGeist_IT_NormalTex(InstanceTimeTitle1Button, 0.8, 0.6, 0.0, 1.0);
	FreierGeist_IT_PushedTex(InstanceTimeTitle1Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTimeTitle1Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTimeTitle1Button, 0.5, 0.5, 0.0, 0.5);
		
	FreierGeist_IT_NormalTex(InstanceTimeTitle2Button, 0.8, 0.6, 0.0, 1.0);
	FreierGeist_IT_PushedTex(InstanceTimeTitle2Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTimeTitle2Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTimeTitle2Button, 0.5, 0.5, 0.0, 0.5);

	FreierGeist_IT_NormalTex(InstanceTimeTitle3Button, 0.8, 0.6, 0.0, 1.0);
	FreierGeist_IT_PushedTex(InstanceTimeTitle3Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTimeTitle3Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTimeTitle3Button, 0.5, 0.5, 0.0, 0.5);
		
	FreierGeist_IT_NormalTex(InstanceTimeTitle4Button, 0.8, 0.6, 0.0, 1.0);
	FreierGeist_IT_PushedTex(InstanceTimeTitle4Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTimeTitle4Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTimeTitle4Button, 0.5, 0.5, 0.0, 0.5);
	
	FreierGeist_IT_NormalTex(InstanceTimeTitle5Button, 0.8, 0.6, 0.0, 1.0);
	FreierGeist_IT_PushedTex(InstanceTimeTitle5Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTimeTitle5Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTimeTitle5Button, 0.5, 0.5, 0.0, 0.5);
	
	FreierGeist_IT_NormalTex(InstanceTimeTitle6Button, 0.8, 0.6, 0.0, 1.0);
	FreierGeist_IT_PushedTex(InstanceTimeTitle6Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_DisabledTex(InstanceTimeTitle6Button, 0.7, 0.7, 0.0, 1.0);
	FreierGeist_IT_HighlightTex(InstanceTimeTitle6Button, 0.5, 0.5, 0.0, 0.5);
end



------------------------------------------
--    set the normal button texture     --
------------------------------------------
function FreierGeist_IT_NormalTex(_button, _arg1, _arg2, _arg3, _arg4)
	local texture = _button:CreateTexture();
	texture:SetHeight(_button:GetHeight());
	texture:SetWidth(_button:GetWidth());
	texture:SetAllPoints(_button);
	texture:SetTexture(_arg1, _arg2, _arg3, _arg4);
	_button:SetNormalTexture(texture);
end


------------------------------------------
--    set the pushed button texture     --
------------------------------------------
function FreierGeist_IT_PushedTex(_button, _arg1, _arg2, _arg3, _arg4)
	local texture = _button:CreateTexture();
	texture:SetHeight(_button:GetHeight());
	texture:SetWidth(_button:GetWidth());
	texture:SetAllPoints(_button);
	texture:SetTexture(_arg1, _arg2, _arg3, _arg4);
	_button:SetPushedTexture(texture);
end


--------------------------------------------
--    set the disabled button texture     --
--------------------------------------------
function FreierGeist_IT_DisabledTex(_button, _arg1, _arg2, _arg3, _arg4)
	local texture = _button:CreateTexture();
	texture:SetHeight(_button:GetHeight());
	texture:SetWidth(_button:GetWidth());
	texture:SetAllPoints(_button);
	texture:SetTexture(_arg1, _arg2, _arg3, _arg4);
	_button:SetDisabledTexture(texture);
end


---------------------------------------------
--     set the highlight button texture    --
---------------------------------------------
function FreierGeist_IT_HighlightTex(_button, _arg1, _arg2, _arg3, _arg4)
	local texture = _button:CreateTexture();
	texture:SetHeight(_button:GetHeight());
	texture:SetWidth(_button:GetWidth());
	texture:SetAllPoints(_button);
	texture:SetTexture(_arg1, _arg2, _arg3, _arg4); 
	_button:SetHighlightTexture(texture);
end


-------------------------------
--      start the timer      --
-------------------------------
function FreierGeist_IT_Start()
	local startIT = true;



	-- reset rollCount and set sItemDisenchanted to default
	rollCount = 0;
	sItemDisenchanted = "---";



	-- Get the start amount for justice/valor points
	justice_points_label, current_justice_points_amount = GetCurrencyInfo(395);
	valor_points_label, current_valor_points_amount = GetCurrencyInfo(396);
	
	if(current_justice_points_amount == nil) then
		current_justice_points_amount = 0;
	end
	if(current_valor_points_amount == nil) then
		current_valor_points_amount = 0;
	end
	
	if(FreierGeist_IT_Debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Justice:"..justice_points_label.." - "..current_justice_points_amount, 0.1, 0.8, 0.1);
		DEFAULT_CHAT_FRAME:AddMessage("Valor:"..valor_points_label.." - "..current_valor_points_amount, 0.1, 0.8, 0.1);
	end


	-- leave all specified channels
	FreierGeist_IT_LeaveTheseChannels();

	-- to get the correct instance name
	-- eventually if not set, "GetInstanceInfo" messes up
	SetMapToCurrentZone();

	-- get the instance difficulty and type
	local ini_name, ini_type, ini_difficultyIndex, ini_difficultyName, ini_maxPlayers, ini_dynamicDifficulty, ini_isDynamic = GetInstanceInfo();
	
	-- get and correct instance name
	ini_name = FreierGeist_IT_CorrectZone(ini_name);	
	
	
	-- Eventually player doesn't want InstanceTime to record.
	-- if in raid
	if(ini_type == 'raid') then
		if(ini_isDynamic) then
			if(not FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"]) then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_DYNAMIC_TEXT);
				startIT = false;
			end
		else
			if(not FreierGeist_IT_Config["FreierGeist_IT_SaveRaidInstances"]) then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_RAID_TEXT);
				startIT = false;
			elseif(((ini_difficultyIndex == 1) or (ini_difficultyIndex == 2)) and (not FreierGeist_IT_Config["FreierGeist_IT_SaveNormalRaidInstances"])) then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_NORMAL_RAID_TEXT);
				startIT = false;
			elseif(((ini_difficultyIndex == 3) or (ini_difficultyIndex == 4)) and (not FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicRaidInstances"])) then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_HEROIC_RAID_TEXT);
				startIT = false;	
			end
		end
	end
	
	
	-- if not in raid
	if(ini_type == 'party') then
		if(not FreierGeist_IT_Config["FreierGeist_IT_SaveGroupInstances"]) then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_GROUP_TEXT);
			startIT = false;
		elseif((ini_difficultyIndex == 1) and (not FreierGeist_IT_Config["FreierGeist_IT_SaveNormalGroupInstances"])) then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_NORMAL_GROUP_TEXT);
			startIT = false;
		elseif((ini_difficultyIndex == 2) and (not FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicGroupInstances"])) then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_NOT_STARTED_HEROIC_GROUP_TEXT);
			startIT = false;
		end
	end
	
	
	
	if((startTime == 0) and (startIT)) then
		timerHasStarted = true;
		
		-- register COMBAT_LOG_EVENT_UNFILTERED
		InstanceTimeFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		
		-- register CHAT_MSG_COMBAT_MISC_INFO
		InstanceTimeFrame:RegisterEvent("CHAT_MSG_COMBAT_MISC_INFO");
		
		-- register CURRENCY_DISPLAY_UPDATE
		InstanceTimeFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE");		-- for getting justice/valor points
		
		
		-- LDB support 
		IT_dataobj.icon = "Interface\\Addons\\FreierGeist_InstanceTime\\icons\\icon_on";

		
		-- get date information
		actualDate = date("%d.%m.%y");
		
		-- get time information
		startTime = time();
		my_startTime = date("%H:%M");
		
		
		-- set global variables to default
		XP = 0;
		reputation[1] = 0;
		reputation[2] = 0;
		reputation[3] = 0;
		fraction[1] = "-";
		fraction[2] = "-";
		fraction[3] = "-";
		gold = 0;
		silver = 0;
		copper = 0;
		gold_repair = 0;
		silver_repair = 0;
		copper_repair = 0;
		deaths = 0;
		justice_points = 0;
		valor_points = 0;
		zoneName = "";
		
		if(showButtons) then
			InstanceTime_MenuFrameButtonStartTimer:Hide();
			InstanceTime_MenuFrameButtonStopTimer:Show();
		end
		
		
		-- set the classes to default
		classes = "";
		
		-- set the bosslist to default
		bosslist = "";
		
		-- get the party/raid members
		FreierGeist_IT_Event_PartyMembersChanged();

		FreierGeist_IT_AdditionalInfo(2);
		FreierGeist_IT_SetDefaults();
		FreierGeist_IT_ResetStopTime();
		
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_STARTED_TEXT);
	end
end


------------------------------
--      stop the timer      --
------------------------------
function FreierGeist_IT_Stop()
	if(startTime > 0 ) then
		-- get time information
		stopTime = time();
		local my_stopTime = date("%H:%M");
		local duration = SecondsToTime(stopTime - startTime);
		
		-- unregister COMBAT_LOG_EVENT_UNFILTERED
		InstanceTimeFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		
		-- unregister CHAT_MSG_COMBAT_MISC_INFO
		InstanceTimeFrame:UnregisterEvent("CHAT_MSG_COMBAT_MISC_INFO");
		
		-- unregister CURRENCY_DISPLAY_UPDATE
		InstanceTimeFrame:UnregisterEvent("CURRENCY_DISPLAY_UPDATE");		-- for getting justice/valor points
		

		-- set start for repair interval
		repairStartTime = time();
		
		-- set start for last loot interval
		-- (needed if timer stops automatically when end boss was killed)
		lastBossStartTime = time();
		
		
		-- join all previously left channels
		FreierGeist_IT_JoinTheseChannels();
		
		
		
		-- LDB support 
		IT_dataobj.icon = "Interface\\Addons\\FreierGeist_InstanceTime\\icons\\icon_off";
		IT_dataobj.text = "|cccffffffInstanceTime|r";
		
		
		if(showButtons) then
			InstanceTime_MenuFrameButtonStartTimer:Show();
			InstanceTime_MenuFrameButtonStopTimer:Hide();
		end


		-- only add this to the list, if the duration is more than 3 minutes
		if((stopTime - startTime) > 180) then
			-- add infos to list
			FreierGeist_IT_AddToList(my_startTime, my_stopTime);
		end

		
		-- we have a new entry, so save also the "startTime" and "stopTime"
		-- this is eventually used to continue an instance-run (see: FreierGeist_IT_OnUpdate())
		-- save the last startTime / stopTime for use in FreierGeist_IT_OnUpdate()
		FreierGeist_IT_Config["FreierGeist_IT_StartTimeSaved"] = startTime;
		FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"] = stopTime;
		
		
		-- reset the values; set defaults
		InstanceTimeFrameText:SetText("InstanceTime");
		FreierGeist_IT_ResetStartTime();
		FreierGeist_IT_ResetStopTime();
		timerHasStarted = false;
		FreierGeist_IT_SetDefaults();
		FreierGeist_IT_AdditionalInfo(1);
		
		-- set this for next start (used in OnUpdate())
		alreadyDoneThis = false;
		
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_STOPPED_TEXT);
		-- use this for posting to channel (only once and right after we finished an instance)
		instanceFinished = true;
		
		
		-- only add this to the list, if the duration is more than 3 minutes
		if((stopTime - startTime) > 180) then
			-- set this to fill the variables for automatically post to channel
			if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
				selectedEntry = 1;
			else
				selectedEntry = scrollBarHeight-1;
			end
			FreierGeist_IT_EntryClicked("LeftButton");
			FreierGeist_IT_ButtonTellActualClicked();
		end

		
		-- reset debug_once
		FreierGeist_IT_Debug_Once = 0;
		
		
		-- reset the variables for posting to channel
		FreierGeist_IT_SetDefaults();
		FreierGeist_IT_AdditionalInfo(1);
	end
end


-----------------------------------------------
--             update the timer              --
-----------------------------------------------
function FreierGeist_IT_OnUpdate(self, elapsed)
	local XPText = "";
	local reputationText = "";
	local moneyText = "";


	-- run this only every second and not every frame
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	if (self.TimeSinceLastUpdate > FreierGeist_IT_UpdateInterval) then	
		if(startTime > 0 and startTime ~= nil) then
			local tempTime = time();
			local duration = SecondsToTime(tempTime - startTime);
			InstanceTimeFrameText:SetText(duration);
			
			-- LDB support
			if (FreierGeist_IT_Config["FreierGeist_IT_XPInBar"]) then
				XPText = "   |cffffd200"..InstanceTime_TimerFrameXPTextXP:GetText().."|r |cccffffff"..InstanceTime_TimerFrameXPTextXPData:GetText().."|r";
			end
			
			if (FreierGeist_IT_Config["FreierGeist_IT_ReputationInBar"]) then
				reputationText = "   |cffffd200"..InstanceTime_TimerFrameRepTextReputation1:GetText().."|r |cccffffff"..InstanceTime_TimerFrameRepTextReputation1Data:GetText().."|r";
			end
			
			if (FreierGeist_IT_Config["FreierGeist_IT_MoneyInBar"]) then
				local tmptext = InstanceTime_ListFrameTextMoney:GetText();
				local tmptext_g = string.gsub(tmptext, INSTANCETIME_MAIN_MONEY_GOLD, "|cffffd200"..INSTANCETIME_MAIN_MONEY_GOLD_SHORT.."|r");
				local tmptext_s = string.gsub(tmptext_g, INSTANCETIME_MAIN_MONEY_SILVER, INSTANCETIME_MAIN_MONEY_SILVER_SHORT);
				local tmptext_c = string.gsub(tmptext_s, INSTANCETIME_MAIN_MONEY_COPPER, INSTANCETIME_MAIN_MONEY_COPPER_SHORT);
				moneyText = tmptext_c;
			end
	
			-- display this
			IT_dataobj.text = "|cffffffff"..duration.."|r"..XPText..reputationText..moneyText;
			
	
			if(tempTime - startTime < 6) then
				InstanceTime_ListFrameButtonClassLoot:Show();
				InstanceTime_ListFrameButtonClipboard:Show();
					
	
				-- for starting the timer outside an instance / default value
				ini_maxPlayers = 1;
		
				
				-- to get the correct instance name
				-- eventually if not set, "GetInstanceInfo" messes up
				SetMapToCurrentZone();
		
				-- get instance info
				local ini_name, ini_type, ini_difficultyIndex, ini_difficultyName, ini_maxPlayers, ini_dynamicDifficulty, ini_isDynamic = GetInstanceInfo();
				
				-- get and correct instance name
				zoneName = FreierGeist_IT_CorrectZone(ini_name);
	
				
				-- get the instance difficulty
				-- (Not solved using ini_difficultyName, because I didn't get "25 Players (heroic)",
				-- always got "5 Players, 10 Players, 25 Players", whether or not this was an heroic instance)
				-- Also in some raid instances "ini_difficultyName" was empty. No string "40 Player" or "15 Player" (UBRS/LBRS).
				-- mode = ini_difficultyName;
				-- so: set the string myself
				mode = ini_maxPlayers..' '..INSTANCETIME_INTERN_DUNGEON_PLAYERS;
	
	
				-- 	dynamic   
			   -- 		=> dynamic
				--		not dynamic
				--			raid
				--				=> difficultyIndex = 1, 2 => normal
				--				=> difficultyIndex = 3, 4 => heroic
				--			no raid == party
				--				=> difficultyIndex = 1 => normal
				--				=> difficultyIndex = 2 => heroic
				local tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
				if(ini_isDynamic) then
					tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE3;
				else
					if(ini_type == 'raid') then
						if((ini_difficultyIndex == 1) or (ini_difficultyIndex == 2)) then
							tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
						elseif((ini_difficultyIndex == 3) or (ini_difficultyIndex == 4)) then
							tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
						end
					elseif(ini_type == 'party') then
						if(ini_difficultyIndex == 1) then
							tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE1;
						elseif(ini_difficultyIndex == 2) then
							tmp_difficulty = INSTANCETIME_INTERN_DUNGEON_MODE2;
						end
					end
				end
				
				
				-- add difficulty
				mode = mode..' ('..tmp_difficulty..')';
	
		
				if(FreierGeist_IT_Debug_Once == 0) then
					if(FreierGeist_IT_Debug) then
						DEFAULT_CHAT_FRAME:AddMessage("ini_name: "..ini_name, 0.1, 0.8, 0.1);
						DEFAULT_CHAT_FRAME:AddMessage("ini_type: "..ini_type, 0.1, 0.8, 0.1);
						DEFAULT_CHAT_FRAME:AddMessage("ini_difficultyIndex: "..ini_difficultyIndex, 0.1, 0.8, 0.1);
						DEFAULT_CHAT_FRAME:AddMessage("InstanceDifficultyName: "..mode, 0.1, 0.8, 0.1);
						DEFAULT_CHAT_FRAME:AddMessage("ini_maxPlayers: "..ini_maxPlayers, 0.1, 0.8, 0.1);
						DEFAULT_CHAT_FRAME:AddMessage("ini_dynamicDifficulty: "..ini_dynamicDifficulty, 0.1, 0.8, 0.1);
						if(ini_isDynamic) then
							DEFAULT_CHAT_FRAME:AddMessage("ini_isDynamic: yes", 0.1, 0.8, 0.1);
						else
							DEFAULT_CHAT_FRAME:AddMessage("ini_isDynamic: no", 0.1, 0.8, 0.1);
						end
						FreierGeist_IT_Debug_Once = 1;
					end
				end
				
				
				InstanceTime_ListFrameButtonTellActual:Show();
				InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_ACTUAL_TIMER);
				InstanceTime_ListFrameButtonTellAll:Show();
				InstanceTime_ListFrameButtonTellAll:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_SUMMARY);
					
				if((scrollBarHeight-1 > 0)
					and (FreierGeist_IT_Config["FreierGeist_IT_StartTimeSaved"] ~= nil)
					and (FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"] ~= nil)
					and (FreierGeist_IT_Config["FreierGeist_IT_ForceNewEntry"] == false)) then
					if( (FreierGeist_IT_Data[scrollBarHeight-1]["zone"] == zoneName) 
						and (FreierGeist_IT_Data[scrollBarHeight-1]["mode"] == mode)
						and ((startTime - FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"]) <= (FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"]*60)) ) then

--					if( (startTime - FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"]) <= (FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"]*60) ) then
						
											
						-- Fall: Zeit zw der Instanzbetretungen wird mitgewertet
						-- set "old" startTime and my_startTime
						startTime = FreierGeist_IT_Config["FreierGeist_IT_StartTimeSaved"];
						my_startTime = FreierGeist_IT_Data[scrollBarHeight-1]["start"];
							
						-- re-set XP, reputation, faction, money, deaths and justice/valor-points
						FreierGeist_IT_SetXP(FreierGeist_IT_Data[scrollBarHeight-1]["XP"], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetReputationFraction(FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][1], FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][2], FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][3], FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][1], FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][2], FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][3], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetReputationFraction(0, 0, 0, FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][1], FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][2], FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][3], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetMoney(FreierGeist_IT_Data[scrollBarHeight-1]["gold"], FreierGeist_IT_Data[scrollBarHeight-1]["silver"], FreierGeist_IT_Data[scrollBarHeight-1]["copper"], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetMoneyRepair(FreierGeist_IT_Data[scrollBarHeight-1]["gold_repair"], FreierGeist_IT_Data[scrollBarHeight-1]["silver_repair"], FreierGeist_IT_Data[scrollBarHeight-1]["copper_repair"], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetDeaths(FreierGeist_IT_Data[scrollBarHeight-1]["deaths"], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetJusticePoints(FreierGeist_IT_Data[scrollBarHeight-1]["justice_points"], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
						FreierGeist_IT_SetValorPoints(FreierGeist_IT_Data[scrollBarHeight-1]["valor_points"], FreierGeist_IT_Data[scrollBarHeight-1]["mode"], FreierGeist_IT_Data[scrollBarHeight-1]["zone"]);
							
						-- set global variables to last values
						XP = FreierGeist_IT_Data[scrollBarHeight-1]["XP"];
						deaths = FreierGeist_IT_Data[scrollBarHeight-1]["deaths"];
						justice_points = FreierGeist_IT_Data[scrollBarHeight-1]["justice_points"];
						valor_points = FreierGeist_IT_Data[scrollBarHeight-1]["valor_points"];
						reputation[1] = FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][1];
						reputation[2] = FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][2];
						reputation[3] = FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][3];
						fraction[1] = FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][1];
						fraction[2] = FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][2];
						fraction[3] = FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][3];
						gold = FreierGeist_IT_Data[scrollBarHeight-1]["gold"];
						silver = FreierGeist_IT_Data[scrollBarHeight-1]["silver"];
						copper = FreierGeist_IT_Data[scrollBarHeight-1]["copper"];
						gold_repair = FreierGeist_IT_Data[scrollBarHeight-1]["gold_repair"];
						silver_repair = FreierGeist_IT_Data[scrollBarHeight-1]["silver_repair"];
						copper_repair = FreierGeist_IT_Data[scrollBarHeight-1]["copper_repair"];
						classes = FreierGeist_IT_Data[scrollBarHeight-1]["classes"];
						bosslist = FreierGeist_IT_Data[scrollBarHeight-1]["bosslist"];
							
						-- delete last entry from list
						FreierGeist_IT_Data[scrollBarHeight-1]["date"] = "";
						FreierGeist_IT_Data[scrollBarHeight-1]["start"] = "";
						FreierGeist_IT_Data[scrollBarHeight-1]["stop"] = "";
						FreierGeist_IT_Data[scrollBarHeight-1]["starttime"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["stoptime"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["zone"] = "";
						FreierGeist_IT_Data[scrollBarHeight-1]["mode"] = INSTANCETIME_INTERN_DUNGEON_MODE1;
						FreierGeist_IT_Data[scrollBarHeight-1]["XP"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["deaths"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["justice_points"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["valor_points"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][1] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][2] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["reputation"][3] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][1] = "-";
						FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][2] = "-";
						FreierGeist_IT_Data[scrollBarHeight-1]["fraction"][3] = "-";
						FreierGeist_IT_Data[scrollBarHeight-1]["gold"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["silver"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["copper"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["gold_repair"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["silver_repair"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["copper_repair"] = 0;
						FreierGeist_IT_Data[scrollBarHeight-1]["classes"] = "";
						FreierGeist_IT_Data[scrollBarHeight-1]["bosslist"] = "";
							
						-- decrease the number of entries (for sizing the scrollbar-list)
						scrollBarHeight = scrollBarHeight-1;
						-- refresh the list
						FreierGeist_IT_ScrollBarUpdate();
						FreierGeist_IT_LootScrollBarUpdate();
		
						DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_CONTINUE_TEXT);
					else			-- fuer Test ACHTUNG
					-- startTime ausgeben ? evtl ist das null, wenn update vor start aufgerufen wird  wann / wie wird update aufgerufen ?
					--		=> ist nicht der Fall
						
					--	DEFAULT_CHAT_FRAME:AddMessage(FreierGeist_IT_Data[scrollBarHeight-1]["zone"].."-"..FreierGeist_IT_Data[scrollBarHeight-1]["mode"].."-", 0.1, 0.8, 0.1);
					--	DEFAULT_CHAT_FRAME:AddMessage(zoneName.."-"..mode.."-", 0.1, 0.8, 0.1);
					--	DEFAULT_CHAT_FRAME:AddMessage("---", 0.1, 0.8, 0.1);
						
-- sind die Ausgaben unterschiedlich, dann evtl zoneName = "" setzen bei SPeicherung des Timers (da, wo starttimesaved/stoptimesaved)
-- und dann hier nicht solange < 6 sondern, bis zoneName einmal ermittelt wurde
-- => sollte ermittelt sein, bevor der char einen teleporter nutzt, so dass der Minimaptext evtl aussagekraeftig ist
						
						
--						DEFAULT_CHAT_FRAME:AddMessage("last_stoptime:"..FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"], 0.1, 0.8, 0.1);
--						DEFAULT_CHAT_FRAME:AddMessage("startTime:"..startTime, 0.1, 0.8, 0.1);

					end
				end
			end
			
			
			-- only set this output if no entry is selected
			if (anEntryIsColoured == false) then	
				-- set strings to display (other than set through: FreierGeist_IT_SetDataOutput(), because of FreierGeist_IT_DataOutput[1])
				FreierGeist_IT_DataOutput[1] = FreierGeist_IT_TextMessage;
				if ((zoneName ~= nil) and (mode ~= nil) and (duration ~= nil)) then
					FreierGeist_IT_DataOutput[2] = zoneName.."  ("..mode..")"..":  "..duration;
				end
				if(XP ~= nil) then
					FreierGeist_IT_DataOutput[3] = INSTANCETIME_MAIN_XP_GAINED..XP;
				end
				if((reputation[1] ~= nil) and (fraction[1] ~= nil)) then
					if((race == INSTANCETIME_MAIN_STRING_HUMAN) and	(reputation[1] > 0)) then
						FreierGeist_IT_DataOutput[4] = reputation[1].." ("..fraction[1]..") ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((reputation[1]/(1.1))+0.5)..")";
					else
						FreierGeist_IT_DataOutput[4] = reputation[1].." ("..fraction[1]..") ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((reputation[1]*(1.1))+0.5)..")";
					end
				end
				if((reputation[2] ~= nil) and (fraction[2] ~= nil)) then
					if(fraction[2] ~= "-") then
						if((race == INSTANCETIME_MAIN_STRING_HUMAN) and	(reputation[2] > 0)) then
							FreierGeist_IT_DataOutput[5] = reputation[2].." ("..fraction[2]..") ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((reputation[2]/(1.1))+0.5)..")";
						else
							FreierGeist_IT_DataOutput[5] = reputation[2].." ("..fraction[2]..") ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((reputation[2]*(1.1))+0.5)..")";
						end
					else
						FreierGeist_IT_DataOutput[5] = "";
					end
				end
				if((reputation[3] ~= nil) and (fraction[3] ~= nil)) then
					if(fraction[3] ~= "-") then
						if((race == INSTANCETIME_MAIN_STRING_HUMAN) and	(reputation[3] > 0)) then
							FreierGeist_IT_DataOutput[6] = reputation[3].." ("..fraction[3]..") ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((reputation[3]/(1.1))+0.5)..")";
						else
							FreierGeist_IT_DataOutput[6] = reputation[3].." ("..fraction[3]..") ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((reputation[3]*(1.1))+0.5)..")";
						end
					else
						FreierGeist_IT_DataOutput[6] = "";
					end
				end
				if((gold ~= nil) and (silver ~= nil) and (copper ~= nil)) then
					FreierGeist_IT_DataOutput[7] = INSTANCETIME_MAIN_MONEY_GAINED..gold.." "..INSTANCETIME_MAIN_MONEY_GOLD..", "..silver.." "..INSTANCETIME_MAIN_MONEY_SILVER..", "..copper.." "..INSTANCETIME_MAIN_MONEY_COPPER;
				end
				if((gold_repair ~= nil) and (silver_repair ~= nil) and (copper_repair ~= nil)) then
					FreierGeist_IT_DataOutput[8] = INSTANCETIME_MAIN_MONEY_REPAIRED..gold_repair.." "..INSTANCETIME_MAIN_MONEY_GOLD..", "..silver_repair.." "..INSTANCETIME_MAIN_MONEY_SILVER..", "..copper_repair.." "..INSTANCETIME_MAIN_MONEY_COPPER;
				end
				if(deaths ~= nil) then
					FreierGeist_IT_DataOutput[9] = INSTANCETIME_MAIN_DEATHS..deaths;
				end
			end
			
			-- fubar extention
			if(InstanceTimeFu) then
				InstanceTimeFu:OnTextUpdate();
			end
		end
	
		self.TimeSinceLastUpdate = 0;
	end
end


-------------------------------------
--        set some defaults        --
-------------------------------------
function FreierGeist_IT_SetDefaults()
	anEntryIsColoured = false;
	lastSelectedEntry = 0;
	
	-- set XP and reputation, faction and money to default
	FreierGeist_IT_SetReputationFraction(0, 0, 0, "-", "-", "-", "", "");
	FreierGeist_IT_SetXP(0, "", "");
	FreierGeist_IT_SetMoney(0, 0, 0, "", "");
	FreierGeist_IT_SetMoneyRepair(0, 0, 0, "", "", "", "");
	FreierGeist_IT_SetDataOutput("", "", "", "", "", "", "", 0, 0, 0, "", "", "", 0, 0, 0, 0, 0, 0, 0);
	FreierGeist_IT_SetDeaths(0, "", "");
	FreierGeist_IT_SetJusticePoints(0, "", "");
	FreierGeist_IT_SetValorPoints(0, "", "");
	
	-- hide the buttons
	InstanceTime_TellToFrame:Hide();
	InstanceTime_ListFrameButtonTellActual:Hide();
	InstanceTime_ListFrameButtonTellAll:Hide();
	InstanceTime_ListFrameTextHintText:SetText(INSTANCETIME_MAIN_DISPLAY_HINT);
	
	-- refresh the list
	FreierGeist_IT_ScrollBarUpdate();
end


----------------------------------------
--    show / hide additional info     --
----------------------------------------
function FreierGeist_IT_AdditionalInfo(_info)
	if(_info == 1) then
		InstanceTime_ListFrameTextMoneyText:Hide();
		InstanceTime_ListFrameTextMoneyTextAll:Hide();
		InstanceTime_ListFrameTextMoney:Hide();
		InstanceTime_ListFrameTextMoneyAll:Hide();
		InstanceTime_ListFrameTextMoneyRepairText:Hide();
		InstanceTime_ListFrameTextMoneyRepairTextAll:Hide();
		InstanceTime_ListFrameTextMoneyRepair:Hide();
		InstanceTime_ListFrameTextMoneyRepairAll:Hide();
		InstanceTime_ListFrameTextXPText:Hide();
		InstanceTime_ListFrameTextXPTextAll:Hide();
		InstanceTime_ListFrameTextXP:Hide();
		InstanceTime_ListFrameTextXPAll:Hide();
		InstanceTime_ListFrameTextJusticePointsText:Hide();
		InstanceTime_ListFrameTextJusticePointsTextAll:Hide();
		InstanceTime_ListFrameTextJusticePoints:Hide();
		InstanceTime_ListFrameTextJusticePointsAll:Hide();
		InstanceTime_ListFrameTextValorPointsText:Hide();
		InstanceTime_ListFrameTextValorPointsTextAll:Hide();
		InstanceTime_ListFrameTextValorPoints:Hide();
		InstanceTime_ListFrameTextValorPointsAll:Hide();	
		InstanceTime_ListFrameTextReputationText:Hide();
		InstanceTime_ListFrameTextReputationTextAll:Hide();
		InstanceTime_ListFrameTextReputation1:Hide();
		InstanceTime_ListFrameTextReputation1All:Hide();
		InstanceTime_ListFrameTextFractionText:Hide();
		InstanceTime_ListFrameTextFraction1:Hide();
		InstanceTime_ListFrameTextDeathsText:Hide();
		InstanceTime_ListFrameTextDeaths:Hide();
		InstanceTime_ListFrameTextDeathsTextAll:Hide();
		InstanceTime_ListFrameTextDeathsAll:Hide();
		InstanceTime_ListFrame:SetHeight(235);
		InstanceTimeMiddleBar2:Hide();
		InstanceTime_ListFrameButtonClassLoot:Hide();
		InstanceTime_ListFrameButtonClipboard:Hide();
		InstanceTime_ClipFrame:Hide();
		InstanceTime_ClassFrame:Hide();
		InstanceTime_LootFrame:Hide();
		InstanceTime_BosskillFrame:Hide();
		InstanceTime_ListFrameTextHintText:Show();
		InstanceTime_ListFrameTextInstanceInfo:Hide();
		InstanceTime_ListFrameTextInstanceInfoAll:Hide();
	else
		InstanceTime_ListFrameTextMoneyText:Show();
		InstanceTime_ListFrameTextMoneyTextAll:Show();
		InstanceTime_ListFrameTextMoney:Show();
		InstanceTime_ListFrameTextMoneyAll:Show();
		InstanceTime_ListFrameTextMoneyRepairText:Show();
		InstanceTime_ListFrameTextMoneyRepairTextAll:Show();
		InstanceTime_ListFrameTextMoneyRepair:Show();
		InstanceTime_ListFrameTextMoneyRepairAll:Show();
		InstanceTime_ListFrameTextXPText:Show();
		InstanceTime_ListFrameTextXPTextAll:Show();
		InstanceTime_ListFrameTextXP:Show();
		InstanceTime_ListFrameTextXPAll:Show();
		InstanceTime_ListFrameTextJusticePointsText:Show();
		InstanceTime_ListFrameTextJusticePointsTextAll:Show();
		InstanceTime_ListFrameTextJusticePoints:Show();
		InstanceTime_ListFrameTextJusticePointsAll:Show();
		InstanceTime_ListFrameTextValorPointsText:Show();
		InstanceTime_ListFrameTextValorPointsTextAll:Show();
		InstanceTime_ListFrameTextValorPoints:Show();
		InstanceTime_ListFrameTextValorPointsAll:Show();
		InstanceTime_ListFrameTextReputationText:Show();
		InstanceTime_ListFrameTextReputationTextAll:Show();
		InstanceTime_ListFrameTextReputation1:Show();
		InstanceTime_ListFrameTextReputation1All:Show();
		InstanceTime_ListFrameTextFractionText:Show();
		InstanceTime_ListFrameTextFraction1:Show();
		InstanceTime_ListFrameTextDeathsText:Show();
		InstanceTime_ListFrameTextDeaths:Show();
		InstanceTime_ListFrameTextDeathsTextAll:Show();
		InstanceTime_ListFrameTextDeathsAll:Show();
		InstanceTime_ListFrame:SetHeight(400);
		InstanceTimeMiddleBar2:Show();
		InstanceTime_ListFrameButtonClassLoot:Show();
		InstanceTime_ListFrameButtonClipboard:Show();
		InstanceTime_ListFrameTextHintText:Hide();
		InstanceTime_ListFrameTextInstanceInfo:Show();
		InstanceTime_ListFrameTextInstanceInfoAll:Show();
	end
end


-----------------------------------
--      show/hide the timer      --
-----------------------------------
function FreierGeist_IT_ShowTimer()
	if (FreierGeist_IT_GlobalVisibility) then
		InstanceTimeFrame:Hide();
		FreierGeist_IT_GlobalVisibility = false;
	else
		InstanceTimeFrame:Show();
		FreierGeist_IT_GlobalVisibility = true;
	end
	
	FreierGeist_IT_SetDefaults();
end


----------------------------------
--         show/hide XP         --
----------------------------------
function FreierGeist_IT_ShowXP()
	InstanceTime_TimerFrameXP:ClearAllPoints();
	InstanceTime_TimerFrameRep:ClearAllPoints();
		
	if(InstanceTime_TimerFrameRep:IsVisible()) then
		if(InstanceTime_TimerFrameRepTextReputation2:IsVisible()) then
			InstanceTime_TimerFrameXP:SetPoint("TOPLEFT", "InstanceTime_TimerFrameRep", 0, -40);
		else
			InstanceTime_TimerFrameXP:SetPoint("TOPLEFT", "InstanceTime_TimerFrameRep", 0, -22);
		end
	else
		InstanceTime_TimerFrameXP:SetPoint("TOPLEFT", "InstanceTimeFrame", 0, -22);
	end
	
	if (FreierGeist_IT_XPVisibility) then
		InstanceTime_TimerFrameXP:Hide();
		FreierGeist_IT_XPVisibility = false;
	else
		InstanceTime_TimerFrameXP:Show();
		FreierGeist_IT_XPVisibility = true;
	end
end


----------------------------------
--     show/hide Reputation     --
----------------------------------
function FreierGeist_IT_ShowRep()
	InstanceTime_TimerFrameXP:ClearAllPoints();
	InstanceTime_TimerFrameRep:ClearAllPoints();
	if(InstanceTime_TimerFrameXP:IsVisible()) then
		InstanceTime_TimerFrameRep:SetPoint("TOPLEFT", "InstanceTime_TimerFrameXP", 0, -22);
	else
		InstanceTime_TimerFrameRep:SetPoint("TOPLEFT", "InstanceTimeFrame", 0, -22);
	end
		
	if (FreierGeist_IT_RepVisibility) then
		InstanceTime_TimerFrameRep:Hide();
		FreierGeist_IT_RepVisibility = false;
	else
		InstanceTime_TimerFrameRep:Show();
		FreierGeist_IT_RepVisibility = true;
	end
end


----------------------------------
--      show/hide the list      --
----------------------------------
function FreierGeist_IT_ShowList()
	if (InstanceTime_ListVisibility) then
		InstanceTime_ListFrame:Hide();
		InstanceTime_ListVisibility = false;
		InstanceTime_TellToFrame:Hide();
		anEntryIsColoured = false;
		lastSelectedEntry = 0;
	else
		InstanceTime_ListFrame:Show();
		InstanceTime_ListVisibility = true;
		-- refresh the list
		FreierGeist_IT_ScrollBarUpdate();
	end

	
	-- set 'no' selected entry
	tmp_EntryDate = "";
	tmp_EntryStart = 0;
	tmp_EntryStop = 0;
	tmp_EntryDuration = "";
	tmp_EntryMode = INSTANCETIME_INTERN_DUNGEON_MODE1;
	tmp_EntryZone = "";
	lastSelectedEntry = 0;
	FreierGeist_IT_SetClasses(classes);
	FreierGeist_IT_SetBosslist(bosslist);

	if(startTime == 0 ) then
		FreierGeist_IT_AdditionalInfo(1);
		FreierGeist_IT_SetDefaults();
	else
		-- hide reputation and faction
		InstanceTime_ListFrameTextReputation1:Hide();
		InstanceTime_ListFrameTextReputation3:Hide();
		InstanceTime_ListFrameTextReputation2:Hide();
		InstanceTime_ListFrameTextReputation1All:Hide();
		InstanceTime_ListFrameTextReputation2All:Hide();
		InstanceTime_ListFrameTextReputation3All:Hide();
		InstanceTime_ListFrameTextFraction1:Hide();
		InstanceTime_ListFrameTextFraction2:Hide();
		InstanceTime_ListFrameTextFraction3:Hide();
		-- show first reputation and faction
		FreierGeist_IT_AdditionalInfo(2);
		
		FreierGeist_IT_SetXP(XP, mode, zoneName);
		FreierGeist_IT_SetReputationFraction(reputation[1], reputation[2], reputation[3], fraction[1], fraction[2], fraction[3], mode, zoneName);
		FreierGeist_IT_SetMoney(gold, silver, copper, mode, zoneName);
		FreierGeist_IT_SetMoneyRepair(gold_repair, silver_repair, copper_repair, mode, zoneName);
		FreierGeist_IT_SetDeaths(deaths, mode, zoneName);
		FreierGeist_IT_SetJusticePoints(justice_points, mode, zoneName);
		FreierGeist_IT_SetValorPoints(valor_points, mode, zoneName);

		InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_ACTUAL_TIMER);
	end
end


-------------------------------------
--     show/hide the options       --
-------------------------------------
function FreierGeist_IT_ShowOptions()
	if (InstanceTime_OptionsVisibility) then
		InstanceTimeOptionsFrame:Hide();
		InstanceTime_OptionsVisibility = false;
		
		-- leave channels if already in an instance
		if(timerHasStarted) then
			FreierGeist_IT_LeaveTheseChannels();
		end
	else
		InstanceTimeOptionsFrame:Show();
		InstanceTimeOptionsFrameAnnouncement:SetText(FreierGeist_IT_TextMessage);
		InstanceTimeOptionsFrameDateFormat:SetText(FreierGeist_IT_DateFormat);
		InstanceTimeOptionsFrameContinueWithin:SetText(FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"]);
		InstanceTimeOptionsFrameRepairUntil:SetText(FreierGeist_IT_Config["FreierGeist_IT_RepairUntil"]);
		InstanceTimeOptionsFrameLeaveChannels:SetText(FreierGeist_IT_Config["FreierGeist_IT_LeaveChannels"]);
		InstanceTimeOptionsFrameSliderOffset:SetValue(FreierGeist_IT_DataArraySize);
		InstanceTime_OptionsVisibility = true;
		
		InstanceTimeOptionsFrameExcludeItem1:SetText(FreierGeist_IT_Exclude[1]);
		InstanceTimeOptionsFrameExcludeItem2:SetText(FreierGeist_IT_Exclude[2]);
		InstanceTimeOptionsFrameExcludeItem3:SetText(FreierGeist_IT_Exclude[3]);
		InstanceTimeOptionsFrameExcludeItem4:SetText(FreierGeist_IT_Exclude[4]);
		InstanceTimeOptionsFrameExcludeItem5:SetText(FreierGeist_IT_Exclude[5]);
		InstanceTimeOptionsFrameExcludeItem6:SetText(FreierGeist_IT_Exclude[6]);
		InstanceTimeOptionsFrameExcludeItem7:SetText(FreierGeist_IT_Exclude[7]);
		InstanceTimeOptionsFrameExcludeItem8:SetText(FreierGeist_IT_Exclude[8]);
		InstanceTimeOptionsFrameExcludeItem9:SetText(FreierGeist_IT_Exclude[9]);
		InstanceTimeOptionsFrameExcludeItem10:SetText(FreierGeist_IT_Exclude[10]);
		
		-- join channels if already left the instance
		if(not timerHasStarted) then
			FreierGeist_IT_JoinTheseChannels();
		end
	end
end


-------------------------------------
--      show/hide the buttons      --
-------------------------------------
function FreierGeist_IT_ShowButtons()

	if (InstanceTime_MenuFrame:IsVisible()) then
		if(startTime == 0) then
			InstanceTime_MenuFrameButtonStartTimer:Hide();
			InstanceTime_MenuFrameButtonStopTimer:Show();
		else
			InstanceTime_MenuFrameButtonStartTimer:Show();
			InstanceTime_MenuFrameButtonStopTimer:Hide();
		end
		
		InstanceTime_MenuFrame:Hide();
		showButtons = false;
	else
		if(startTime == 0) then
			InstanceTime_MenuFrameButtonStartTimer:Show();
			InstanceTime_MenuFrameButtonStopTimer:Hide();
		else
			InstanceTime_MenuFrameButtonStartTimer:Hide();
			InstanceTime_MenuFrameButtonStopTimer:Show();
		end
		
		InstanceTime_MenuFrame:Show();
		showButtons = true;
	end
end


-----------------------------------
--   lock/unlock timer dialog    --
-----------------------------------
function FreierGeist_IT_LockTimer()
	if (FreierGeist_IT_Config["FreierGeist_IT_TimerLocked"]) then
		InstanceTimeFrame.isLocked = 0;
		FreierGeist_IT_Config["FreierGeist_IT_TimerLocked"] = false;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_DIALOG_MOVEABLE);
	else
		InstanceTimeFrame.isLocked = 1;
		FreierGeist_IT_Config["FreierGeist_IT_TimerLocked"] = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_DIALOG_NOT_MOVEABLE);
	end
end


--------------------------------------------------
--     automatically/manually manage timer      --
--------------------------------------------------
function FreierGeist_IT_ManageTimerAutomatically()
	if (FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"]) then
		FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_TimerAutomaticallyManaged"] = true;
	end
end


-------------------------------------
--   set if XP should be posted    --
-------------------------------------
function FreierGeist_IT_SetXPOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_XPOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_XPOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_XPOutput"] = true;
	end
	
	if(anEntryIsColoured) then
		FreierGeist_IT_EntryClicked(selectedEntry);
	end
end


---------------------------------------------
--   set if reputation should be posted    --
---------------------------------------------
function FreierGeist_IT_SetReputationOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_ReputationOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_ReputationOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_ReputationOutput"] = true;
	end
	
	if(anEntryIsColoured) then
		FreierGeist_IT_EntryClicked(selectedEntry);
	end
end


----------------------------------------
--   set if money should be posted    --
----------------------------------------
function FreierGeist_IT_SetMoneyOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_MoneyOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_MoneyOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_MoneyOutput"] = true;
	end
	
	if(anEntryIsColoured) then
		FreierGeist_IT_EntryClicked(selectedEntry);
	end
end


-----------------------------------------
--   set if repair should be posted    --
-----------------------------------------
function FreierGeist_IT_SetRepairOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_RepairOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_RepairOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_RepairOutput"] = true;
	end
	
	if(anEntryIsColoured) then
		FreierGeist_IT_EntryClicked(selectedEntry);
	end
end


-----------------------------------------
--   set if deaths should be posted    --
-----------------------------------------
function FreierGeist_IT_SetDeathsOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_DeathsOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_DeathsOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_DeathsOutput"] = true;
	end
	
	if(anEntryIsColoured) then
		FreierGeist_IT_EntryClicked(selectedEntry);
	end
end


-----------------------------------------
--  set if XP should be display in bar --
-----------------------------------------
function FreierGeist_IT_Set_ShowXPInBar()
	if (FreierGeist_IT_Config["FreierGeist_IT_XPInBar"]) then
		FreierGeist_IT_Config["FreierGeist_IT_XPInBar"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_XPInBar"] = true;
	end
end


-------------------------------------------------
--  set if reputation should be display in bar --
-------------------------------------------------
function FreierGeist_IT_Set_ShowReputationInBar()
	if (FreierGeist_IT_Config["FreierGeist_IT_ReputationInBar"]) then
		FreierGeist_IT_Config["FreierGeist_IT_ReputationInBar"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_ReputationInBar"] = true;
	end
end


--------------------------------------------
--  set if money should be display in bar --
--------------------------------------------
function FreierGeist_IT_Set_ShowMoneyInBar()
	if (FreierGeist_IT_Config["FreierGeist_IT_MoneyInBar"]) then
		FreierGeist_IT_Config["FreierGeist_IT_MoneyInBar"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_MoneyInBar"] = true;
	end
end


-------------------------------------
--   reverse the scrollbar-list    --
-------------------------------------
function FreierGeist_IT_ReverseList()
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		FreierGeist_IT_Config["FreierGeist_IT_Reverse"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_Reverse"] = true;
	end
	
	-- refresh the list
	FreierGeist_IT_ScrollBarUpdate();
end


-------------------------------------
--   timer starts on first pull    --
-------------------------------------
function FreierGeist_IT_FirstPull()
	if (FreierGeist_IT_Config["FreierGeist_IT_FirstPull"]) then
		FreierGeist_IT_Config["FreierGeist_IT_FirstPull"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_FirstPull"] = true;
	end
end


---------------------------------------
--    timer stops on endboss kill    --
---------------------------------------
function FreierGeist_IT_FinalBossKill()
	if (FreierGeist_IT_Config["FreierGeist_IT_FinalBossKill"]) then
		FreierGeist_IT_Config["FreierGeist_IT_FinalBossKill"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_FinalBossKill"] = true;
	end
end


------------------------------------------
--          exclude green items         --
------------------------------------------
function FreierGeist_IT_ExcludeGreenFunc()
	if (FreierGeist_IT_Config["FreierGeist_IT_ExcludeGreen"]) then
		FreierGeist_IT_Config["FreierGeist_IT_ExcludeGreen"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_ExcludeGreen"] = true;
	end
end


------------------------------------------
--          exclude blue items          --
------------------------------------------
function FreierGeist_IT_ExcludeBlueFunc()
	if (FreierGeist_IT_Config["FreierGeist_IT_ExcludeBlue"]) then
		FreierGeist_IT_Config["FreierGeist_IT_ExcludeBlue"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_ExcludeBlue"] = true;
	end
end


---------------------------------------------------------
--  set if standard-info should be copied to clipboard --
---------------------------------------------------------
function FreierGeist_IT_Set_StandardClipboardOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_StandardClipboardOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_StandardClipboardOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_StandardClipboardOutput"] = true;
	end
end


------------------------------------------------------
--  set if grouplist should be copied to clipboard  --
------------------------------------------------------
function FreierGeist_IT_Set_GrouplistClipboardOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"] = true;
	end
end


-----------------------------------------------------
--  set if lootlist should be copied to clipboard  --
-----------------------------------------------------
function FreierGeist_IT_Set_LootlistClipboardOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"] = true;
	end
end


-----------------------------------------------------
--  set if bosslist should be copied to clipboard  --
-----------------------------------------------------
function FreierGeist_IT_Set_BosslistClipboardOutput()
	if (FreierGeist_IT_Config["FreierGeist_IT_BosslistClipboardOutput"]) then
		FreierGeist_IT_Config["FreierGeist_IT_BosslistClipboardOutput"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_BosslistClipboardOutput"] = true;
	end
end


--------------------------------------------------
--   set if dynamic instances should be saved   --
--------------------------------------------------
function FreierGeist_IT_Set_SaveDynamicInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveDynamicInstances"] = true;
	end
end


-----------------------------------------------
--   set if raid-instances should be saved   --
-----------------------------------------------
function FreierGeist_IT_Set_SaveRaidInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveRaidInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveRaidInstances"] = false;
		InstanceTimeOptionsFrameSaveNormalRaidInstances:Disable();
		InstanceTimeOptionsFrameSaveHeroicRaidInstances:Disable();
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveRaidInstances"] = true;
		InstanceTimeOptionsFrameSaveNormalRaidInstances:Enable();
		InstanceTimeOptionsFrameSaveHeroicRaidInstances:Enable();
	end
end


------------------------------------------------
--   set if group-instances should be saved   --
------------------------------------------------
function FreierGeist_IT_Set_SaveGroupInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveGroupInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveGroupInstances"] = false;
		InstanceTimeOptionsFrameSaveNormalGroupInstances:Disable();
		InstanceTimeOptionsFrameSaveHeroicGroupInstances:Disable();
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveGroupInstances"] = true;
		InstanceTimeOptionsFrameSaveNormalGroupInstances:Enable();
		InstanceTimeOptionsFrameSaveHeroicGroupInstances:Enable();
	end
end


-----------------------------------------------------
--  set if normal raid instances should be saved   --
-----------------------------------------------------
function FreierGeist_IT_Set_SaveNormalRaidInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveNormalRaidInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveNormalRaidInstances"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveNormalRaidInstances"] = true;
	end
end


-----------------------------------------------------
--  set if heroic raid instances should be saved   --
-----------------------------------------------------
function FreierGeist_IT_Set_SaveHeroicRaidInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicRaidInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicRaidInstances"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicRaidInstances"] = true;
	end
end


------------------------------------------------------
--  set if normal group instances should be saved   --
------------------------------------------------------
function FreierGeist_IT_Set_SaveNormalGroupInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveNormalGroupInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveNormalGroupInstances"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveNormalGroupInstances"] = true;
	end
end


------------------------------------------------------
--  set if heroic group instances should be saved   --
------------------------------------------------------
function FreierGeist_IT_Set_SaveHeroicGroupInstances()
	if (FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicGroupInstances"]) then
		FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicGroupInstances"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_SaveHeroicGroupInstances"] = true;
	end
end


---------------------------------------------
--           slider has changed            --
---------------------------------------------
function FreierGeist_IT_OptionSliderChanged()
	FreierGeist_IT_InitList(InstanceTimeOptionsFrameSliderOffset:GetValue());
	FreierGeist_IT_DataArraySize = InstanceTimeOptionsFrameSliderOffset:GetValue();
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_ENTRIES..FreierGeist_IT_DataArraySize);

	-- refresh the list
	FreierGeist_IT_ScrollBarUpdate();
end


-------------------------------------------
--        set 'create new entry'         --
-------------------------------------------
function FreierGeist_IT_SetCreateNewEntry()
	if (FreierGeist_IT_Config["FreierGeist_IT_ForceNewEntry"] == true) then
		FreierGeist_IT_Config["FreierGeist_IT_ForceNewEntry"] = false;
		InstanceTimeOptionsFrameForceNewEntry:SetChecked(false);
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_FORCE_NO_NEW_ENTRY);
	else
		FreierGeist_IT_Config["FreierGeist_IT_ForceNewEntry"] = true;
		InstanceTimeOptionsFrameForceNewEntry:SetChecked(true);
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_FORCE_NEW_ENTRY);
	end
end



-------------------------------------------
--       set location of buttons         --
-------------------------------------------
function FreierGeist_IT_ReverseButtonsSet()
	if (FreierGeist_IT_Config["FreierGeist_IT_ReverseButtons"]) then
		InstanceTime_MenuFrame:ClearAllPoints();
		InstanceTime_MenuFrame:SetPoint("BOTTOMRIGHT", "InstanceTimeFrame", "BOTTOMRIGHT", 120, -86);
	else
		InstanceTime_MenuFrame:ClearAllPoints();
		InstanceTime_MenuFrame:SetPoint("BOTTOMLEFT", "InstanceTimeFrame", "BOTTOMLEFT", -120, -86);
	end
end


--------------------------------------------
--            reverse buttons             --
--------------------------------------------
function FreierGeist_IT_ReverseButtonsFunc()
	if (FreierGeist_IT_Config["FreierGeist_IT_ReverseButtons"]) then
		FreierGeist_IT_Config["FreierGeist_IT_ReverseButtons"] = false;
	else
		FreierGeist_IT_Config["FreierGeist_IT_ReverseButtons"] = true;
	end
	
	FreierGeist_IT_ReverseButtonsSet();
end


------------------------------------------------
--            add entry to list               --
------------------------------------------------
function FreierGeist_IT_AddToList(_start, _stop)
	if(XP == nil) then XP = 0; end
	if(deaths == nil) then deaths = 0; end
	if(justice_points == nil) then justice_points = 0; end
	if(valor_points == nil) then valor_points = 0; end
	if(reputation[1] == nil) then reputation[1] = 0; end
	if(reputation[2] == nil) then reputation[2] = 0; end
	if(reputation[3] == nil) then reputation[3] = 0; end
	if(fraction[1] == nil) then fraction[1] = "-"; end
	if(fraction[2] == nil) then fraction[2] = "-"; end
	if(fraction[3] == nil) then fraction[3] = "-"; end
	if(gold == nil) then gold = 0; end
	if(silver == nil) then silver = 0; end
	if(copper == nil) then copper = 0; end
	

	for i=1,FreierGeist_IT_DataArraySize do
		if(FreierGeist_IT_Data[i]["date"] == "") then
			FreierGeist_IT_Data[i]["date"] = actualDate;
			FreierGeist_IT_Data[i]["start"] = _start;
			FreierGeist_IT_Data[i]["stop"] = _stop;
			FreierGeist_IT_Data[i]["starttime"] = startTime;
			FreierGeist_IT_Data[i]["stoptime"] = stopTime;
			FreierGeist_IT_Data[i]["zone"] = zoneName;
			FreierGeist_IT_Data[i]["mode"] = mode;
			FreierGeist_IT_Data[i]["XP"] = XP;
			FreierGeist_IT_Data[i]["deaths"] = deaths;
			FreierGeist_IT_Data[i]["justice_points"] = justice_points;
			FreierGeist_IT_Data[i]["valor_points"] = valor_points;
			FreierGeist_IT_Data[i]["reputation"] = {};
			FreierGeist_IT_Data[i]["reputation"][1] = reputation[1];
			FreierGeist_IT_Data[i]["reputation"][2] = reputation[2];
			FreierGeist_IT_Data[i]["reputation"][3] = reputation[3];
			FreierGeist_IT_Data[i]["fraction"] = {};
			FreierGeist_IT_Data[i]["fraction"][1] = fraction[1];
			FreierGeist_IT_Data[i]["fraction"][2] = fraction[2];
			FreierGeist_IT_Data[i]["fraction"][3] = fraction[3];
			FreierGeist_IT_Data[i]["gold"] = gold;
			FreierGeist_IT_Data[i]["silver"] = silver;
			FreierGeist_IT_Data[i]["copper"] = copper;
			FreierGeist_IT_Data[i]["gold_repair"] = gold_repair;
			FreierGeist_IT_Data[i]["silver_repair"] = silver_repair;
			FreierGeist_IT_Data[i]["copper_repair"] = copper_repair;
			FreierGeist_IT_Data[i]["classes"] = classes;
			FreierGeist_IT_Data[i]["bosslist"] = bosslist;
			
			-- increase the number of entries (for sizing the scrollbar-list)
			scrollBarHeight = scrollBarHeight+1;
			break;
		end
		
		if(i == FreierGeist_IT_DataArraySize) then
			for i=1,FreierGeist_IT_DataArraySize-1 do
				FreierGeist_IT_Data[i]["date"] = FreierGeist_IT_Data[i+1]["date"];
				FreierGeist_IT_Data[i]["start"] = FreierGeist_IT_Data[i+1]["start"];
				FreierGeist_IT_Data[i]["stop"] = FreierGeist_IT_Data[i+1]["stop"];
				FreierGeist_IT_Data[i]["starttime"] = FreierGeist_IT_Data[i+1]["starttime"];
				FreierGeist_IT_Data[i]["stoptime"] = FreierGeist_IT_Data[i+1]["stoptime"];
				FreierGeist_IT_Data[i]["zone"] = FreierGeist_IT_Data[i+1]["zone"];
				FreierGeist_IT_Data[i]["mode"] = FreierGeist_IT_Data[i+1]["mode"];
				FreierGeist_IT_Data[i]["XP"] = FreierGeist_IT_Data[i+1]["XP"];
				FreierGeist_IT_Data[i]["deaths"] = FreierGeist_IT_Data[i+1]["deaths"];
				FreierGeist_IT_Data[i]["justice_points"] = FreierGeist_IT_Data[i+1]["justice_points"];
				FreierGeist_IT_Data[i]["valor_points"] = FreierGeist_IT_Data[i+1]["valor_points"];
				FreierGeist_IT_Data[i]["reputation"][1] = FreierGeist_IT_Data[i+1]["reputation"][1];
				FreierGeist_IT_Data[i]["reputation"][2] = FreierGeist_IT_Data[i+1]["reputation"][2];
				FreierGeist_IT_Data[i]["reputation"][3] = FreierGeist_IT_Data[i+1]["reputation"][3];
				FreierGeist_IT_Data[i]["fraction"][1] = FreierGeist_IT_Data[i+1]["fraction"][1];
				FreierGeist_IT_Data[i]["fraction"][2] = FreierGeist_IT_Data[i+1]["fraction"][2];
				FreierGeist_IT_Data[i]["fraction"][3] = FreierGeist_IT_Data[i+1]["fraction"][3];
				FreierGeist_IT_Data[i]["gold"] = FreierGeist_IT_Data[i+1]["gold"];
				FreierGeist_IT_Data[i]["silver"] = FreierGeist_IT_Data[i+1]["silver"];
				FreierGeist_IT_Data[i]["copper"] = FreierGeist_IT_Data[i+1]["copper"];
				FreierGeist_IT_Data[i]["gold_repair"] = FreierGeist_IT_Data[i+1]["gold_repair"];
				FreierGeist_IT_Data[i]["silver_repair"] = FreierGeist_IT_Data[i+1]["silver_repair"];
				FreierGeist_IT_Data[i]["copper_repair"] = FreierGeist_IT_Data[i+1]["copper_repair"];
				FreierGeist_IT_Data[i]["classes"] = FreierGeist_IT_Data[i+1]["classes"];
				FreierGeist_IT_Data[i]["bosslist"] = FreierGeist_IT_Data[i+1]["bosslist"];
			end
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["date"] = actualDate;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["start"] = _start;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["stop"] = _stop;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["starttime"] = startTime;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["stoptime"] = stopTime;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["zone"] = zoneName;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["mode"] = mode;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["XP"] = XP;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["deaths"] = deaths;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["justice_points"] = justice_points;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["valor_points"] = valor_points;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["reputation"][1] = reputation[1];
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["reputation"][2] = reputation[2];
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["reputation"][3] = reputation[3];
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["fraction"][1] = fraction[1];
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["fraction"][2] = fraction[2];
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["fraction"][3] = fraction[3];
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["gold"] = gold;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["silver"] = silver;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["copper"] = copper;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["gold_repair"] = gold_repair;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["silver_repair"] = silver_repair;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["copper_repair"] = copper_repair;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["classes"] = classes;
			FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["bosslist"] = bosslist;
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TIMER_LIST_FULL);
		end
	end

	-- refresh the list
	FreierGeist_IT_ScrollBarUpdate();
end


------------------------------------
--         delete the list        --
------------------------------------
function FreierGeist_IT_DeleteList()
	for i=1,FreierGeist_IT_DataArraySize do
		FreierGeist_IT_Data[i]["date"] = "";
		FreierGeist_IT_Data[i]["start"] = "";
		FreierGeist_IT_Data[i]["stop"] = "";
		FreierGeist_IT_Data[i]["starttime"] = 0;
		FreierGeist_IT_Data[i]["stoptime"] = 0;
		FreierGeist_IT_Data[i]["zone"] = "";
		FreierGeist_IT_Data[i]["mode"] = INSTANCETIME_INTERN_DUNGEON_MODE1;
		FreierGeist_IT_Data[i]["XP"] = 0;
		FreierGeist_IT_Data[i]["deaths"] = 0;
		FreierGeist_IT_Data[i]["justice_points"] = 0;
		FreierGeist_IT_Data[i]["valor_points"] = 0;
		FreierGeist_IT_Data[i]["reputation"][1] = 0;
		FreierGeist_IT_Data[i]["reputation"][2] = 0;
		FreierGeist_IT_Data[i]["reputation"][3] = 0;
		FreierGeist_IT_Data[i]["fraction"][1] = "-";
		FreierGeist_IT_Data[i]["fraction"][2] = "-";
		FreierGeist_IT_Data[i]["fraction"][3] = "-";
		FreierGeist_IT_Data[i]["gold"] = 0;
		FreierGeist_IT_Data[i]["silver"] = 0;
		FreierGeist_IT_Data[i]["copper"] = 0;
		FreierGeist_IT_Data[i]["gold_repair"] = 0;
		FreierGeist_IT_Data[i]["silver_repair"] = 0;
		FreierGeist_IT_Data[i]["copper_repair"] = 0;
		FreierGeist_IT_Data[i]["classes"] = "";
		FreierGeist_IT_Data[i]["bosslist"] = "";
		
		-- delete also the lootlist
		FreierGeist_IT_Loot = nil;
		FreierGeist_IT_Loot = {};
	end
	
		
	-- decrease the number of entries (for sizing the scrollbar-list)
	scrollBarHeight = 1;
	-- refresh the list
	FreierGeist_IT_ScrollBarUpdate();
	
	FreierGeist_IT_Config["FreierGeist_IT_StartTimeSaved"] = 0;
	FreierGeist_IT_Config["FreierGeist_IT_StopTimeSaved"] = 0;
	FreierGeist_IT_SetDefaults();
	
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_LIST_DELETED);
end


----------------------------------------------------
--         set the line which is selected         --
----------------------------------------------------
function FreierGeist_IT_SetSelectedEntryLine(_entry)
	selectedEntry = _entry;
	
	FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);
	lineplusoffset = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		lineplusoffset = scrollBarHeight-lineplusoffset;
	end
	
	INSTANCETIME_CHAT_REALLY_DELETE_ENTRY_QUESTION_TEXT = "\n\n"..FreierGeist_IT_Data[lineplusoffset]["date"].."\n"..FreierGeist_IT_Data[lineplusoffset]["start"].."-"..FreierGeist_IT_Data[lineplusoffset]["stop"].."    "..SecondsToTime(FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]).." in "..FreierGeist_IT_Data[lineplusoffset]["zone"].."  ("..FreierGeist_IT_Data[lineplusoffset]["mode"]..")";
end


-----------------------------------------------------------
--    set the line which is selected for the tooltip     --
-----------------------------------------------------------
function FreierGeist_IT_SetSelectedEntryLineTooltip(_entry)
	local lineplusoffset;
	local tmp_slowest, tmp_fastest;
	local tmp_average_duration = 0;
	local tmp_duration = 0;
	instance_count = 0;
		
		
	FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);
	lineplusoffset = _entry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		lineplusoffset = scrollBarHeight-lineplusoffset;
	end
	
	if((FreierGeist_IT_Data[lineplusoffset]["zone"]  ~= nil) and (FreierGeist_IT_Data[lineplusoffset]["zone"] ~= "")) then
		tmp_slowest = 0;		-- as fast as it can be
		tmp_fastest = 86400;	-- 1 day in seconds
		
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == FreierGeist_IT_Data[lineplusoffset]["zone"])
			and (FreierGeist_IT_Data[tmp_line]["mode"] == FreierGeist_IT_Data[lineplusoffset]["mode"])) then
				instance_count = instance_count + 1;
				
				if((FreierGeist_IT_Data[tmp_line]["starttime"] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["stoptime"] ~= nil)) then
					
					if((FreierGeist_IT_Data[tmp_line]["starttime"] ~= 0)
					and (FreierGeist_IT_Data[tmp_line]["stoptime"] ~= 0)) then
						tmp_duration = FreierGeist_IT_Data[tmp_line]["stoptime"] - FreierGeist_IT_Data[tmp_line]["starttime"];	
					else
						tmp_duration = 0;
					end
	
	
					tmp_average_duration = tmp_average_duration + tmp_duration;

					if(tmp_duration >= tmp_slowest) then
						tmp_slowest = tmp_duration;
					end
					if(tmp_duration <= tmp_fastest) then
						tmp_fastest = tmp_duration;
					end
				end
			end
		end
		
		-- this is set, if all entries doesn't have ["starttime"] / ["stoptime"]
		if(tmp_fastest == 86400) then
			tmp_fastest = 0;
		end
	
		tmp_average_duration = tmp_average_duration / instance_count;

		GameTooltip:AddLine("|ccc00cc00"..FreierGeist_IT_Data[lineplusoffset]["zone"].." ("..FreierGeist_IT_Data[lineplusoffset]["mode"].."):\n|r", 0,0,0,1);
		GameTooltip:AddLine(INSTANCETIME_MAIN_TOOLTIP_DUNGEON_INFO_1..instance_count, 0.7,0.7,0.7);
		GameTooltip:AddDoubleLine("|cccdd8833"..INSTANCETIME_MAIN_TOOLTIP_DUNGEON_INFO_2.."|r", "|ccc88aa44"..SecondsToTime(tmp_fastest).."|r", 0,0,0,0,0,0);
		GameTooltip:AddDoubleLine("|cccdd8833"..INSTANCETIME_MAIN_TOOLTIP_DUNGEON_INFO_3.."|r", "|cccee5555"..SecondsToTime(tmp_slowest).."|r", 0,0,0,0,0,0);
		GameTooltip:AddDoubleLine("|cccdd8833"..INSTANCETIME_MAIN_TOOLTIP_DUNGEON_INFO_4.."|r", "|ccceedd33"..SecondsToTime(tmp_average_duration).."|r", 0,0,0,0,0,0);
	end
end


-------------------------------------
--         delete entry            --
-------------------------------------
function FreierGeist_IT_DeleteEntry()
	local line;
	local lineplusoffset;
	
   
  	FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);
	lineplusoffset = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		lineplusoffset = scrollBarHeight-lineplusoffset;
	end
	
	for line=lineplusoffset,FreierGeist_IT_DataArraySize-1 do
		FreierGeist_IT_Data[line]["date"] = FreierGeist_IT_Data[line+1]["date"];
		FreierGeist_IT_Data[line]["start"] = FreierGeist_IT_Data[line+1]["start"];
		FreierGeist_IT_Data[line]["stop"] = FreierGeist_IT_Data[line+1]["stop"];
		FreierGeist_IT_Data[line]["starttime"] = FreierGeist_IT_Data[line+1]["starttime"];
		FreierGeist_IT_Data[line]["stoptime"] = FreierGeist_IT_Data[line+1]["stoptime"];
		FreierGeist_IT_Data[line]["zone"] = FreierGeist_IT_Data[line+1]["zone"];
		FreierGeist_IT_Data[line]["mode"] = FreierGeist_IT_Data[line+1]["mode"];
		FreierGeist_IT_Data[line]["XP"] = FreierGeist_IT_Data[line+1]["XP"];
		FreierGeist_IT_Data[line]["deaths"] = FreierGeist_IT_Data[line+1]["deaths"];
		FreierGeist_IT_Data[line]["justice_points"] = FreierGeist_IT_Data[line+1]["justice_points"];
		FreierGeist_IT_Data[line]["valor_points"] = FreierGeist_IT_Data[line+1]["valor_points"];
		FreierGeist_IT_Data[line]["reputation"][1] = FreierGeist_IT_Data[line+1]["reputation"][1];
		FreierGeist_IT_Data[line]["reputation"][2] = FreierGeist_IT_Data[line+1]["reputation"][2];
		FreierGeist_IT_Data[line]["reputation"][3] = FreierGeist_IT_Data[line+1]["reputation"][3];
		FreierGeist_IT_Data[line]["fraction"][1] = FreierGeist_IT_Data[line+1]["fraction"][1];
		FreierGeist_IT_Data[line]["fraction"][2] = FreierGeist_IT_Data[line+1]["fraction"][2];
		FreierGeist_IT_Data[line]["fraction"][3] = FreierGeist_IT_Data[line+1]["fraction"][3];
		FreierGeist_IT_Data[line]["gold"] = FreierGeist_IT_Data[line+1]["gold"];
		FreierGeist_IT_Data[line]["silver"] = FreierGeist_IT_Data[line+1]["silver"];
		FreierGeist_IT_Data[line]["copper"] = FreierGeist_IT_Data[line+1]["copper"];
		FreierGeist_IT_Data[line]["gold_repair"] = FreierGeist_IT_Data[line+1]["gold_repair"];
		FreierGeist_IT_Data[line]["silver_repair"] = FreierGeist_IT_Data[line+1]["silver_repair"];
		FreierGeist_IT_Data[line]["copper_repair"] = FreierGeist_IT_Data[line+1]["copper_repair"];
		FreierGeist_IT_Data[line]["classes"] = FreierGeist_IT_Data[line+1]["classes"];
		FreierGeist_IT_Data[line]["bosslist"] = FreierGeist_IT_Data[line+1]["bosslist"];
	
		
		-- take care that this exists
		if(FreierGeist_IT_Loot["index"] == nil) then FreierGeist_IT_Loot["index"] = {}; end
		if(FreierGeist_IT_Loot["item"] == nil) then FreierGeist_IT_Loot["item"] = {}; end
		if(FreierGeist_IT_Loot["unit"] == nil) then FreierGeist_IT_Loot["unit"] = {}; end
		if(FreierGeist_IT_Loot["player"] == nil) then FreierGeist_IT_Loot["player"] = {}; end
		
		if(FreierGeist_IT_Loot["index"][line] == nil) then FreierGeist_IT_Loot["index"][line] = 0; end
		if(FreierGeist_IT_Loot["item"][line] == nil) then FreierGeist_IT_Loot["item"][line] = {}; end
		if(FreierGeist_IT_Loot["unit"][line] == nil) then FreierGeist_IT_Loot["unit"][line] = {}; end
		if(FreierGeist_IT_Loot["player"][line] == nil) then FreierGeist_IT_Loot["player"][line] = {}; end
		
		if(FreierGeist_IT_Loot["index"][line+1] == nil) then FreierGeist_IT_Loot["index"][line+1] = 0; end
		if(FreierGeist_IT_Loot["item"][line+1] == nil) then FreierGeist_IT_Loot["item"][line+1] = {}; end
		if(FreierGeist_IT_Loot["unit"][line+1] == nil) then FreierGeist_IT_Loot["unit"][line+1] = {}; end
		if(FreierGeist_IT_Loot["player"][line+1] == nil) then FreierGeist_IT_Loot["player"][line+1] = {}; end
		
		
		-- move also the lootlist
		FreierGeist_IT_Loot["index"][line] = FreierGeist_IT_Loot["index"][line+1];
		FreierGeist_IT_Loot["item"][line] = FreierGeist_IT_Loot["item"][line+1];
		FreierGeist_IT_Loot["unit"][line] = FreierGeist_IT_Loot["unit"][line+1];
		FreierGeist_IT_Loot["player"][line] = FreierGeist_IT_Loot["player"][line+1];
	end
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["date"] = "";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["start"] = "";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["stop"] = "";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["starttime"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["stoptime"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["zone"] = "";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["mode"] = INSTANCETIME_INTERN_DUNGEON_MODE1;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["XP"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["deaths"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["justice_points"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["valor_points"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["reputation"][1] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["reputation"][2] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["reputation"][3] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["fraction"][1] = "-";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["fraction"][2] = "-";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["fraction"][3] = "-";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["gold"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["silver"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["copper"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["gold_repair"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["silver_repair"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["copper_repair"] = 0;
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["classes"] = "";
	FreierGeist_IT_Data[FreierGeist_IT_DataArraySize]["bosslist"] = "";
	
	-- delete also the lootlist
	FreierGeist_IT_Loot["index"][FreierGeist_IT_DataArraySize] = nil;
	FreierGeist_IT_Loot["item"][FreierGeist_IT_DataArraySize] = nil;
	FreierGeist_IT_Loot["unit"][FreierGeist_IT_DataArraySize] = nil;
	FreierGeist_IT_Loot["player"][FreierGeist_IT_DataArraySize] = nil;


	-- decrease the number of entries (for sizing the scrollbar-list)
	scrollBarHeight = scrollBarHeight-1;
	-- refresh the list
	FreierGeist_IT_ScrollBarUpdate();

	DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_ENTRY_DELETED);
end


--------------------------------------
--         merge entries            --
--------------------------------------
function FreierGeist_IT_MergeEntries()
	local index_1, index_2, start_1, start_2, stop_1;
	
	
	lineplusoffset = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		lineplusoffset = scrollBarHeight-lineplusoffset;
	end
	
		
	index_1 = markedIndexToMerge[1];
	index_2 = markedIndexToMerge[2];
	start_1 = FreierGeist_IT_Data[index_1]["starttime"];
	start_2 = FreierGeist_IT_Data[index_2]["starttime"];
	-- for later delete set 'selectedEntry'
	if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		selectedEntry = scrollBarHeight-markedIndexToMerge[2]-FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	else
		selectedEntry = markedIndexToMerge[2]-FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	end
	
	
	-- sort, so that the oldes entry is in index_1 and the newer is in index_2
	if(start_1 > start_2) then
		index_1 = markedIndexToMerge[2];
		index_2 = markedIndexToMerge[1];
		-- for later delete set 'selectedEntry'
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			selectedEntry = scrollBarHeight-markedIndexToMerge[1]-FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		else
			selectedEntry = markedIndexToMerge[1]-FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		end
	end
	start_1 = FreierGeist_IT_Data[index_1]["starttime"];
	start_2 = FreierGeist_IT_Data[index_2]["starttime"];
	stop_1 = FreierGeist_IT_Data[index_1]["stoptime"];

	
	-- write the new entry in index_1
	if(FreierGeist_IT_Data[index_1]["zone"] ~= "" and FreierGeist_IT_Data[index_2]["zone"] ~= ""
		and FreierGeist_IT_Data[index_1]["zone"] ~= FreierGeist_IT_Data[index_2]["zone"]) then
		StaticPopup_Show("MERGE_FAILED", INSTANCETIME_CHAT_ENTRY_CANT_MERGE_3);
	elseif(abs(start_2 - stop_1) <= (FreierGeist_IT_Config["FreierGeist_IT_ContinueWithin"]*60)) then
		FreierGeist_IT_Data[index_1]["date"] = FreierGeist_IT_Data[index_1]["date"];
		FreierGeist_IT_Data[index_1]["start"] = FreierGeist_IT_Data[index_1]["start"];
		FreierGeist_IT_Data[index_1]["stop"] = FreierGeist_IT_Data[index_2]["stop"];
		FreierGeist_IT_Data[index_1]["starttime"] = FreierGeist_IT_Data[index_1]["starttime"];
		FreierGeist_IT_Data[index_1]["stoptime"] = FreierGeist_IT_Data[index_2]["stoptime"];
		FreierGeist_IT_Data[index_1]["XP"] = FreierGeist_IT_Data[index_1]["XP"] + FreierGeist_IT_Data[index_2]["XP"];
		FreierGeist_IT_Data[index_1]["deaths"] = FreierGeist_IT_Data[index_1]["deaths"] + FreierGeist_IT_Data[index_2]["deaths"];
		FreierGeist_IT_Data[index_1]["justice_points"] = FreierGeist_IT_Data[index_1]["justice_points"] + FreierGeist_IT_Data[index_2]["justice_points"];
		FreierGeist_IT_Data[index_1]["valor_points"] = FreierGeist_IT_Data[index_1]["valor_points"] + FreierGeist_IT_Data[index_2]["valor_points"];
		if((FreierGeist_IT_Data[index_1]["zone"] == "") or (FreierGeist_IT_Data[index_1]["zone"] == nil)) then
			FreierGeist_IT_Data[index_1]["zone"] = FreierGeist_IT_Data[index_2]["zone"];
		else
			FreierGeist_IT_Data[index_1]["zone"] = FreierGeist_IT_Data[index_1]["zone"];
		end
		
		if((FreierGeist_IT_Data[index_1]["mode"] == "") or (FreierGeist_IT_Data[index_1]["mode"] == nil)) then
			FreierGeist_IT_Data[index_1]["mode"] = FreierGeist_IT_Data[index_2]["mode"];
		else
			FreierGeist_IT_Data[index_1]["mode"] = FreierGeist_IT_Data[index_1]["mode"];
		end
		
		
		FreierGeist_IT_Data[index_1]["gold"] = FreierGeist_IT_Data[index_1]["gold"] + FreierGeist_IT_Data[index_2]["gold"];
		FreierGeist_IT_Data[index_1]["silver"] = FreierGeist_IT_Data[index_1]["silver"] + FreierGeist_IT_Data[index_2]["silver"];
		FreierGeist_IT_Data[index_1]["copper"] = FreierGeist_IT_Data[index_1]["copper"] + FreierGeist_IT_Data[index_2]["copper"];
		
		FreierGeist_IT_Data[index_1]["gold_repair"] = FreierGeist_IT_Data[index_1]["gold_repair"] + FreierGeist_IT_Data[index_2]["gold_repair"];
		FreierGeist_IT_Data[index_1]["silver_repair"] = FreierGeist_IT_Data[index_1]["silver_repair"] + FreierGeist_IT_Data[index_2]["silver_repair"];
		FreierGeist_IT_Data[index_1]["copper_repair"] = FreierGeist_IT_Data[index_1]["copper_repair"] + FreierGeist_IT_Data[index_2]["copper_repair"];
		
		-- correct gold, silver, copper
		while (FreierGeist_IT_Data[index_1]["copper"] >= 100) do
			FreierGeist_IT_Data[index_1]["silver"] = FreierGeist_IT_Data[index_1]["silver"] + 1;
			FreierGeist_IT_Data[index_1]["copper"] = FreierGeist_IT_Data[index_1]["copper"] - 100;
		end
		while (FreierGeist_IT_Data[index_1]["silver"] >= 100) do
			FreierGeist_IT_Data[index_1]["gold"] = FreierGeist_IT_Data[index_1]["gold"] + 1;
			FreierGeist_IT_Data[index_1]["silver"] = FreierGeist_IT_Data[index_1]["silver"] - 100;
		end
		
		-- correct repair gold, silver, copper
		while (FreierGeist_IT_Data[index_1]["copper_repair"] >= 100) do
			FreierGeist_IT_Data[index_1]["silver_repair"] = FreierGeist_IT_Data[index_1]["silver_repair"] + 1;
			FreierGeist_IT_Data[index_1]["copper_repair"] = FreierGeist_IT_Data[index_1]["copper_repair"] - 100;
		end
		while (FreierGeist_IT_Data[index_1]["silver_repair"] >= 100) do
			FreierGeist_IT_Data[index_1]["gold_repair"] = FreierGeist_IT_Data[index_1]["gold_repair"] + 1;
			FreierGeist_IT_Data[index_1]["silver_repair"] = FreierGeist_IT_Data[index_1]["silver_repair"] - 100;
		end
		
		
		-- add up the same reputations
		for index_a=1,3 do
			for index_b=1,3 do
				if(FreierGeist_IT_Data[index_1]["fraction"][index_a] == FreierGeist_IT_Data[index_2]["fraction"][index_b]) then
					FreierGeist_IT_Data[index_1]["reputation"][index_a] = FreierGeist_IT_Data[index_1]["reputation"][index_a] + FreierGeist_IT_Data[index_2]["reputation"][index_b];
				end
			end
		end
		
		
		-- if one has no reputation
		if( (FreierGeist_IT_Data[index_1]["fraction"][1] == "-") and (FreierGeist_IT_Data[index_2]["fraction"][1] ~= "-") ) then
			FreierGeist_IT_Data[index_1]["fraction"][1] = FreierGeist_IT_Data[index_2]["fraction"][1];
			FreierGeist_IT_Data[index_1]["reputation"][1] = FreierGeist_IT_Data[index_2]["reputation"][1];
		end
		
		if( (FreierGeist_IT_Data[index_1]["fraction"][2] == "-") and (FreierGeist_IT_Data[index_2]["fraction"][2] ~= "-") ) then
			if(FreierGeist_IT_Data[index_1]["fraction"][1] ~= FreierGeist_IT_Data[index_2]["fraction"][2]) then
				FreierGeist_IT_Data[index_1]["fraction"][2] = FreierGeist_IT_Data[index_2]["fraction"][2];
				FreierGeist_IT_Data[index_1]["reputation"][2] = FreierGeist_IT_Data[index_2]["reputation"][2];
			end
		end
		if( (FreierGeist_IT_Data[index_1]["fraction"][3] == "-") and (FreierGeist_IT_Data[index_2]["fraction"][3] ~= "-") ) then
			if( (FreierGeist_IT_Data[index_1]["fraction"][1] ~= FreierGeist_IT_Data[index_2]["fraction"][3])
				and (FreierGeist_IT_Data[index_1]["fraction"][2] ~= FreierGeist_IT_Data[index_2]["fraction"][3]) ) then
				FreierGeist_IT_Data[index_1]["fraction"][3] = FreierGeist_IT_Data[index_2]["fraction"][3];
				FreierGeist_IT_Data[index_1]["reputation"][3] = FreierGeist_IT_Data[index_2]["reputation"][3];
			end
		end
		
		
		-- merge also the lootlist
		if(FreierGeist_IT_Loot["index"] == nil) then FreierGeist_IT_Loot["index"] = {}; end
		if(FreierGeist_IT_Loot["item"] == nil) then FreierGeist_IT_Loot["item"] = {}; end
		if(FreierGeist_IT_Loot["unit"] == nil) then FreierGeist_IT_Loot["unit"] = {}; end
		if(FreierGeist_IT_Loot["player"] == nil) then FreierGeist_IT_Loot["player"] = {}; end
		if(FreierGeist_IT_Loot["index"][index_1] == nil) then FreierGeist_IT_Loot["index"][index_1] = 0; end
		if(FreierGeist_IT_Loot["item"][index_1] == nil) then FreierGeist_IT_Loot["item"][index_1] = {}; end
		if(FreierGeist_IT_Loot["unit"][index_1] == nil) then FreierGeist_IT_Loot["unit"][index_1] = {}; end
		if(FreierGeist_IT_Loot["player"][index_1] == nil) then FreierGeist_IT_Loot["player"][index_1] = {}; end		
		if(FreierGeist_IT_Loot["index"][index_2] == nil) then FreierGeist_IT_Loot["index"][index_2] = 0; end
		
		
		for tmp_index=1,FreierGeist_IT_Loot["index"][index_2] do
			FreierGeist_IT_Loot["item"][index_1][FreierGeist_IT_Loot["index"][index_1]+tmp_index] = FreierGeist_IT_Loot["item"][index_2][tmp_index];
			FreierGeist_IT_Loot["unit"][index_1][FreierGeist_IT_Loot["index"][index_1]+tmp_index] = FreierGeist_IT_Loot["unit"][index_2][tmp_index];
			FreierGeist_IT_Loot["player"][index_1][FreierGeist_IT_Loot["index"][index_1]+tmp_index] = FreierGeist_IT_Loot["player"][index_2][tmp_index];
		end
		FreierGeist_IT_Loot["index"][index_1] = FreierGeist_IT_Loot["index"][index_1] + FreierGeist_IT_Loot["index"][index_2];


		-- correct old versions: be sure that the classes begin with one "\n"
		-- (Some may be have no "\n" at the beginning.)
		FreierGeist_IT_Data[index_1]["classes"] = "\n"..FreierGeist_IT_Data[index_1]["classes"];
		FreierGeist_IT_Data[index_1]["classes"] = string.gsub(FreierGeist_IT_Data[index_1]["classes"], "\n\n", "\n");
		FreierGeist_IT_Data[index_2]["classes"] = "\n"..FreierGeist_IT_Data[index_2]["classes"];
		FreierGeist_IT_Data[index_2]["classes"] = string.gsub(FreierGeist_IT_Data[index_2]["classes"], "\n\n", "\n");
		
		

		-- merge classes:
		local tmp_i = 0;
		local tmp_j = 0;
		local tmp_charname = "";
		local tmp_allClasses = "";
		FreierGeist_IT_Data[index_1]["classes"] = FreierGeist_IT_Data[index_1]["classes"]..FreierGeist_IT_Data[index_2]["classes"];
		while (tmp_j < string.len(FreierGeist_IT_Data[index_1]["classes"])) do
			local tmp_char = "";
			tmp_i, tmp_j = string.find(FreierGeist_IT_Data[index_1]["classes"], "..........(%w+)..   ..........%((%w+) %d+%)..", tmp_j);
		
			if((tmp_i ~= nil) and (tmp_j ~= nil)) then
				tmp_charname = string.sub(FreierGeist_IT_Data[index_1]["classes"], tmp_i, tmp_j);
				tmp_char = string.gsub(tmp_charname, "..........(%w+)..   ..........%((%w+) %d+%)..", "%1");
			
				if(string.find(tmp_allClasses, tmp_char) == nil) then
					tmp_allClasses = tmp_allClasses..tmp_charname;
				end
			end
			
			if(tmp_j == nil) then
				tmp_j = string.len(FreierGeist_IT_Data[index_1]["classes"]);
			end
		end
		FreierGeist_IT_Data[index_1]["classes"] = tmp_allClasses;



		-- merge bosslist:
		FreierGeist_IT_Data[index_1]["bosslist"] = FreierGeist_IT_Data[index_1]["bosslist"]..FreierGeist_IT_Data[index_2]["bosslist"];
		
		
		
		-- delete second entry
		FreierGeist_IT_DeleteEntry()
	else
		StaticPopup_Show("MERGE_FAILED", INSTANCETIME_CHAT_ENTRY_CANT_MERGE_2);
	end
		
	-- unmark the entries and refresh the scrollbar
	markedIndexToMerge[1] = 0;
	markedIndexToMerge[2] = 0;
	FreierGeist_IT_ScrollBarUpdate();
end


---------------------------------------------
--        entry button was clicked         --
---------------------------------------------
function FreierGeist_IT_EntryClicked(_button)
	local lineplusoffset;
	

	FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);
	
	lineplusoffset = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
	if(FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
		lineplusoffset = scrollBarHeight-lineplusoffset;
	end
		
	
	-- fill the clipboard
	FreierGeist_IT_FillClipboard();
	
	
	-- this can only happen if the list is visible (otherwise the user has clicked on the timer-window)
	if(InstanceTime_ListFrame:IsVisible()) then
		if(FreierGeist_IT_Data[lineplusoffset]["date"] ~= "") then
			if((_button == "LeftButton") and (IsControlKeyDown())) then
				if(lineplusoffset == markedIndexToMerge[1]) then
					markedIndexToMerge[1] = 0;
				elseif(lineplusoffset == markedIndexToMerge[2]) then
					markedIndexToMerge[2] = 0;
				else
					if (markedIndexToMerge[1] == 0) and (markedIndexToMerge[2] == 0) then		-- zero entries are marked
						markedIndexToMerge[1] = lineplusoffset;
					elseif (markedIndexToMerge[1] ~= 0) and (markedIndexToMerge[2] == 0) then	-- one entry is marked
						markedIndexToMerge[2] = lineplusoffset;
					elseif (markedIndexToMerge[1] == 0) and (markedIndexToMerge[2] ~= 0) then	-- one entry is marked
						markedIndexToMerge[1] = lineplusoffset;
					end
					
					if((abs(markedIndexToMerge[1] - markedIndexToMerge[2]) > 1) 
						and (markedIndexToMerge[1] ~= 0) and (markedIndexToMerge[2] ~= 0)) then
						StaticPopup_Show("MERGE_FAILED", INSTANCETIME_CHAT_ENTRY_CANT_MERGE);
						markedIndexToMerge[1] = 0;
						markedIndexToMerge[2] = 0;
						FreierGeist_IT_ScrollBarUpdate();
					elseif (markedIndexToMerge[1] ~= 0) and (markedIndexToMerge[2] ~= 0) then
						StaticPopup_Show("MERGE_ENTRIES", "\n\n"..FreierGeist_IT_Data[markedIndexToMerge[1]]["zone"].."\n+\n"..FreierGeist_IT_Data[markedIndexToMerge[2]]["zone"]);
					end
				end
			elseif(_button == "RightButton") then
				if (anEntryIsColoured == false) then
					StaticPopup_Show("DELETE_ENTRY", INSTANCETIME_CHAT_REALLY_DELETE_ENTRY_QUESTION_TEXT);
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_ENTRY_NOT_DELETED);
				end
			else
				if	(tmp_EntryDate == FreierGeist_IT_Data[lineplusoffset]["date"]) and
					(tmp_EntryStart == FreierGeist_IT_Data[lineplusoffset]["start"]) and
					(tmp_EntryStop == FreierGeist_IT_Data[lineplusoffset]["stop"]) and
					(tmp_EntryDuration == FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]) and
					(tmp_EntryMode == FreierGeist_IT_Data[lineplusoffset]["mode"]) and
					(tmp_EntryZone == FreierGeist_IT_Data[lineplusoffset]["zone"]) 	then
	
						
					if(startTime > 0) then
						FreierGeist_IT_SetXP(XP, mode, zoneName);
						FreierGeist_IT_SetReputationFraction(reputation[1], reputation[2], reputation[3], fraction[1], fraction[2], fraction[3], mode, zoneName);
						FreierGeist_IT_SetMoney(gold, silver, copper, mode, zoneName);
						FreierGeist_IT_SetMoneyRepair(gold_repair, silver_repair, copper_repair, mode, zoneName);
						FreierGeist_IT_SetDeaths(deaths, mode, zoneName);
						FreierGeist_IT_SetJusticePoints(justice_points, mode, zoneName);
						FreierGeist_IT_SetValorPoints(valor_points, mode, zoneName);
						InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_ACTUAL_TIMER);
						FreierGeist_IT_AdditionalInfo(2);
						lastSelectedEntry = 0;
					else
						FreierGeist_IT_AdditionalInfo(1);
						FreierGeist_IT_SetDefaults();
					end
					anEntryIsColoured = false;
					_instance_count = 0;
					FreierGeist_IT_SetClasses(classes);
					FreierGeist_IT_SetBosslist(bosslist);
						
					tmp_EntryDate = "";
					tmp_EntryStart = 0;
					tmp_EntryStop = 0;
					tmp_EntryDuration = "";
					tmp_EntryZone = "";
					tmp_EntryMode = INSTANCETIME_INTERN_DUNGEON_MODE1;
				else
					FreierGeist_IT_AdditionalInfo(2);
					_instance_count = instance_count;
						
					-- set the entry for use in whisper, group, etc
					FreierGeist_IT_SetDataOutput(FreierGeist_IT_Data[lineplusoffset]["date"], FreierGeist_IT_Data[lineplusoffset]["zone"], FreierGeist_IT_Data[lineplusoffset]["mode"], SecondsToTime(FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]), FreierGeist_IT_Data[lineplusoffset]["start"], FreierGeist_IT_Data[lineplusoffset]["stop"], FreierGeist_IT_Data[lineplusoffset]["XP"], FreierGeist_IT_Data[lineplusoffset]["reputation"][1], FreierGeist_IT_Data[lineplusoffset]["reputation"][2], FreierGeist_IT_Data[lineplusoffset]["reputation"][3], FreierGeist_IT_Data[lineplusoffset]["fraction"][1], FreierGeist_IT_Data[lineplusoffset]["fraction"][2], FreierGeist_IT_Data[lineplusoffset]["fraction"][3], FreierGeist_IT_Data[lineplusoffset]["gold"], FreierGeist_IT_Data[lineplusoffset]["silver"], FreierGeist_IT_Data[lineplusoffset]["copper"], FreierGeist_IT_Data[lineplusoffset]["gold_repair"], FreierGeist_IT_Data[lineplusoffset]["silver_repair"], FreierGeist_IT_Data[lineplusoffset]["copper_repair"], FreierGeist_IT_Data[lineplusoffset]["deaths"]);
						
					-- show XP and reputation according to this entry
					if(FreierGeist_IT_Data[lineplusoffset]["XP"] == nil) then FreierGeist_IT_Data[lineplusoffset]["XP"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["deaths"] == nil) then FreierGeist_IT_Data[lineplusoffset]["deaths"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["justice_points"] == nil) then FreierGeist_IT_Data[lineplusoffset]["justice_points"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["valor_points"] == nil) then FreierGeist_IT_Data[lineplusoffset]["valor_points"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["reputation"][1] == nil) then FreierGeist_IT_Data[lineplusoffset]["reputation"][1] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["reputation"][2] == nil) then FreierGeist_IT_Data[lineplusoffset]["reputation"][2] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["reputation"][3] == nil) then FreierGeist_IT_Data[lineplusoffset]["reputation"][3] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["fraction"][1] == nil) then FreierGeist_IT_Data[lineplusoffset]["fraction"][1] = "-"; end
					if(FreierGeist_IT_Data[lineplusoffset]["fraction"][2] == nil) then FreierGeist_IT_Data[lineplusoffset]["fraction"][2] = "-"; end
					if(FreierGeist_IT_Data[lineplusoffset]["fraction"][3] == nil) then FreierGeist_IT_Data[lineplusoffset]["fraction"][3] = "-"; end
					if(FreierGeist_IT_Data[lineplusoffset]["gold"] == nil) then FreierGeist_IT_Data[lineplusoffset]["gold"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["silver"] == nil) then FreierGeist_IT_Data[lineplusoffset]["silver"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["copper"] == nil) then FreierGeist_IT_Data[lineplusoffset]["copper"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["gold_repair"] == nil) then FreierGeist_IT_Data[lineplusoffset]["gold_repair"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["silver_repair"] == nil) then FreierGeist_IT_Data[lineplusoffset]["silver_repair"] = 0; end
					if(FreierGeist_IT_Data[lineplusoffset]["copper_repair"] == nil) then FreierGeist_IT_Data[lineplusoffset]["copper_repair"] = 0; end
						
					FreierGeist_IT_SetReputationFraction(FreierGeist_IT_Data[lineplusoffset]["reputation"][1], FreierGeist_IT_Data[lineplusoffset]["reputation"][2], FreierGeist_IT_Data[lineplusoffset]["reputation"][3], FreierGeist_IT_Data[lineplusoffset]["fraction"][1], FreierGeist_IT_Data[lineplusoffset]["fraction"][2], FreierGeist_IT_Data[lineplusoffset]["fraction"][3], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetXP(FreierGeist_IT_Data[lineplusoffset]["XP"], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetMoney(FreierGeist_IT_Data[lineplusoffset]["gold"], FreierGeist_IT_Data[lineplusoffset]["silver"], FreierGeist_IT_Data[lineplusoffset]["copper"], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetMoneyRepair(FreierGeist_IT_Data[lineplusoffset]["gold_repair"], FreierGeist_IT_Data[lineplusoffset]["silver_repair"], FreierGeist_IT_Data[lineplusoffset]["copper_repair"], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetDeaths(FreierGeist_IT_Data[lineplusoffset]["deaths"], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetJusticePoints(FreierGeist_IT_Data[lineplusoffset]["justice_points"], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetValorPoints(FreierGeist_IT_Data[lineplusoffset]["valor_points"], FreierGeist_IT_Data[lineplusoffset]["mode"], FreierGeist_IT_Data[lineplusoffset]["zone"]);
					FreierGeist_IT_SetClasses(FreierGeist_IT_Data[lineplusoffset]["classes"]);
					FreierGeist_IT_SetBosslist(FreierGeist_IT_Data[lineplusoffset]["bosslist"]);
										
					InstanceTime_ListFrameButtonTellActual:Show();
					InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_SELECTED_ENTRY);
					InstanceTime_ListFrameButtonTellAll:Show();
					InstanceTime_ListFrameButtonTellAll:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_SUMMARY);
											
					-- set tmp_'...' to remember that an entry is coloured
					lastSelectedEntry = selectedEntry;
					anEntryIsColoured = true;
					tmp_EntryDate = FreierGeist_IT_Data[lineplusoffset]["date"];
					tmp_EntryStart = FreierGeist_IT_Data[lineplusoffset]["start"];
					tmp_EntryStop = FreierGeist_IT_Data[lineplusoffset]["stop"];
					tmp_EntryDuration = FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"];
					tmp_EntryMode = FreierGeist_IT_Data[lineplusoffset]["mode"];
					tmp_EntryZone = FreierGeist_IT_Data[lineplusoffset]["zone"];
				end
			end
		end
	end
	
	FreierGeist_IT_ScrollBarUpdate();
	FreierGeist_IT_LootScrollBarUpdate();
end


----------------------------------------------
--      button tell all was clicked         --
----------------------------------------------
function FreierGeist_IT_ButtonTellAllClicked()
	_postAllOfThisInstance = 1;
	FreierGeist_IT_SetDataOutput("", all_zone, all_mode, "", "", "", all_xp, all_reputation[1], all_reputation[2], all_reputation[3], all_fraction[1], all_fraction[2], all_fraction[3], all_gold, all_silver, all_copper, all_gold_repair, all_silver_repair, all_copper_repair, all_deaths);
end


-------------------------------------------------
--      button tell actual was clicked         --
-------------------------------------------------
function FreierGeist_IT_ButtonTellActualClicked()
	local lineplusoffset;
	
	
	_postAllOfThisInstance = 0;
	
	if(startTime == 0) then
		FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);
		
		lineplusoffset = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			lineplusoffset = scrollBarHeight-lineplusoffset;
		end
		FreierGeist_IT_SetDataOutput(FreierGeist_IT_Data[lineplusoffset]["date"], FreierGeist_IT_Data[lineplusoffset]["zone"], FreierGeist_IT_Data[lineplusoffset]["mode"], SecondsToTime(FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]), FreierGeist_IT_Data[lineplusoffset]["start"], FreierGeist_IT_Data[lineplusoffset]["stop"], FreierGeist_IT_Data[lineplusoffset]["XP"], FreierGeist_IT_Data[lineplusoffset]["reputation"][1], FreierGeist_IT_Data[lineplusoffset]["reputation"][2], FreierGeist_IT_Data[lineplusoffset]["reputation"][3], FreierGeist_IT_Data[lineplusoffset]["fraction"][1], FreierGeist_IT_Data[lineplusoffset]["fraction"][2], FreierGeist_IT_Data[lineplusoffset]["fraction"][3], FreierGeist_IT_Data[lineplusoffset]["gold"], FreierGeist_IT_Data[lineplusoffset]["silver"], FreierGeist_IT_Data[lineplusoffset]["copper"], FreierGeist_IT_Data[lineplusoffset]["gold_repair"], FreierGeist_IT_Data[lineplusoffset]["silver_repair"], FreierGeist_IT_Data[lineplusoffset]["copper_repair"], FreierGeist_IT_Data[lineplusoffset]["deaths"]);
	end
end


-------------------------------------------------
--     sort class entries by _attribute        --
-------------------------------------------------
function FreierGeist_IT_SortClassList(_attribute)
	local endSorted, elementToInsertDate, elementToInsertStart, elementToInsertStop, elementToInsertStarttime;
	local elementToInsertStoptime, elementToInsertZone, elementToInsertMode, elementToInsertDeaths;
	local elementToInsertJusticePoints, elementToInsertValorPoints;
	local elementToInsertXP, elementToInsertReputation1, elementToInsertReputation2, elementToInsertReputation3;
	local elementToInsertFraction1, elementToInsertFraction2, elementToInsertFraction3;
	local elementToInsertGold, elementToInsertSilver, elementToInsertCopper, elementToInsertClasses, elementToInsertBosslist;
	local elementToInsertGoldRepair, elementToInsertSilverRepair, elementToInsertCopperRepair;
	local elementToInsertLootIndex, elementToInsertLootItem, elementToInsertLootUnit, elementToInsertLootPlayer;
	

	for loop=1, scrollBarHeight-1 do
		elementToInsertDate = FreierGeist_IT_Data[loop]["date"];
		elementToInsertStart = FreierGeist_IT_Data[loop]["start"];
		elementToInsertStop = FreierGeist_IT_Data[loop]["stop"];
		elementToInsertStarttime = FreierGeist_IT_Data[loop]["starttime"];
		elementToInsertStoptime = FreierGeist_IT_Data[loop]["stoptime"];
		elementToInsertZone = FreierGeist_IT_Data[loop]["zone"];
		elementToInsertMode = FreierGeist_IT_Data[loop]["mode"];
		elementToInsertXP = FreierGeist_IT_Data[loop]["XP"];
		elementToInsertDeaths = FreierGeist_IT_Data[loop]["deaths"];
		elementToInsertJusticePoints = FreierGeist_IT_Data[loop]["justice_points"];
		elementToInsertValorPoints = FreierGeist_IT_Data[loop]["valor_points"];
		elementToInsertReputation1 = FreierGeist_IT_Data[loop]["reputation"][1];
		elementToInsertReputation2 = FreierGeist_IT_Data[loop]["reputation"][2];
		elementToInsertReputation3 = FreierGeist_IT_Data[loop]["reputation"][3];
		elementToInsertFraction1 = FreierGeist_IT_Data[loop]["fraction"][1];
		elementToInsertFraction2 = FreierGeist_IT_Data[loop]["fraction"][2];
		elementToInsertFraction3 = FreierGeist_IT_Data[loop]["fraction"][3];
		elementToInsertGold = FreierGeist_IT_Data[loop]["gold"];
		elementToInsertSilver = FreierGeist_IT_Data[loop]["silver"];
		elementToInsertCopper = FreierGeist_IT_Data[loop]["copper"];
		elementToInsertGoldRepair = FreierGeist_IT_Data[loop]["gold_repair"];
		elementToInsertSilverRepair = FreierGeist_IT_Data[loop]["silver_repair"];
		elementToInsertCopperRepair = FreierGeist_IT_Data[loop]["copper_repair"];
		elementToInsertClasses = FreierGeist_IT_Data[loop]["classes"];
		elementToInsertBosslist = FreierGeist_IT_Data[loop]["bosslist"];
		elementToInsertLootIndex = FreierGeist_IT_Loot["index"][loop];
		elementToInsertLootItem = FreierGeist_IT_Loot["item"][loop];
		elementToInsertLootUnit = FreierGeist_IT_Loot["unit"][loop];
		elementToInsertLootPlayer = FreierGeist_IT_Loot["player"][loop];
		endSorted = loop;

	
		local compareTo = "";
		if(_attribute == "date") then
			compareTo = FreierGeist_IT_ConvertDateToNumbers(FreierGeist_IT_Data[loop]["date"]);
		elseif(_attribute == "start") then
			compareTo = elementToInsertStart;
		elseif(_attribute == "stop") then
			compareTo = elementToInsertStop;
		elseif(_attribute == "duration") then
			compareTo = FreierGeist_IT_Data[loop]["stoptime"] - FreierGeist_IT_Data[loop]["starttime"];	
		elseif(_attribute == "mode") then
			compareTo = elementToInsertMode;
		elseif(_attribute == "zone") then
			compareTo = elementToInsertZone;
		end


		local elementToCompare = "";
		if(endSorted > 1) then
			if(_attribute == "duration") then
				elementToCompare = FreierGeist_IT_Data[endSorted-1]["stoptime"] - FreierGeist_IT_Data[endSorted-1]["starttime"];		
			elseif(_attribute == "date") then
				elementToCompare = FreierGeist_IT_ConvertDateToNumbers(FreierGeist_IT_Data[endSorted-1][_attribute]);
			else
				elementToCompare = FreierGeist_IT_Data[endSorted-1][_attribute];
			end
		end

		if(sorted[_attribute]) then
			while( (endSorted > 1) and (elementToCompare > compareTo) ) do
				FreierGeist_IT_Data[endSorted]["date"] = FreierGeist_IT_Data[endSorted-1]["date"];
				FreierGeist_IT_Data[endSorted]["start"] = FreierGeist_IT_Data[endSorted-1]["start"];
				FreierGeist_IT_Data[endSorted]["stop"] = FreierGeist_IT_Data[endSorted-1]["stop"];
				FreierGeist_IT_Data[endSorted]["starttime"] = FreierGeist_IT_Data[endSorted-1]["starttime"];
				FreierGeist_IT_Data[endSorted]["stoptime"] = FreierGeist_IT_Data[endSorted-1]["stoptime"];
				FreierGeist_IT_Data[endSorted]["zone"] = FreierGeist_IT_Data[endSorted-1]["zone"];
				FreierGeist_IT_Data[endSorted]["mode"] = FreierGeist_IT_Data[endSorted-1]["mode"];
				FreierGeist_IT_Data[endSorted]["XP"] = FreierGeist_IT_Data[endSorted-1]["XP"];
				FreierGeist_IT_Data[endSorted]["deaths"] = FreierGeist_IT_Data[endSorted-1]["deaths"];
				FreierGeist_IT_Data[endSorted]["justice_points"] = FreierGeist_IT_Data[endSorted-1]["justice_points"];
				FreierGeist_IT_Data[endSorted]["valor_points"] = FreierGeist_IT_Data[endSorted-1]["valor_points"];
				FreierGeist_IT_Data[endSorted]["reputation"][1] = FreierGeist_IT_Data[endSorted-1]["reputation"][1];
				FreierGeist_IT_Data[endSorted]["reputation"][2] = FreierGeist_IT_Data[endSorted-1]["reputation"][2];
				FreierGeist_IT_Data[endSorted]["reputation"][3] = FreierGeist_IT_Data[endSorted-1]["reputation"][3];
				FreierGeist_IT_Data[endSorted]["fraction"][1] = FreierGeist_IT_Data[endSorted-1]["fraction"][1];
				FreierGeist_IT_Data[endSorted]["fraction"][2] = FreierGeist_IT_Data[endSorted-1]["fraction"][2];
				FreierGeist_IT_Data[endSorted]["fraction"][3] = FreierGeist_IT_Data[endSorted-1]["fraction"][3];
				FreierGeist_IT_Data[endSorted]["gold"] = FreierGeist_IT_Data[endSorted-1]["gold"];
				FreierGeist_IT_Data[endSorted]["silver"] = FreierGeist_IT_Data[endSorted-1]["silver"];
				FreierGeist_IT_Data[endSorted]["copper"] = FreierGeist_IT_Data[endSorted-1]["copper"];
				FreierGeist_IT_Data[endSorted]["gold_repair"] = FreierGeist_IT_Data[endSorted-1]["gold_repair"];
				FreierGeist_IT_Data[endSorted]["silver_repair"] = FreierGeist_IT_Data[endSorted-1]["silver_repair"];
				FreierGeist_IT_Data[endSorted]["copper_repair"] = FreierGeist_IT_Data[endSorted-1]["copper_repair"];
				FreierGeist_IT_Data[endSorted]["classes"] = FreierGeist_IT_Data[endSorted-1]["classes"];
				FreierGeist_IT_Data[endSorted]["bosslist"] = FreierGeist_IT_Data[endSorted-1]["bosslist"];
				
				-- correct also all of the FreierGeist_IT_Loot array
				FreierGeist_IT_Loot["index"][endSorted] = FreierGeist_IT_Loot["index"][endSorted-1];
				FreierGeist_IT_Loot["item"][endSorted] = FreierGeist_IT_Loot["item"][endSorted-1];
				FreierGeist_IT_Loot["unit"][endSorted] = FreierGeist_IT_Loot["unit"][endSorted-1];
				FreierGeist_IT_Loot["player"][endSorted] = FreierGeist_IT_Loot["player"][endSorted-1];
		
			 	endSorted = endSorted-1;
			 	if(endSorted > 1) then
				 	if(_attribute == "duration") then
						elementToCompare = FreierGeist_IT_Data[endSorted-1]["stoptime"] - FreierGeist_IT_Data[endSorted-1]["starttime"];
					elseif(_attribute == "date") then
						elementToCompare = FreierGeist_IT_ConvertDateToNumbers(FreierGeist_IT_Data[endSorted-1][_attribute]);
					else
						elementToCompare = FreierGeist_IT_Data[endSorted-1][_attribute];
					end
				end
			end
		else
			while( (endSorted > 1) and (elementToCompare < compareTo) ) do
				FreierGeist_IT_Data[endSorted]["date"] = FreierGeist_IT_Data[endSorted-1]["date"];
				FreierGeist_IT_Data[endSorted]["start"] = FreierGeist_IT_Data[endSorted-1]["start"];
				FreierGeist_IT_Data[endSorted]["stop"] = FreierGeist_IT_Data[endSorted-1]["stop"];
				FreierGeist_IT_Data[endSorted]["starttime"] = FreierGeist_IT_Data[endSorted-1]["starttime"];
				FreierGeist_IT_Data[endSorted]["stoptime"] = FreierGeist_IT_Data[endSorted-1]["stoptime"];
				FreierGeist_IT_Data[endSorted]["zone"] = FreierGeist_IT_Data[endSorted-1]["zone"];
				FreierGeist_IT_Data[endSorted]["mode"] = FreierGeist_IT_Data[endSorted-1]["mode"];
				FreierGeist_IT_Data[endSorted]["XP"] = FreierGeist_IT_Data[endSorted-1]["XP"];
				FreierGeist_IT_Data[endSorted]["deaths"] = FreierGeist_IT_Data[endSorted-1]["deaths"];
				FreierGeist_IT_Data[endSorted]["justice_points"] = FreierGeist_IT_Data[endSorted-1]["justice_points"];
				FreierGeist_IT_Data[endSorted]["valor_points"] = FreierGeist_IT_Data[endSorted-1]["valor_points"];
				FreierGeist_IT_Data[endSorted]["reputation"][1] = FreierGeist_IT_Data[endSorted-1]["reputation"][1];
				FreierGeist_IT_Data[endSorted]["reputation"][2] = FreierGeist_IT_Data[endSorted-1]["reputation"][2];
				FreierGeist_IT_Data[endSorted]["reputation"][3] = FreierGeist_IT_Data[endSorted-1]["reputation"][3];
				FreierGeist_IT_Data[endSorted]["fraction"][1] = FreierGeist_IT_Data[endSorted-1]["fraction"][1];
				FreierGeist_IT_Data[endSorted]["fraction"][2] = FreierGeist_IT_Data[endSorted-1]["fraction"][2];
				FreierGeist_IT_Data[endSorted]["fraction"][3] = FreierGeist_IT_Data[endSorted-1]["fraction"][3];
				FreierGeist_IT_Data[endSorted]["gold"] = FreierGeist_IT_Data[endSorted-1]["gold"];
				FreierGeist_IT_Data[endSorted]["silver"] = FreierGeist_IT_Data[endSorted-1]["silver"];
				FreierGeist_IT_Data[endSorted]["copper"] = FreierGeist_IT_Data[endSorted-1]["copper"];
				FreierGeist_IT_Data[endSorted]["gold_repair"] = FreierGeist_IT_Data[endSorted-1]["gold_repair"];
				FreierGeist_IT_Data[endSorted]["silver_repair"] = FreierGeist_IT_Data[endSorted-1]["silver_repair"];
				FreierGeist_IT_Data[endSorted]["copper_repair"] = FreierGeist_IT_Data[endSorted-1]["copper_repair"];
				FreierGeist_IT_Data[endSorted]["classes"] = FreierGeist_IT_Data[endSorted-1]["classes"];
				FreierGeist_IT_Data[endSorted]["bosslist"] = FreierGeist_IT_Data[endSorted-1]["bosslist"];
			 				 	
			 	-- correct also all of the FreierGeist_IT_Loot array
			 	FreierGeist_IT_Loot["index"][endSorted] = FreierGeist_IT_Loot["index"][endSorted-1];
				FreierGeist_IT_Loot["item"][endSorted] = FreierGeist_IT_Loot["item"][endSorted-1];
				FreierGeist_IT_Loot["unit"][endSorted] = FreierGeist_IT_Loot["unit"][endSorted-1];
				FreierGeist_IT_Loot["player"][endSorted] = FreierGeist_IT_Loot["player"][endSorted-1];
				
				endSorted = endSorted-1;
			 	if(endSorted > 1) then
				 	if(_attribute == "duration") then
						elementToCompare = FreierGeist_IT_Data[endSorted-1]["stoptime"] - FreierGeist_IT_Data[endSorted-1]["starttime"];
					elseif(_attribute == "date") then
						elementToCompare = FreierGeist_IT_ConvertDateToNumbers(FreierGeist_IT_Data[endSorted-1][_attribute]);
					else
						elementToCompare = FreierGeist_IT_Data[endSorted-1][_attribute];
					end
				end
			end
		end
		
		
		FreierGeist_IT_Data[endSorted]["date"] = elementToInsertDate;
		FreierGeist_IT_Data[endSorted]["start"] = elementToInsertStart;
		FreierGeist_IT_Data[endSorted]["stop"] = elementToInsertStop;
		FreierGeist_IT_Data[endSorted]["starttime"] = elementToInsertStarttime;
		FreierGeist_IT_Data[endSorted]["stoptime"] = elementToInsertStoptime;
		FreierGeist_IT_Data[endSorted]["zone"] = elementToInsertZone;
		FreierGeist_IT_Data[endSorted]["mode"] = elementToInsertMode;
		FreierGeist_IT_Data[endSorted]["XP"] = elementToInsertXP;
		FreierGeist_IT_Data[endSorted]["deaths"] = elementToInsertDeaths;
		FreierGeist_IT_Data[endSorted]["justice_points"] = elementToInsertJusticePoints;
		FreierGeist_IT_Data[endSorted]["valor_points"] = elementToInsertValorPoints;
		FreierGeist_IT_Data[endSorted]["reputation"][1] = elementToInsertReputation1;
		FreierGeist_IT_Data[endSorted]["reputation"][2] = elementToInsertReputation2;
		FreierGeist_IT_Data[endSorted]["reputation"][3] = elementToInsertReputation3;
		FreierGeist_IT_Data[endSorted]["fraction"][1] = elementToInsertFraction1;
		FreierGeist_IT_Data[endSorted]["fraction"][2] = elementToInsertFraction2;
		FreierGeist_IT_Data[endSorted]["fraction"][3] = elementToInsertFraction3;
		FreierGeist_IT_Data[endSorted]["gold"] = elementToInsertGold;
		FreierGeist_IT_Data[endSorted]["silver"] = elementToInsertSilver;
		FreierGeist_IT_Data[endSorted]["copper"] = elementToInsertCopper;
		FreierGeist_IT_Data[endSorted]["gold_repair"] = elementToInsertGoldRepair;
		FreierGeist_IT_Data[endSorted]["silver_repair"] = elementToInsertSilverRepair;
		FreierGeist_IT_Data[endSorted]["copper_repair"] = elementToInsertCopperRepair;
		FreierGeist_IT_Data[endSorted]["classes"] = elementToInsertClasses;
		FreierGeist_IT_Data[endSorted]["bosslist"] = elementToInsertBosslist;
		
		-- correct also all of the FreierGeist_IT_Loot array
		FreierGeist_IT_Loot["index"][endSorted] = elementToInsertLootIndex;
		FreierGeist_IT_Loot["item"][endSorted] = elementToInsertLootItem;
		FreierGeist_IT_Loot["unit"][endSorted] = elementToInsertLootUnit;
		FreierGeist_IT_Loot["player"][endSorted] = elementToInsertLootPlayer;
	end
	

	-- reverse for next sorting
	sorted[_attribute] = not sorted[_attribute];
end


----------------------------------------------
--          correct some zone text          --
----------------------------------------------
function FreierGeist_IT_CorrectZone(_ini_name)
	if(string.find(_ini_name, INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_TO_CORRECT_DEADMINES)) then
		zoneName = INSTANCETIME_INSTANCE_MINIMAP_ZONE_TEXT_CORRECTED_DEADMINES;
	else
		zoneName = _ini_name;
	end
	
	return zoneName
end


---------------------------------------
--      set the stopTime to 0        --
---------------------------------------
function FreierGeist_IT_ResetStopTime()
	stopTime = 0;
	
	-- fubar extention
	if(InstanceTimeFu) then
		InstanceTimeFu:OnTextUpdate();
	end
end


----------------------------------------
--      set the startTime to 0        --
----------------------------------------
function FreierGeist_IT_ResetStartTime()
	startTime = 0;
	
	-- fubar extention
	if(InstanceTimeFu) then
		InstanceTimeFu:OnTextUpdate();
	end
end


--------------------------------------
--     return the startTime         --
--------------------------------------
function FreierGeist_IT_GetStartTime()
	return startTime;
end


--------------------------------------------------
--      toggle reputation and fraction          --
--------------------------------------------------
function FreierGeist_IT_ToggleReputationFraction()
	if(InstanceTime_ListFrameTextReputation1:IsShown()) then
		InstanceTime_ListFrameTextReputation1:Hide();
		InstanceTime_ListFrameTextReputation2:Show();
		InstanceTime_ListFrameTextReputation3:Hide();
		InstanceTime_ListFrameTextReputation1All:Hide();
		InstanceTime_ListFrameTextReputation2All:Show();
		InstanceTime_ListFrameTextReputation3All:Hide();
		InstanceTime_ListFrameTextFraction1:Hide();
		InstanceTime_ListFrameTextFraction2:Show();
		InstanceTime_ListFrameTextFraction3:Hide();
	elseif(InstanceTime_ListFrameTextReputation2:IsShown() and InstanceTime_TimerFrameRepTextReputation3:IsShown()) then
		InstanceTime_ListFrameTextReputation1:Hide();
		InstanceTime_ListFrameTextReputation2:Hide();
		InstanceTime_ListFrameTextReputation3:Show();
		InstanceTime_ListFrameTextReputation1All:Hide();
		InstanceTime_ListFrameTextReputation2All:Hide();
		InstanceTime_ListFrameTextReputation3All:Show();
		InstanceTime_ListFrameTextFraction1:Hide();
		InstanceTime_ListFrameTextFraction2:Hide();
		InstanceTime_ListFrameTextFraction3:Show();
	else
		InstanceTime_ListFrameTextReputation1:Show();
		InstanceTime_ListFrameTextReputation2:Hide();		
		InstanceTime_ListFrameTextReputation3:Hide();
		InstanceTime_ListFrameTextReputation1All:Show();
		InstanceTime_ListFrameTextReputation2All:Hide();
		InstanceTime_ListFrameTextReputation3All:Hide();
		InstanceTime_ListFrameTextFraction1:Show();
		InstanceTime_ListFrameTextFraction2:Hide();
		InstanceTime_ListFrameTextFraction3:Hide();
	end
end


------------------------------------------------
--                   set XP                   --
------------------------------------------------
function FreierGeist_IT_SetXP(_XP, _mode, _zone)
	all_xp = 0;
	all_zone = "";
	all_mode = "";
	

	if(InstanceTime_ListFrameTextXP ~= nil) then
		InstanceTime_ListFrameTextXP:SetText("|cccffffff".._XP.."|r");
	end
	if(InstanceTime_TimerFrameXPTextXPData ~= nil) then
		InstanceTime_TimerFrameXPTextXPData:SetText(_XP);
	end
	
	if(InstanceTime_ListFrameTextXPAll ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if(FreierGeist_IT_Data[tmp_line]["XP"] ~= nil) then
					all_xp = all_xp + FreierGeist_IT_Data[tmp_line]["XP"];
				end
			end
			
			-- set also all_zone and all_mode
			all_zone = _zone;
			all_mode = _mode;
		end
		
		if(startTime > 0 and startTime ~= nil) then
			all_xp = all_xp + _XP;
		end
		
		InstanceTime_ListFrameTextXPAll:SetText("|cccffffff"..all_xp.."|r");
	end
end


---------------------------------------------------------------------
--                  set reputation and fraction                    --
---------------------------------------------------------------------
function FreierGeist_IT_SetReputationFraction(_reputation1, _reputation2, _reputation3, _fraction1, _fraction2, _fraction3, _mode, _zone)
	all_reputation[1] = 0;
	all_reputation[2] = 0;
	all_reputation[3] = 0;
	all_fraction[1] = "-";
	all_fraction[2] = "-";
	all_fraction[3] = "-";
	local myReputationString = "";
	
	
	-- to prevent errors
	if(_reputation1 == nil) then _reputation1 = 0; end
	if(_reputation2 == nil) then _reputation2 = 0; end
	if(_reputation3 == nil) then _reputation3 = 0; end
	if(_fraction1 == nil) then _fraction1 = "-"; end
	if(_fraction2 == nil) then _fraction2 = "-"; end
	if(_fraction3 == nil) then _fraction3 = "-"; end
	
	
	-- search all entries for the same instance-name and lookup the faction
	-- (This is done only if the player didn't get reputation in the current run.)
	if(_fraction1 == "-") then
	
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if(FreierGeist_IT_Data[tmp_line]["zone"] == _zone) then
				if(FreierGeist_IT_Data[tmp_line]["fraction"][3] ~= nil) then
					_fraction3 = FreierGeist_IT_Data[tmp_line]["fraction"][3];
				end
				if(FreierGeist_IT_Data[tmp_line]["fraction"][2] ~= nil) then
					_fraction2 = FreierGeist_IT_Data[tmp_line]["fraction"][2];
				end
				if(FreierGeist_IT_Data[tmp_line]["fraction"][1] ~= nil) then
					_fraction1 = FreierGeist_IT_Data[tmp_line]["fraction"][1];
					break;
				end
			end
		end	
	end

	
	-- hide the second and third fraction
	InstanceTime_ListFrameTextFraction2:Hide();
	InstanceTime_ListFrameTextReputation2:Hide();
	InstanceTime_ListFrameTextReputation2All:Hide();
	InstanceTime_ListFrameTextFraction3:Hide();
	InstanceTime_ListFrameTextReputation3:Hide();
	InstanceTime_ListFrameTextReputation3All:Hide();
	
	
	if(_fraction3 ~= "-") then	-- we have 3 fractions
		-- show the ">>" button
		InstanceTime_ListFrameButtonMoreReputation:Show();
		InstanceTime_TimerFrameRep:SetHeight(65);
		InstanceTime_TimerFrameRepTextReputation2:Show();
		InstanceTime_TimerFrameRepTextReputation2Data:Show();
		InstanceTime_TimerFrameRepTextReputation3:Show();
		InstanceTime_TimerFrameRepTextReputation3Data:Show();
	elseif(_fraction2 ~= "-") then	-- we have 2 fractions
		-- show the ">>" button
		InstanceTime_ListFrameButtonMoreReputation:Show();
		InstanceTime_TimerFrameRep:SetHeight(45);
		InstanceTime_TimerFrameRepTextReputation2:Show();
		InstanceTime_TimerFrameRepTextReputation2Data:Show();
		InstanceTime_TimerFrameRepTextReputation3:Hide();
		InstanceTime_TimerFrameRepTextReputation3Data:Hide();
	else				-- we have 1 fraction
		-- hide the ">>" button
		InstanceTime_ListFrameButtonMoreReputation:Hide();
		InstanceTime_TimerFrameRep:SetHeight(25);
		InstanceTime_TimerFrameRepTextReputation2:Hide();
		InstanceTime_TimerFrameRepTextReputation2Data:Hide();
		InstanceTime_TimerFrameRepTextReputation3:Hide();
		InstanceTime_TimerFrameRepTextReputation3Data:Hide();
	end
	

	
	-- set first reputation / fraction
	if(InstanceTime_ListFrameTextReputation1 ~= nil) then
		myReputationString = "|cccffffff".._reputation1.."  |r|cccdd8833";
		if(race == INSTANCETIME_MAIN_STRING_HUMAN) then
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((_reputation1/(1.1))+0.5)..")|r";
		else
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((_reputation1/(1.1))+0.5)..")|r";
		end	
		InstanceTime_ListFrameTextReputation1:SetText(myReputationString);
	end
	if(InstanceTime_TimerFrameRepTextReputation1Data ~= nil) then
		InstanceTime_TimerFrameRepTextReputation1Data:SetText(_reputation1);
	end
	if(InstanceTime_ListFrameTextFraction1 ~= nil) then
		InstanceTime_ListFrameTextFraction1:SetText("|cccffffff".._fraction1.."|r");
	end
	
	-- set second reputation / fraction			
	if(InstanceTime_ListFrameTextReputation2 ~= nil) then
		myReputationString = "|cccffffff".._reputation2.."  |r|cccdd8833";
		if(race == INSTANCETIME_MAIN_STRING_HUMAN) then
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((_reputation2/(1.1))+0.5)..")|r";
		else
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((_reputation2/(1.1))+0.5)..")|r";
		end
		InstanceTime_ListFrameTextReputation2:SetText(myReputationString);
	end
	if(InstanceTime_TimerFrameRepTextReputation2Data ~= nil) then
		InstanceTime_TimerFrameRepTextReputation2Data:SetText(_reputation2);
	end
	if(InstanceTime_ListFrameTextFraction2 ~= nil) then
		InstanceTime_ListFrameTextFraction2:SetText("|cccffffff".._fraction2.."|r");
	end
	
	-- set third reputation / fraction			
	if(InstanceTime_ListFrameTextReputation3 ~= nil) then
		myReputationString = "|cccffffff".._reputation3.."  |r|cccdd8833";
		if(race == INSTANCETIME_MAIN_STRING_HUMAN) then
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((_reputation3/(1.1))+0.5)..")|r";
		else
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((_reputation3/(1.1))+0.5)..")|r";
		end
		InstanceTime_ListFrameTextReputation3:SetText(myReputationString);
	end
	if(InstanceTime_TimerFrameRepTextReputation3Data ~= nil) then
		InstanceTime_TimerFrameRepTextReputation3Data:SetText(_reputation3);
	end
	if(InstanceTime_ListFrameTextFraction3 ~= nil) then
		InstanceTime_ListFrameTextFraction3:SetText("|cccffffff".._fraction3.."|r");
	end
	
	
	if(InstanceTime_ListFrameTextReputation1All ~= nil and InstanceTime_ListFrameTextReputation2All ~= nil
		and InstanceTime_ListFrameTextReputation3All ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if((FreierGeist_IT_Data[tmp_line]["reputation"][1] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["reputation"][2] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["reputation"][3] ~= nil)) then
					all_reputation[1] = all_reputation[1] + FreierGeist_IT_Data[tmp_line]["reputation"][1];
					all_reputation[2] = all_reputation[2] + FreierGeist_IT_Data[tmp_line]["reputation"][2];
					all_reputation[3] = all_reputation[3] + FreierGeist_IT_Data[tmp_line]["reputation"][3];
				end
				
				-- set also all_fraction
				if(FreierGeist_IT_Data[tmp_line]["fraction"][1] ~= nil) then 
					all_fraction[1] = FreierGeist_IT_Data[tmp_line]["fraction"][1];
				end
				if(FreierGeist_IT_Data[tmp_line]["fraction"][2] ~= nil) then
					all_fraction[2] = FreierGeist_IT_Data[tmp_line]["fraction"][2];
				end
				if(FreierGeist_IT_Data[tmp_line]["fraction"][3] ~= nil) then
					all_fraction[3] = FreierGeist_IT_Data[tmp_line]["fraction"][3];
				end
			end
		end
		if(startTime > 0 and startTime ~= nil) then
			all_reputation[1] = all_reputation[1] + _reputation1;
			all_reputation[2] = all_reputation[2] + _reputation2;
			all_reputation[3] = all_reputation[3] + _reputation3;
		end
		
		
		myReputationString = "|cccffffff"..all_reputation[1].."  |r|cccdd8833";
		if(race == INSTANCETIME_MAIN_STRING_HUMAN) then
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((all_reputation[1]/(1.1))+0.5)..")|r";
		else
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((all_reputation[1]/(1.1))+0.5)..")|r";
		end
		InstanceTime_ListFrameTextReputation1All:SetText(myReputationString);
		
		
		myReputationString = "|cccffffff"..all_reputation[2].."  |r|cccdd8833";
		if(race == INSTANCETIME_MAIN_STRING_HUMAN) then
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((all_reputation[2]/(1.1))+0.5)..")|r";
		else
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((all_reputation[2]/(1.1))+0.5)..")|r";
		end
		InstanceTime_ListFrameTextReputation2All:SetText(myReputationString);
		
		
		myReputationString = "|cccffffff"..all_reputation[3].."  |r|cccdd8833";
		if(race == INSTANCETIME_MAIN_STRING_HUMAN) then
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((all_reputation[3]/(1.1))+0.5)..")|r";
		else
			myReputationString = myReputationString.."   ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((all_reputation[3]/(1.1))+0.5)..")|r";
		end
		InstanceTime_ListFrameTextReputation3All:SetText(myReputationString);
	end
end


-----------------------------------------------------------------------
--                             set money                             --
-----------------------------------------------------------------------
function FreierGeist_IT_SetMoney(_gold, _silver, _copper, _mode, _zone)
	all_gold = 0;
	all_silver = 0;
	all_copper = 0;


	if(InstanceTime_ListFrameTextMoney ~= nil) then
		InstanceTime_ListFrameTextMoney:SetText("     ".."|cccffffff".._gold.."|r "..INSTANCETIME_MAIN_MONEY_GOLD.."     |cccffffff".._silver.."|r |cccaaaaaa"..INSTANCETIME_MAIN_MONEY_SILVER.."|r     |cccffffff".._copper.."|r ".."|cccdd8833"..INSTANCETIME_MAIN_MONEY_COPPER.."|r");
	end
	
	if(InstanceTime_ListFrameTextMoneyAll ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if((FreierGeist_IT_Data[tmp_line]["gold"] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["silver"] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["copper"] ~= nil)) then
					all_gold = all_gold + FreierGeist_IT_Data[tmp_line]["gold"];
					all_silver = all_silver + FreierGeist_IT_Data[tmp_line]["silver"];
					all_copper = all_copper + FreierGeist_IT_Data[tmp_line]["copper"];
				end
			end
		end

		if(startTime > 0 and startTime ~= nil) then
			all_gold = all_gold + _gold;
			all_silver = all_silver + _silver;
			all_copper = all_copper + _copper;
		end
		
		-- correct gold, silver, copper
		while (all_copper >= 100) do
			all_silver = all_silver + 1;
			all_copper = all_copper - 100;
		end
		while (all_silver >= 100) do
			all_gold = all_gold + 1;
			all_silver = all_silver - 100;
		end
		InstanceTime_ListFrameTextMoneyAll:SetText("     ".."|cccffffff"..all_gold.."|r "..INSTANCETIME_MAIN_MONEY_GOLD.."     |cccffffff"..all_silver.."|r |cccaaaaaa"..INSTANCETIME_MAIN_MONEY_SILVER.."|r     |cccffffff"..all_copper.."|r |cccdd8833"..INSTANCETIME_MAIN_MONEY_COPPER.."|r");
	end
end



--------------------------------------------------------------------------------------------------
--                 		               set money repair                                         --
--------------------------------------------------------------------------------------------------
function FreierGeist_IT_SetMoneyRepair(_gold_repair, _silver_repair, _copper_repair, _mode, _zone)
	all_gold_repair = 0;
	all_silver_repair = 0;
	all_copper_repair = 0;
	


	if(InstanceTime_ListFrameTextMoneyRepair ~= nil) then
		InstanceTime_ListFrameTextMoneyRepair:SetText("     ".."|cccffffff".._gold_repair.."|r "..INSTANCETIME_MAIN_MONEY_GOLD.."     |cccffffff".._silver_repair.."|r |cccaaaaaa"..INSTANCETIME_MAIN_MONEY_SILVER.."|r     |cccffffff".._copper_repair.."|r ".."|cccdd8833"..INSTANCETIME_MAIN_MONEY_COPPER.."|r");
	end
	
	if(InstanceTime_ListFrameTextMoneyRepairAll ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if((FreierGeist_IT_Data[tmp_line]["gold_repair"] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["silver_repair"] ~= nil)
				and (FreierGeist_IT_Data[tmp_line]["copper_repair"] ~= nil)) then
					all_gold_repair = all_gold_repair + FreierGeist_IT_Data[tmp_line]["gold_repair"];
					all_silver_repair = all_silver_repair + FreierGeist_IT_Data[tmp_line]["silver_repair"];
					all_copper_repair = all_copper_repair + FreierGeist_IT_Data[tmp_line]["copper_repair"];
				end
			end
		end

		if(startTime > 0 and startTime ~= nil) then
			all_gold_repair = all_gold_repair + _gold_repair;
			all_silver_repair = all_silver_repair + _silver_repair;
			all_copper_repair = all_copper_repair + _copper_repair;
		end
		
		-- correct gold, silver, copper
		while (all_copper_repair >= 100) do
			all_silver_repair = all_silver_repair + 1;
			all_copper_repair = all_copper_repair - 100;
		end
		while (all_silver_repair >= 100) do
			all_gold_repair = all_gold_repair + 1;
			all_silver_repair = all_silver_repair - 100;
		end
		InstanceTime_ListFrameTextMoneyRepairAll:SetText("     ".."|cccffffff"..all_gold_repair.."|r "..INSTANCETIME_MAIN_MONEY_GOLD.."     |cccffffff"..all_silver_repair.."|r |cccaaaaaa"..INSTANCETIME_MAIN_MONEY_SILVER.."|r     |cccffffff"..all_copper_repair.."|r |cccdd8833"..INSTANCETIME_MAIN_MONEY_COPPER.."|r");
	end
end



--------------------------------------------------------
--                     set deaths                     --
--------------------------------------------------------
function FreierGeist_IT_SetDeaths(_number, _mode, _zone)
	all_deaths = 0;
	

	-- set deaths from the single instance
	if(InstanceTime_ListFrameTextDeaths ~= nil) then
		InstanceTime_ListFrameTextDeaths:SetText("|cccffffff".._number.."|r");
	end
	
	
	-- set deaths from all of these instances
	if(InstanceTime_ListFrameTextMoneyRepairAll ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if(FreierGeist_IT_Data[tmp_line]["deaths"] ~= nil) then
					all_deaths = all_deaths + FreierGeist_IT_Data[tmp_line]["deaths"];
				end
			end
		end
		
		if(startTime > 0 and startTime ~= nil) then
			all_deaths = all_deaths + _number;
		end
		
		InstanceTime_ListFrameTextDeathsAll:SetText("|cccffffff"..all_deaths.."|r");
	end
end



---------------------------------------------------------------
--                 set justice points                        --
---------------------------------------------------------------
function FreierGeist_IT_SetJusticePoints(_number, _mode, _zone)
	all_justice_points = 0;
	

	-- set justice points from the single instance
	if(InstanceTime_ListFrameTextJusticePoints ~= nil) then
		InstanceTime_ListFrameTextJusticePoints:SetText("|cccffffff".._number.."|r");
	end
	
	
	-- set justice points from all of these instances
	if(InstanceTime_ListFrameTextMoneyRepairAll ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if(FreierGeist_IT_Data[tmp_line]["justice_points"] ~= nil) then
					all_justice_points = all_justice_points + FreierGeist_IT_Data[tmp_line]["justice_points"];
				end
			end
		end
		
		if(startTime > 0 and startTime ~= nil) then
			all_justice_points = all_justice_points + _number;
		end
		
		InstanceTime_ListFrameTextJusticePointsAll:SetText("|cccffffff"..all_justice_points.."|r");
	end
end



-------------------------------------------------------------
--                  set valor points                       --
-------------------------------------------------------------
function FreierGeist_IT_SetValorPoints(_number, _mode, _zone)
	all_valor_points = 0;
	

	-- set valor points from the single instance
	if(InstanceTime_ListFrameTextValorPoints ~= nil) then
		InstanceTime_ListFrameTextValorPoints:SetText("|cccffffff".._number.."|r");
	end
	
	
	-- set valor points from all of these instances
	if(InstanceTime_ListFrameTextMoneyRepairAll ~= nil) then
		for tmp_line=1,FreierGeist_IT_DataArraySize do
			if((FreierGeist_IT_Data[tmp_line]["zone"] == _zone)
			and (FreierGeist_IT_Data[tmp_line]["mode"] == _mode)) then
				if(FreierGeist_IT_Data[tmp_line]["valor_points"] ~= nil) then
					all_valor_points = all_valor_points + FreierGeist_IT_Data[tmp_line]["valor_points"];
				end
			end
		end
		
		if(startTime > 0 and startTime ~= nil) then
			all_valor_points = all_valor_points + _number;
		end
		
		InstanceTime_ListFrameTextValorPointsAll:SetText("|cccffffff"..all_valor_points.."|r");
	end
end



--------------------------------------------
--     	      add repair costs	 	      --
--------------------------------------------
function FreierGeist_IT_AddRepairCosts(_arg)
	local tmp_gold_repair, tmp_silver_repair, tmp_copper_repair;
	local actual_gold_repair, actual_silver_repair, actual_copper_repair;
	
	
	if(timerHasStarted) then
		-- get gold, silver, copper
		tmp_gold_repair = math.floor(_arg / 10000);
		gold_repair = gold_repair + math.floor(_arg / 10000);
		tmp_silver_repair = math.floor((_arg - (tmp_gold_repair * 10000)) / 100);
		silver_repair = silver_repair + math.floor((_arg - (tmp_gold_repair * 10000)) / 100);
		copper_repair = copper_repair + math.floor(_arg - (tmp_gold_repair * 10000) - (tmp_silver_repair * 100));
	else
		-- get gold, silver, copper
		tmp_gold_repair = math.floor(_arg / 10000);
		gold_repair = math.floor(_arg / 10000);
		tmp_silver_repair = math.floor((_arg - (tmp_gold_repair * 10000)) / 100);
		silver_repair = math.floor((_arg - (tmp_gold_repair * 10000)) / 100);
		copper_repair = math.floor(_arg - (tmp_gold_repair * 10000) - (tmp_silver_repair * 100));
		
		actual_copper_repair = FreierGeist_IT_Data[scrollBarHeight-1]["copper_repair"] + copper_repair;
		actual_silver_repair = FreierGeist_IT_Data[scrollBarHeight-1]["silver_repair"] + silver_repair;
		actual_gold_repair = FreierGeist_IT_Data[scrollBarHeight-1]["gold_repair"] + gold_repair;
		
		-- correct gold, silver, copper
		while (actual_copper_repair >= 100) do
			actual_silver_repair = actual_silver_repair + 1;
			actual_copper_repair = actual_copper_repair - 100;
		end
		while (actual_silver_repair >= 100) do
			actual_gold_repair = actual_gold_repair + 1;
			actual_silver_repair = actual_silver_repair - 100;
		end
		
		FreierGeist_IT_Data[scrollBarHeight-1]["gold_repair"] = actual_gold_repair;
		FreierGeist_IT_Data[scrollBarHeight-1]["silver_repair"] = actual_silver_repair;
		FreierGeist_IT_Data[scrollBarHeight-1]["copper_repair"] = actual_copper_repair;
	end
	
	if(FreierGeist_IT_Debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Reparaturkosten zu zahlen:"..gold_repair.."g "..silver_repair.."s "..copper_repair.."k ", 0.1, 0.8, 0.1);
	end
	
	FreierGeist_IT_SetMoneyRepair(gold_repair, silver_repair, copper_repair, mode, zone);
end



--------------------------------------------
--            set class list              --
--------------------------------------------
function FreierGeist_IT_SetClasses(_classes)
	classScrollBarHeight = 1;


	for line in _classes:gmatch"[^\n]+" do
		classesArray[classScrollBarHeight] = line;
		classScrollBarHeight = classScrollBarHeight+1;
		if(line == nil) then
			break;
		end
	end
	
	-- refresh the class list
	FreierGeist_IT_ClassScrollBarUpdate();
end



----------------------------------------------
--        ---    set boss list              --
----------------------------------------------
function FreierGeist_IT_SetBosslist(_bosslist)
	bossScrollBarHeight = 1;


	for line in _bosslist:gmatch"[^\n]+" do
		bosslistArray[bossScrollBarHeight] = line;
		bossScrollBarHeight = bossScrollBarHeight+1;
		if(line == nil) then
			break;
		end
	end
	
	-- refresh the class list
	FreierGeist_IT_BossScrollBarUpdate();
end



------------------------------
--    display help dialog   --
------------------------------
function FreierGeist_IT_Help()
	if(InstanceTime_Help:IsVisible()) then
		InstanceTime_Help:Hide();
	else
		PanelTemplates_TabResize(InstanceTime_HelpTab_1, 0);
		PanelTemplates_TabResize(InstanceTime_HelpTab_2, 0);
		PanelTemplates_TabResize(InstanceTime_HelpTab_3, 0);
		PanelTemplates_TabResize(InstanceTime_HelpTab_4, 0);
		PanelTemplates_TabResize(InstanceTime_HelpTab_5, 0);
		PanelTemplates_TabResize(InstanceTime_HelpTab_6, 0);
		PanelTemplates_SelectTab(InstanceTime_HelpTab_1);
		PanelTemplates_DeselectTab(InstanceTime_HelpTab_2);
		PanelTemplates_DeselectTab(InstanceTime_HelpTab_3);
		PanelTemplates_DeselectTab(InstanceTime_HelpTab_4);
		PanelTemplates_DeselectTab(InstanceTime_HelpTab_5);
		PanelTemplates_DeselectTab(InstanceTime_HelpTab_6);
		InstanceTime_HelpScrollFrameScrollChildText:SetText(INSTANCETIME_HELP_GENERAL);
		InstanceTime_HelpScrollFrameScrollBar:SetValue(0);
		InstanceTime_HelpScrollFrame:UpdateScrollChildRect();

		InstanceTime_Help:Show();
	end
end


----------------------------------------
--     display message to channel     --
----------------------------------------
function FreierGeist_IT_Output(_channel)
	FreierGeist_IT_DataOutput[0] = "------- InstanceTime - "..INSTANCETIME_INFO_TEXT.." -------";
	local chatnumber;
	
	
	num = string.match(FreierGeist_IT_DataOutput[2], "(%d+) |4");
	if (num == nil) then
		num = 0;
	end
	
	if (tonumber(num) <= 1) then
		FreierGeist_IT_DataOutput[2] = gsub(FreierGeist_IT_DataOutput[2], "|4(.-):.-;", "%1");
	else
		FreierGeist_IT_DataOutput[2] = gsub(FreierGeist_IT_DataOutput[2], "|4.-:(.-);", "%1");
	end
	
	
	
	-- un-set lines for output
	if(not FreierGeist_IT_Config["FreierGeist_IT_XPOutput"]) then
		FreierGeist_IT_DataOutput[3] = "";
	end
	if(not FreierGeist_IT_Config["FreierGeist_IT_ReputationOutput"]) then
		FreierGeist_IT_DataOutput[4] = "";
		FreierGeist_IT_DataOutput[5] = "";
		FreierGeist_IT_DataOutput[6] = "";
	end
	if(not FreierGeist_IT_Config["FreierGeist_IT_MoneyOutput"]) then
		FreierGeist_IT_DataOutput[7] = "";
	end
	
	if(not FreierGeist_IT_Config["FreierGeist_IT_RepairOutput"]) then
		FreierGeist_IT_DataOutput[8] = "";
	end
	
	if(not FreierGeist_IT_Config["FreierGeist_IT_DeathsOutput"]) then
		FreierGeist_IT_DataOutput[9] = "";
	end

	
	local activeWindow = ChatEdit_GetActiveWindow();

	if(activeWindow) then
		local channel = ChatFrame1EditBox:GetAttribute("chatType");
     	local chatnumber = nil;
		local posted = false;
		
		if(IsAddOnLoaded("WIM")) then
			if (WIM.windows.active.whisper) then
				for i in pairs(WIM.windows.active.whisper) do
					--if getglobal(WIM.windows.active.whisper[i]:GetName().."MsgBox"):HasFocus() then
					if _G[WIM.windows.active.whisper[i]:GetName().."MsgBox"]:HasFocus() then
						for index=0,9 do
							SendChatMessage(FreierGeist_IT_DataOutput[index], "WHISPER", nil, WIM.windows.active.whisper[i].theUser);
						end
						posted = true;
					end
				end
			end
			
			if (WIM.windows.active.chat) then
				for i in pairs(WIM.windows.active.chat) do
					--if getglobal(WIM.windows.active.chat[i]:GetName().."MsgBox"):HasFocus() then
					if _G[WIM.windows.active.whisper[i]:GetName().."MsgBox"]:HasFocus() then
						if ((WIM.windows.active.chat[i].chatType == "say") or (WIM.windows.active.chat[i].chatType == "guild") or (WIM.windows.active.chat[i].chatType == "officer") or (WIM.windows.active.chat[i].chatType == "party") or (WIM.windows.active.chat[i].chatType == "raid")) then
							for index=0,9 do
								SendChatMessage(FreierGeist_IT_DataOutput[index], WIM.windows.active.chat[i].chatType);
							end
							posted = true;
						end
					end
				end
			end
		end
		
		if(not posted) then
			DEFAULT_CHAT_FRAME:AddMessage(channel);
			for index=0,9 do
				if (channel == "WHISPER") then
					chatnumber = ChatFrame1EditBox:GetAttribute("tellTarget");
					DEFAULT_CHAT_FRAME:AddMessage(chatnumber);		-- ACHTUNG: was ist damit
					SendChatMessage(FreierGeist_IT_DataOutput[index], "WHISPER", nil, chatnumber);
				elseif (channel == "CHANNEL") then
					chatnumber = ChatFrame1EditBox:GetAttribute("channelTarget");
					SendChatMessage(FreierGeist_IT_DataOutput[index], "CHANNEL", GetDefaultLanguage("player"), chatnumber);
				elseif (channel == "PARTY") then
					SendChatMessage(FreierGeist_IT_DataOutput[index], "PARTY");
				elseif (channel == "RAID") then
					SendChatMessage(FreierGeist_IT_DataOutput[index], "RAID");
				elseif (channel == "GUILD") then
					SendChatMessage(FreierGeist_IT_DataOutput[index], "GUILD");
				elseif (channel == "SAY") then
					SendChatMessage(FreierGeist_IT_DataOutput[index], "SAY");
				end
			end
		end
	elseif(_channel == "GUILD") then
		if(IsInGuild()) then
			for index=0,9 do
				SendChatMessage(FreierGeist_IT_DataOutput[index], "GUILD");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TELL_TO_GUILD);
		end
	elseif(_channel == "PARTY") then
		if(GetNumPartyMembers() > 0) then
			for index=0,9 do
				SendChatMessage(FreierGeist_IT_DataOutput[index], "PARTY");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TELL_TO_GROUP);
		end
	elseif(_channel == "RAID") then
		if(GetNumRaidMembers() > 0) then
			for index=0,9 do
				SendChatMessage(FreierGeist_IT_DataOutput[index], "RAID");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TELL_TO_RAID);
		end
	elseif(_channel == "WHISPER") then
		if(UnitIsPlayer("target")) then
			for index=0,9 do
				SendChatMessage(FreierGeist_IT_DataOutput[index], "WHISPER", GetDefaultLanguage("player"), UnitName("target"));
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_TELL_TO_CHAR);
			ChatFrame1EditBox:Show();
		end
	else
		for index=0,9 do
			DEFAULT_CHAT_FRAME:AddMessage(FreierGeist_IT_DataOutput[index]);
		end
	end

	ChatFrame1EditBox:Hide();
	InstanceTime_TellToFrame:Hide();
end


-----------------------------------------
--           scrollbar update          --
-----------------------------------------
function FreierGeist_IT_ScrollBarUpdate()
	local line;
	local lineplusoffset;
	

	FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);

	for line=1,8 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (lineplusoffset < scrollBarHeight) then
			if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
				lineplusoffset = scrollBarHeight-lineplusoffset;
			end
			_G["InstanceTimeDateEntry"..line.."_Text"]:SetText(FreierGeist_IT_Data[lineplusoffset]["date"]);
			_G["InstanceTimeStartEntry"..line.."_Text"]:SetText(FreierGeist_IT_Data[lineplusoffset]["start"]);
			_G["InstanceTimeStopEntry"..line.."_Text"]:SetText(FreierGeist_IT_Data[lineplusoffset]["stop"]);
			local tmp_duration = SecondsToTime(FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]);
			_G["InstanceTimeDurationEntry"..line.."_Text"]:SetText(tmp_duration);
			_G["InstanceTimeModeEntry"..line.."_Text"]:SetText(FreierGeist_IT_Data[lineplusoffset]["mode"]);
			_G["InstanceTimeInstanceNameEntry"..line.."_Text"]:SetText("|ccc00cc00"..FreierGeist_IT_Data[lineplusoffset]["zone"].."|r");

			-- colour the one, which was selected
			if (anEntryIsColoured) then
				if	(tmp_EntryDate == FreierGeist_IT_Data[lineplusoffset]["date"]) and
					(tmp_EntryStart == FreierGeist_IT_Data[lineplusoffset]["start"]) and
					(tmp_EntryStop == FreierGeist_IT_Data[lineplusoffset]["stop"]) and
					(tmp_EntryDuration == (FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"])) and
					(tmp_EntryMode == FreierGeist_IT_Data[lineplusoffset]["mode"]) and
					(tmp_EntryZone == FreierGeist_IT_Data[lineplusoffset]["zone"]) 	then
					
					_G["InstanceTimeDateEntry"..line.."_Text"]:SetText("|cffffd200"..FreierGeist_IT_Data[lineplusoffset]["date"].."|r");
					_G["InstanceTimeStartEntry"..line.."_Text"]:SetText("|cffffd200"..FreierGeist_IT_Data[lineplusoffset]["start"].."|r");
					_G["InstanceTimeStopEntry"..line.."_Text"]:SetText("|cffffd200"..FreierGeist_IT_Data[lineplusoffset]["stop"].."|r");
					_G["InstanceTimeDurationEntry"..line.."_Text"]:SetText("|cffffd200"..SecondsToTime(FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]).."|r");
					_G["InstanceTimeModeEntry"..line.."_Text"]:SetText("|cffffd200"..FreierGeist_IT_Data[lineplusoffset]["mode"].."|r");
					_G["InstanceTimeInstanceNameEntry"..line.."_Text"]:SetText("|cffffd200"..FreierGeist_IT_Data[lineplusoffset]["zone"].."|r");
				end
			end
			
			if (markedIndexToMerge[1] == lineplusoffset) then
				_G["InstanceTimeDateEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[1]]["date"].."|r");
				_G["InstanceTimeStartEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[1]]["start"].."|r");
				_G["InstanceTimeStopEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[1]]["stop"].."|r");
				_G["InstanceTimeDurationEntry"..line.."_Text"]:SetText("|cffff4444"..SecondsToTime(FreierGeist_IT_Data[markedIndexToMerge[1]]["stoptime"] - FreierGeist_IT_Data[markedIndexToMerge[1]]["starttime"]).."|r");
				_G["InstanceTimeModeEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[1]]["mode"].."|r");
				_G["InstanceTimeInstanceNameEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[1]]["zone"].."|r");
			end
			if (markedIndexToMerge[2] == lineplusoffset) then
				_G["InstanceTimeDateEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[2]]["date"].."|r");
				_G["InstanceTimeStartEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[2]]["start"].."|r");
				_G["InstanceTimeStopEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[2]]["stop"].."|r");
				_G["InstanceTimeDurationEntry"..line.."_Text"]:SetText("|cffff4444"..SecondsToTime(FreierGeist_IT_Data[markedIndexToMerge[2]]["stoptime"] - FreierGeist_IT_Data[markedIndexToMerge[2]]["starttime"]).."|r");
				_G["InstanceTimeModeEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[2]]["mode"].."|r");
				_G["InstanceTimeInstanceNameEntry"..line.."_Text"]:SetText("|cffff4444"..FreierGeist_IT_Data[markedIndexToMerge[2]]["zone"].."|r");
			end
			
			_G["InstanceTimeDateEntry"..line]:Show();
			_G["InstanceTimeStartEntry"..line]:Show();
			_G["InstanceTimeStopEntry"..line]:Show();
			_G["InstanceTimeDurationEntry"..line]:Show();
			_G["InstanceTimeModeEntry"..line]:Show();
			_G["InstanceTimeInstanceNameEntry"..line]:Show();
		else
			_G["InstanceTimeDateEntry"..line]:Hide();
			_G["InstanceTimeStartEntry"..line]:Hide();
			_G["InstanceTimeStopEntry"..line]:Hide();
			_G["InstanceTimeDurationEntry"..line]:Hide();
			_G["InstanceTimeModeEntry"..line]:Hide();
			_G["InstanceTimeInstanceNameEntry"..line]:Hide();
		end
	end
	
	-- update the number of entries
	local tmp_scrollBarHeight = scrollBarHeight-1;
	InstanceTime_ListFrameText_NumberOfEntries:SetText("|cccdddddd"..tmp_scrollBarHeight.." / "..FreierGeist_IT_DataArraySize.." "..INSTANCETIME_MAIN_NUMBER_OF_ENTRIES.."|r");
end



----------------------------------------------
--          class scrollbar update          --
----------------------------------------------
function FreierGeist_IT_ClassScrollBarUpdate()
	local line;
	local lineplusoffset;

	
	FauxScrollFrame_Update(InstanceTimeClassScrollBar, classScrollBarHeight, 6, 16);

	for line=1,5 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(InstanceTimeClassScrollBar);
		if (lineplusoffset < classScrollBarHeight) then
			_G["InstanceTimeCharNameEntry"..line.."_Text"]:SetText(classesArray[lineplusoffset]);
			_G["InstanceTimeCharNameEntry"..line]:Show();
		else
			_G["InstanceTimeCharNameEntry"..line]:Hide();
		end
	end
end


---------------------------------------------
--          boss scrollbar update          --
---------------------------------------------
function FreierGeist_IT_BossScrollBarUpdate()
	local line;
	local lineplusoffset;


	FauxScrollFrame_Update(InstanceTimeBossScrollBar, bossScrollBarHeight, 5, 16);
	
	for line=1,4 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(InstanceTimeBossScrollBar);
		if (lineplusoffset < bossScrollBarHeight) then
			_G["InstanceTimeBossNameEntry"..line.."_Text"]:SetText(bosslistArray[lineplusoffset]);
			_G["InstanceTimeBossNameEntry"..line]:Show();
		else
			_G["InstanceTimeBossNameEntry"..line]:Hide();
		end
	end
end


---------------------------------------------
--         loot scrollbar update           --
---------------------------------------------
function FreierGeist_IT_LootScrollBarUpdate()
	local line;
	local lineplusoffset;
	local lootindex;
	local numberOfLoot;
	

	if(anEntryIsColoured) then
		lootindex = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			lootindex = scrollBarHeight-lootindex;
		end
	else
		lootindex = scrollBarHeight;
	end
	
	numberOfLoot = 0;
	if(FreierGeist_IT_Loot["index"] ~= nil) then
		if(FreierGeist_IT_Loot["index"][lootindex] ~= nil) then
			numberOfLoot = FreierGeist_IT_Loot["index"][lootindex]+1;
		end
	end
	FauxScrollFrame_Update(InstanceTimeLootScrollBar, numberOfLoot, 6, 16);


	for line=1,5 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(InstanceTimeLootScrollBar);
		if (lineplusoffset < numberOfLoot) then
			_G["InstanceTimeLootEntry"..line.."_Text"]:SetText(FreierGeist_IT_Loot["item"][lootindex][lineplusoffset]);
			_G["InstanceTimeLootEntry"..line]:Show();			
		else
			_G["InstanceTimeLootEntry"..line]:Hide();
		end
	end
	
	
	-- set headline and number of items:
	local item_counter_green = 0;
	local item_counter_blue = 0;
	local item_counter_purple = 0;
	local item_counter_orange = 0;
	for line=1,numberOfLoot-1 do
		if(string.find(FreierGeist_IT_Loot["item"][lootindex][line], "cff1eff00")) then
			item_counter_green = item_counter_green+1;
		end
		if(string.find(FreierGeist_IT_Loot["item"][lootindex][line], "cff0070dd")) then
			item_counter_blue = item_counter_blue+1;
		end
		if(string.find(FreierGeist_IT_Loot["item"][lootindex][line], "cffa335ee")) then
			item_counter_purple = item_counter_purple+1;
		end
		if(string.find(FreierGeist_IT_Loot["item"][lootindex][line], "cffff8000")) then
			item_counter_orange = item_counter_orange+1;
		end
	end
	InstanceTime_LootFrameTextLoot:SetText(INSTANCETIME_MAIN_LOOTINFORMATION_HEADLINE.."                "..INSTANCETIME_MAIN_NUMBER.." |cff1eff00"..item_counter_green.."|r  |cff0070dd"..item_counter_blue.."|r  |cffa335ee"..item_counter_purple.."|r  |cffff8000"..item_counter_orange.."|r");
end


---------------------------------------------------------------------
--                 scrollbar set line clicked                      --
---------------------------------------------------------------------
function FreierGeist_IT_ScrollBarSetSelectedEntryLineTooltip(_number)
	local lootlindex;
	NumberForItemLink = _number;

	
	if(anEntryIsColoured) then
		lootindex = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			lootindex = scrollBarHeight-lootindex;
		end
	else
		lootindex = scrollBarHeight;
	end
	lineplusoffset = NumberForItemLink + FauxScrollFrame_GetOffset(InstanceTimeLootScrollBar);

	
	GameTooltip:AddLine(FreierGeist_IT_Loot["item"][lootindex][lineplusoffset], 0.7,0.7,0.7);
	GameTooltip:AddDoubleLine("|cccdd8833"..INSTANCETIME_PARSER_FROM_UNIT.."|r", FreierGeist_IT_Loot["unit"][lootindex][lineplusoffset], 0,0,0,0.7,0.7,0.7);
	GameTooltip:AddDoubleLine("|cccdd8833"..INSTANCETIME_PARSER_TO_UNIT.."|r", FreierGeist_IT_Loot["player"][lootindex][lineplusoffset], 0,0,0,0.7,0.7,0.7);
end


-------------------------------------------------------------------------
--                 scrollbar set line clicked char                     --
-------------------------------------------------------------------------
function FreierGeist_IT_ScrollBarSetSelectedEntryLineTooltipChar(_number)
	local classindex;
	local lootlindex;
	local numberOfLoot;
	local tmp_playername;
	local tmp_playernamecoloured;
	

	classindex = _number + FauxScrollFrame_GetOffset(InstanceTimeClassScrollBar);
	tmp_playername = classesArray[classindex];
	
	if(anEntryIsColoured) then
		lootindex = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			lootindex = scrollBarHeight-lootindex;
		end
	else
		lootindex = scrollBarHeight;
	end

	
	numberOfLoot = 0;
	if(FreierGeist_IT_Loot["index"] ~= nil) then
		if(FreierGeist_IT_Loot["index"][lootindex] ~= nil) then
			numberOfLoot = FreierGeist_IT_Loot["index"][lootindex]+1;
		end
	end
	
	
	-- german: replace special characters (for class)
	tmp_playername = string.gsub(tmp_playername, "\195\164", "ae");
	tmp_playername = string.gsub(tmp_playername, "\195\132", "Ae");
	tmp_playername = string.gsub(tmp_playername, "\195\188", "ue");
	tmp_playername = string.gsub(tmp_playername, "\195\156", "Ue");
	tmp_playername = string.gsub(tmp_playername, "\195\182", "oe");
	tmp_playername = string.gsub(tmp_playername, "\195\150", "Oe");
	tmp_playername = string.gsub(tmp_playername, "\195\159", "ss");
	-- french: replace special characters (for class)
	tmp_playername = string.gsub(tmp_playername, "\195\170", "e");
	tmp_playername = string.gsub(tmp_playername, "\195\169", "e");
	tmp_playernamecoloured = tmp_playername;
	
	tmp_playername = string.gsub(tmp_playername, "|cccc8b4c6", "");
	tmp_playername = string.gsub(tmp_playername, "|cccff7d0a", "");
	tmp_playername = string.gsub(tmp_playername, "|cccabd473", "");
	tmp_playername = string.gsub(tmp_playername, "|ccc69ccf0", "");
	tmp_playername = string.gsub(tmp_playername, "|cccf58cba", "");
	tmp_playername = string.gsub(tmp_playername, "|cccffffff", "");
	tmp_playername = string.gsub(tmp_playername, "|cccfff569", "");
	tmp_playername = string.gsub(tmp_playername, "|ccc00dbba", "");
	tmp_playername = string.gsub(tmp_playername, "|ccc9482ca", "");
	tmp_playername = string.gsub(tmp_playername, "|cccc79c6e", "");
	tmp_playername = string.gsub(tmp_playername, "|cccc41f3b", "");
	tmp_playername = string.gsub(tmp_playername, "|r", "");
	tmp_playername = string.gsub(tmp_playername, "%(", "");
	tmp_playername = string.gsub(tmp_playername, "%)", "");
	tmp_playername = string.gsub(tmp_playername, "%-", "");
	tmp_playername = string.gsub(tmp_playername, "Level %d*", "");
	tmp_playername = string.gsub(tmp_playername, "(%w*) (%w*)", "%1");
	tmp_playername = string.gsub(tmp_playername, " ", "");
	
	
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "|cccc8b4c6", "");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "|r", "");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "%(", "");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "%)", "");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "%-", "");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "Level %d*", "");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "(%w*) (%w*)", "%1");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, "(%w*) (%w*)", "%1");
	tmp_playernamecoloured = string.gsub(tmp_playernamecoloured, " ", "");
	tmp_playernamecoloured = tmp_playernamecoloured.."|r";

	
	-- add the name
	GameTooltip:AddLine(tmp_playernamecoloured, 0.7,0.7,0.7);
	
	-- add the loot
	for line=1,numberOfLoot-1 do
		if(string.find(FreierGeist_IT_Loot["player"][lootindex][line], tmp_playername)) then
			GameTooltip:AddLine(FreierGeist_IT_Loot["item"][lootindex][line], 0.7,0.7,0.7);
		end
	end
end


----------------------------------------------
--        scrollbar show item link          --
----------------------------------------------
function FreierGeist_IT_ScrollBarSetItemLink()
	local lootlindex;
	local link;
	local current_item, disenchant_found;
	

	if(anEntryIsColoured) then
		lootindex = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			lootindex = scrollBarHeight-lootindex;
		end
	else
		lootindex = scrollBarHeight;
	end
	lineplusoffset = NumberForItemLink + FauxScrollFrame_GetOffset(InstanceTimeLootScrollBar);
	

	if(FreierGeist_IT_Loot["item"][lootindex][lineplusoffset] ~= nil) then
		disenchant_found = string.find(FreierGeist_IT_Loot["item"][lootindex][lineplusoffset], "%s%=%>%s");
		if(disenchant_found ~= nil) then
			current_item = string.sub(FreierGeist_IT_Loot["item"][lootindex][lineplusoffset], 1, disenchant_found-1);
		else
			current_item = FreierGeist_IT_Loot["item"][lootindex][lineplusoffset];
		end
	end
	

	-- As suggested from Corelgun. (Thank you very much !)
	_, itemLink = GetItemInfo(current_item);
	if (itemLink) then
		_, _, itemString = string.find(itemLink, "^|c%x+|H(.+)|h%[.*%]");
		if (itemString) then
			SetItemRef(itemString, itemLink, "InstanceTimeLootEntry"..NumberForItemLink);
		end
	end 
	
end


--------------------------------------------
--         show dropdownbox class         --
--------------------------------------------
function FreierGeist_IT_ShowDropDownPostTo()
	UIDropDownMenu_Initialize(InstanceTimeOptionsFrameDropDownPostTo, FreierGeist_IT_DropDownPostTo_Initialize);
	UIDropDownMenu_SetWidth(InstanceTimeOptionsFrameDropDownPostTo, 120);
	UIDropDownMenu_SetSelectedID(InstanceTimeOptionsFrameDropDownPostTo, FreierGeist_IT_Config["FreierGeist_IT_viewIndex"]);
end


---------------------------------------------------
--       initialize dropdownbox post to          --
---------------------------------------------------
function FreierGeist_IT_DropDownPostTo_Initialize()
	local info;
	
	
	-- add "no channel"
	info = {
		text = INSTANCETIME_OPTIONS_DROPDOWNPOSTTO_NONE;
		func = FreierGeist_IT_DropDownPostTo_OnClick;
	};
	UIDropDownMenu_AddButton(info);
	
	-- add "party"
	info = {
		text = INSTANCETIME_OPTIONS_DROPDOWNPOSTTO_PARTY;
		func = FreierGeist_IT_DropDownPostTo_OnClick;
	};
	UIDropDownMenu_AddButton(info);
	
	-- add "raid"
	info = {
		text = INSTANCETIME_OPTIONS_DROPDOWNPOSTTO_RAID;
		func = FreierGeist_IT_DropDownPostTo_OnClick;
	};
	UIDropDownMenu_AddButton(info);
	
	-- add "guild"
	info = {
		text = INSTANCETIME_OPTIONS_DROPDOWNPOSTTO_GUILD;
		func = FreierGeist_IT_DropDownPostTo_OnClick;
	};
	UIDropDownMenu_AddButton(info);
	
	-- add "self"
	info = {
		text = INSTANCETIME_OPTIONS_DROPDOWNPOSTTO_SELF;
		func = FreierGeist_IT_DropDownPostTo_OnClick;
	};
	UIDropDownMenu_AddButton(info);
end


------------------------------------------------
--        clicked dropdownbox class           --
------------------------------------------------
function FreierGeist_IT_DropDownPostTo_OnClick()
	FreierGeist_IT_Config["FreierGeist_IT_viewIndex"] = self:GetID();
	UIDropDownMenu_SetSelectedID(InstanceTimeOptionsFrameDropDownPostTo, FreierGeist_IT_Config["FreierGeist_IT_viewIndex"]);
end



-----------------------------------------------------------
----------           event functions            -----------
-----------------------------------------------------------


---------------------------------------------------
--         event party members changed           --
---------------------------------------------------
function FreierGeist_IT_Event_PartyMembersChanged()
	local playerName = UnitName("player");
	local playerClass, englishClass = UnitClass("player");
	local playerLevel = UnitLevel("player");
	
	
	local CLASS_COLOURS = {};
	CLASS_COLOURS['DRUID'] = "ff7d0a";
	CLASS_COLOURS['HUNTER']	= "abd473";
	CLASS_COLOURS['MAGE'] = "69ccf0";
	CLASS_COLOURS['PALADIN'] = "f58cba";
	CLASS_COLOURS['PRIEST']	= "ffffff";
	CLASS_COLOURS['ROGUE'] = "fff569";
	CLASS_COLOURS['SHAMAN']	= "183582";
	CLASS_COLOURS['WARLOCK'] = "9482ca";
	CLASS_COLOURS['WARRIOR'] = "c79c6e";
	CLASS_COLOURS['DEATHKNIGHT'] = "c41f3b";
	

	-- add myself
	-- check if this is a new player and add him
	if(classes ~= nil and playerName ~= nil) then
		if(string.find(classes, playerName) == nil) then
			local coloredPlayerName = "|ccc"..CLASS_COLOURS[englishClass]..playerName.."|r";
			
			local unit_role = UnitGroupRolesAssigned("player");
			local role = '';
			if(unit_role == 'TANK') then 
				role = ', Tank';
			end
			if(unit_role == 'HEALER') then 
				role = ', Healer';
			end
			if(unit_role == 'DAMAGER') then 
				role = ', Damager';
			end
					
			if(unit_role == 'NONE') then
				classes = classes.."\n"..coloredPlayerName.."   |cccc8b4c6(Lvl "..playerLevel..")|r";
			else
				classes = classes.."\n"..coloredPlayerName.."   |cccc8b4c6(Lvl "..playerLevel..role..")|r";
			end
		end
	end


	if(GetNumRaidMembers() > 0) then
		for i=1, GetNumRaidMembers(), 1 do
			playerName = UnitName("raid"..i);
			playerClass, englishClass = UnitClass("raid"..i);
			playerLevel = UnitLevel("raid"..i);
  
  			local unit_role = UnitGroupRolesAssigned("raid"..i);
			local role = '';
			if(unit_role == 'TANK') then 
				role = ', Tank';
			end
			if(unit_role == 'HEALER') then 
				role = ', Healer';
			end
			if(unit_role == 'DAMAGER') then 
				role = ', Damager';
			end
  
			if(UnitIsConnected("raid"..i) == 1 ) then
				if((playerName ~= nil) and (playerClass ~= nil) and (playerLevel ~= nil)) then
					-- check if this is a new player and add him		
					if((classes ~= nil) and (playerName ~= nil) and (playerLevel > 0)) then
						if(string.find(classes, playerName) == nil) then
							local coloredPlayerName = "|ccc"..CLASS_COLOURS[englishClass]..playerName.."|r";
							
							if(unit_role == 'NONE') then
								classes = classes.."\n"..coloredPlayerName.."   |cccc8b4c6(Lvl "..playerLevel..")|r";
							else
								classes = classes.."\n"..coloredPlayerName.."   |cccc8b4c6(Lvl "..playerLevel..role..")|r";
							end
						end
					end
				end
			end
		end
	elseif(GetNumPartyMembers() > 0) then 
		for i=1, GetNumPartyMembers(), 1 do
			playerName = UnitName("party"..i);
			playerClass, englishClass = UnitClass("party"..i);
			playerLevel = UnitLevel("party"..i);
			
			local unit_role = UnitGroupRolesAssigned("party"..i);
			local role = '';
			if(unit_role == 'TANK') then 
				role = ', Tank';
			end
			if(unit_role == 'HEALER') then 
				role = ', Healer';
			end
			if(unit_role == 'DAMAGER') then 
				role = ', Damager';
			end
			
			
			if(UnitIsConnected("party"..i) == 1 ) then
				if((playerName ~= nil) and (playerClass ~= nil) and (playerLevel ~= nil)) then
					-- check if this is a new player and add him
					if((classes ~= nil) and (playerName ~= nil) and (playerLevel > 0)) then
						if(string.find(classes, playerName) == nil) then
							local coloredPlayerName = "|ccc"..CLASS_COLOURS[englishClass]..playerName.."|r";
							
							if(unit_role == 'NONE') then
								classes = classes.."\n"..coloredPlayerName.."   |cccc8b4c6(Lvl "..playerLevel..")|r";
							else
								classes = classes.."\n"..coloredPlayerName.."   |cccc8b4c6(Lvl "..playerLevel..role..")|r";
							end
						end
					end
				end
			end
		end
	end

	FreierGeist_IT_SetClasses(classes);
end


-------------------------------------------------------
--          event chat msg combat XP gain            --
-------------------------------------------------------
function FreierGeist_IT_Event_ChatMsgCombatXPGain(_arg)
	if(FreierGeist_IT_Debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Original ChatMsg:", 0.1, 0.8, 0.1);
		DEFAULT_CHAT_FRAME:AddMessage(_arg, 0.1, 0.8, 0.1);
	end
	
	-- assume that the first number in the message is the gained xp
	-- so for english and german client it works the same and no localisation is necessary
	i, j = string.find(_arg, "%d+");
	gainedXP = string.sub (_arg, i, j);
	XP = XP + gainedXP;
	
	if(anEntryIsColoured == false) then
		InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_ACTUAL_TIMER);
		InstanceTime_ListFrameButtonTellAll:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_SUMMARY);
		FreierGeist_IT_SetXP(XP, mode, zoneName);
	end
end


--------------------------------------------------------------
--           event chat msg combat faction change           --
--------------------------------------------------------------
function FreierGeist_IT_Event_ChatMsgCombatFactionChange(_arg)
	local tmp_fraction = "-";
	local a, b;
	
	
	if(FreierGeist_IT_Debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Original ChatMsg:", 0.1, 0.8, 0.1);
		DEFAULT_CHAT_FRAME:AddMessage(_arg, 0.1, 0.8, 0.1);
	end


	a, b = string.find(_arg, INSTANCETIME_PARSER_REPUTATION_CHAT_TEXT1);
	if(b ~= nil) then
		local c, d;
		c, d = string.find(_arg, INSTANCETIME_PARSER_REPUTATION_CHAT_TEXT2);
		if(c ~= nil) then
			tmp_fraction = string.sub(_arg, b+1, c-1);
			if(FreierGeist_IT_Debug) then
				DEFAULT_CHAT_FRAME:AddMessage("Faction is:", 0.1, 0.8, 0.1);
				DEFAULT_CHAT_FRAME:AddMessage(tmp_fraction, 0.1, 0.8, 0.1);
			end
		end
	end
			
	
	-- get the reputation	
	u, v = string.find(_arg, INSTANCETIME_PARSER_REPUTATION_NUMBER_CHAT_TEXT1);
	w, x = string.find(_arg, INSTANCETIME_PARSER_REPUTATION_NUMBER_CHAT_TEXT2);
	if( (v ~= nil) and (w ~= nil) ) then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("Position:", 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage(v, 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage(w, 0.1, 0.8, 0.1);
		end
		gainedReputation = string.sub (_arg, v+1, w-1);
	else
		gainedReputation = 0;
	end

	
	-- add the gained reputation to the correct fraction
	if((fraction[1] ~= nil) and (fraction[2] ~= nil) and (fraction[3] ~= nil)) then
		if(fraction[1] == "-") then
			fraction[1] = tmp_fraction;
		elseif(tmp_fraction ~= fraction[1] and fraction[2] == "-") then
			fraction[2] = tmp_fraction;
		elseif(tmp_fraction ~= fraction[1] and tmp_fraction ~= fraction[2] and fraction[3] == "-") then
			fraction[3] = tmp_fraction;
		end	
		if(tmp_fraction == fraction[1]) then
			reputation[1] = reputation[1] + gainedReputation;
		elseif(tmp_fraction == fraction[2]) then
			reputation[2] = reputation[2] + gainedReputation;
		elseif(tmp_fraction == fraction[3]) then
			reputation[3] = reputation[3] + gainedReputation;
		end
		
		
		if(anEntryIsColoured == false) then
			InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_ACTUAL_TIMER);
			InstanceTime_ListFrameButtonTellAll:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_SUMMARY);
			FreierGeist_IT_SetReputationFraction(reputation[1], reputation[2], reputation[3], fraction[1], fraction[2], fraction[3], mode, zoneName);
		end
	end
end



------------------------------------------------
--           event chat msg money             --
------------------------------------------------
function FreierGeist_IT_Event_ChatMsgMoney(_arg)
	-- GlobalStrings.lua: LOOT_MONEY_SPLIT
	-- _arg = "Euer Anteil an der Beute ist 1 Gold, 2 Silber, 78 Kupfer.";
	-- _arg = "Your share of the loot is 5 Gold, 2 Silver, 78 Copper.";
	-- _arg = "Votre part du butin est de 5 Or, 2 Argent, 78 Cuivre.";
	-- _arg = "Ваша доля добычи: %s |4монета:монеты:монет;";
	
	-- GlobalStrings.lua: LOOT_MONEY_SPLIT_GUILD
	-- _arg = "Euer Anteil an der Beute beträgt 31 Silber, 49 Kupfer. (1 Silber, 57 Kupfer in der Gildenbank hinterlegt)";
	
	
	-- GlobalStrings.lua: YOU_LOOT_MONEY
	-- _arg = "Ihr plündert 1 Gold, 2 Silber, 78 Kupfer.";
	-- _arg = "You loot 5 Gold, 2 Silver, 78 Copper.";
	-- _arg = "Vous ramassez 5 Or, 2 Argent, 78 Cuivre.";
	-- _arg = "Вы находите: %s |4монета:монеты:монет;";
	
	-- GlobalStrings.lua: YOU_LOOT_MONEY_GUILD
	-- _arg = "Ihr plündert 31 Silber, 49 Kupfer (1 Silber, 57 Kupfer in der Gildenbank hinterlegt)";

	-- kupfer:		медная монета:медные монеты:медных монет;
	-- silber:		серебряная:серебряные:серебряных;
	-- gold:		золотая:золотые:золотых;
	
	
	
	local chatmsg = "";
	local tmp_gold = 0;
	local tmp_silver = 0;
	local tmp_copper = 0;
	
	
	-- cut guild money loot-msg; if available
	if(FreierGeist_IT_Debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Money-Loot-Msg previous:".._arg, 0.1, 0.8, 0.1);
	end
	nstart, nstop = string.find(_arg, "%(");
	if( (nstart ~= nil) and (nstart > 0) ) then
		_arg = string.sub(_arg, 0, nstart-2);
	end
	if(FreierGeist_IT_Debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Money-Loot-Msg after:".._arg, 0.1, 0.8, 0.1);
	end
	
	
	if( (GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0)) then
		chatmsg = INSTANCETIME_PARSER_MONEY_SAY;
	else
		chatmsg = INSTANCETIME_PARSER_MONEY_SINGLE_SAY;
	end
	
		
		
	-- gold, silber und kupfer
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
		tmp_silver = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD..", (%d+) "..INSTANCETIME_MAIN_MONEY_SILVER..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
		tmp_copper= string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_2..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER_2..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
		tmp_silver = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_2..", (%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_2..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
		tmp_copper= string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_2..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER_2..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_3..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER_3..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
		tmp_silver = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_3..", (%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_3..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
		tmp_copper= string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_3..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER_3..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
	end
	

	-- gold und silber
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) )  then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER.."%p*", "%1");
		tmp_silver = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD..", (%d+) "..INSTANCETIME_MAIN_MONEY_SILVER.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) )  then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_2..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER_2.."%p*", "%1");
		tmp_silver = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_2..", (%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_2.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) )  then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_3..", %d+ "..INSTANCETIME_MAIN_MONEY_SILVER_3.."%p*", "%1");
		tmp_silver = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_3..", (%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_3.."%p*", "%1");
	end
	

	-- gold und kupfer
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
		tmp_copper = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_2..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
		tmp_copper = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_2..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_3..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
		tmp_copper = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_GOLD_3..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
	end


	-- silber und kupfer
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) ) then
		tmp_silver = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_SILVER..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
		tmp_copper = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_SILVER..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
	end	
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) ) then
		tmp_silver = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_2..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
		tmp_copper = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_SILVER_2..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
	end	
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) ) then
		tmp_silver = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_3..", %d+ "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
		tmp_copper = string.gsub(_arg, chatmsg.."%d+ "..INSTANCETIME_MAIN_MONEY_SILVER_3..", (%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
	end	

	
	-- nur gold
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_2.."%p*", "%1");
	end
	if( (string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) ) then
		tmp_gold = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_GOLD_3.."%p*", "%1");
	end


	-- nur silber
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) ) then
		tmp_silver = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_SILVER.."%p*", "%1");
	end
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) ) then
		tmp_silver = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_2.."%p*", "%1");
	end
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) ) then
		tmp_silver = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_SILVER_3.."%p*", "%1");
	end
	

	-- nur kupfer
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER)) ) then
		tmp_copper = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_COPPER.."%p*", "%1");
	end
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_2)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_2)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_2)) ) then
		tmp_copper = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_2.."%p*", "%1");
	end
	if( (not string.find(_arg, INSTANCETIME_MAIN_MONEY_GOLD_3)) and (not string.find(_arg, INSTANCETIME_MAIN_MONEY_SILVER_3)) and (string.find(_arg, INSTANCETIME_MAIN_MONEY_COPPER_3)) ) then
		tmp_copper = string.gsub(_arg, chatmsg.."(%d+) "..INSTANCETIME_MAIN_MONEY_COPPER_3.."%p*", "%1");
	end
	
	
	
	if(tonumber(tmp_copper) ~= nil) then
		copper = copper + tonumber(tmp_copper);
		while (copper >= 100) do
			silver = silver + 1;
			copper = copper - 100;
		end
	end
	if(tonumber(tmp_silver) ~= nil) then
		silver = silver + tonumber(tmp_silver);
		while (silver >= 100) do
			gold = gold + 1;
			silver = silver - 100;
		end
	end
	if(tonumber(tmp_gold) ~= nil) then
		gold = gold + tonumber(tmp_gold);
	end
	
	
	if(anEntryIsColoured == false) then
		InstanceTime_ListFrameButtonTellActual:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_ACTUAL_TIMER);
		InstanceTime_ListFrameButtonTellAll:SetText(INSTANCETIME_MAIN_BUTTON_DISPLAY_SUMMARY);
		FreierGeist_IT_SetMoney(gold, silver, copper, mode, zoneName);
	end
end


-----------------------------------------------
--           event chat msg loot             --
-----------------------------------------------
function FreierGeist_IT_Event_ChatMsgLoot(_arg)
	local excludeItem1Text = FreierGeist_IT_Exclude[1];
	if((excludeItem1Text == "") or (excludeItem1Text == " ")) then excludeItem1Text = "no item to search for"; end
	local excludeItem2Text = FreierGeist_IT_Exclude[2];
	if((excludeItem2Text == "") or (excludeItem2Text == " ")) then excludeItem2Text = "no item to search for"; end
	local excludeItem3Text = FreierGeist_IT_Exclude[3];
	if((excludeItem3Text == "") or (excludeItem3Text == " ")) then excludeItem3Text = "no item to search for"; end
	local excludeItem4Text = FreierGeist_IT_Exclude[4];
	if((excludeItem4Text == "") or (excludeItem4Text == " ")) then excludeItem4Text = "no item to search for"; end
	local excludeItem5Text = FreierGeist_IT_Exclude[5];
	if((excludeItem5Text == "") or (excludeItem5Text == " ")) then excludeItem5Text = "no item to search for"; end
	local excludeItem6Text = FreierGeist_IT_Exclude[6];
	if((excludeItem6Text == "") or (excludeItem6Text == " ")) then excludeItem6Text = "no item to search for"; end
	local excludeItem7Text = FreierGeist_IT_Exclude[7];
	if((excludeItem7Text == "") or (excludeItem7Text == " ")) then excludeItem7Text = "no item to search for"; end
	local excludeItem8Text = FreierGeist_IT_Exclude[8];
	if((excludeItem8Text == "") or (excludeItem8Text == " ")) then excludeItem8Text = "no item to search for"; end
	local excludeItem9Text = FreierGeist_IT_Exclude[9];
	if((excludeItem9Text == "") or (excludeItem9Text == " ")) then excludeItem9Text = "no item to search for"; end
	local excludeItem10Text = FreierGeist_IT_Exclude[10];
	if((excludeItem10Text == "") or (excludeI0tem1Text == " ")) then excludeItem10Text = "no item to search for"; end


	-- exclude green and/or blue items (assigend in the options)
	if( (FreierGeist_IT_Config["FreierGeist_IT_ExcludeGreen"] == true) and (string.find(_arg, "|cff1eff00|") ~= nil) ) then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("Item refused - green", 0.1, 0.8, 0.1);
		end
		sItemDisenchanted = "---";		-- reset the saved item, because it shoudl not be saved
		return;
	end
		
	if( (FreierGeist_IT_Config["FreierGeist_IT_ExcludeBlue"] == true) and (string.find(_arg, "|cff0070dd|") ~= nil) ) then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("Item refused - blue", 0.1, 0.8, 0.1);
		end
		sItemDisenchanted = "---";		-- reset the saved item, because it shoudl not be saved
		return;
	end

	-- exclude some parser text
	if( (string.find(_arg, INSTANCETIME_PARSER_CREATE_1) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_CREATE_2) ~= nil)
		or (string.find(_arg, "|cffffffff|") ~= nil)
		or (string.find(_arg, "|cff9d9d9d|") ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_PASSED_OTHER) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_GREED) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_NEED) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_DISENCHANTED) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_PASSED) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_PASSED_AUTOMATIC) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_WON) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_RECEIVE_1) ~= nil)
		or (string.find(_arg, INSTANCETIME_PARSER_RECEIVE_2) ~= nil)
		or (string.find(_arg, "x%d") ~= nil) ) then			-- Filtert zB: "Ihr erhaltet: Gerechtigkeitspunkte x70."
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("Item refused - parser", 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage("Text:".._arg, 0.1, 0.8, 0.1);
		end
		return;
	end



	-- exclude the items of the exclude-list
	if( (string.find(_arg, excludeItem1Text) ~= nil)
		or (string.find(_arg, excludeItem2Text) ~= nil)
		or (string.find(_arg, excludeItem3Text) ~= nil)
		or (string.find(_arg, excludeItem4Text) ~= nil)
		or (string.find(_arg, excludeItem5Text) ~= nil)
		or (string.find(_arg, excludeItem6Text) ~= nil)
		or (string.find(_arg, excludeItem7Text) ~= nil)
		or (string.find(_arg, excludeItem8Text) ~= nil)
		or (string.find(_arg, excludeItem9Text) ~= nil)
		or (string.find(_arg, excludeItem10Text) ~= nil)) then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("Item refused - excludeItemText", 0.1, 0.8, 0.1);
		end
		return;
	end
	

	sItem = _arg;
	sPlayerName = _arg;

	
		
	-- filter the 'sItem' string
	-- DEFAULT_CHAT_FRAME:AddMessage("sItem 1 vorher: "..sItem);
	sItem = string.gsub(sItem, "([^%s]+) "..INSTANCETIME_PARSER_LOOT_ITEM_OTHER, "");
	sItem = string.gsub(sItem, INSTANCETIME_PARSER_LOOT_ITEM_SELF, "");
	sItem = string.gsub(sItem, "([^%s]+) "..INSTANCETIME_PARSER_LOOT_ITEM_SELF_3, "");
	--	sItem = string.gsub(sItem, "x%d", "");		-- filter number of items: [Emblem des Frosts]x5
	sItem = string.gsub(sItem, "%.", "");			-- filter .: [Emblem des Frosts]x5.
	-- DEFAULT_CHAT_FRAME:AddMessage("sItem 1 nachher: "..sItem);


	-- if player has select to disenchant the item, add the previous item name to the disenchanted info
	if((sItemDisenchanted ~= "---") and (sItemDisenchanted ~= nil)) then
		if(FreierGeist_IT_Debug) then
			DEFAULT_CHAT_FRAME:AddMessage("Adding item as disenchanted", 0.1, 0.8, 0.1);
			DEFAULT_CHAT_FRAME:AddMessage("Disenchanted item:"..sItemDisenchanted, 0.1, 0.8, 0.1);
		end
		sItem = " "..sItemDisenchanted.." => "..sItem;
		sItemDisenchanted = "---";
	end
	
				
	-- DEFAULT_CHAT_FRAME:AddMessage("sPlayerName 2 vorher: "..sPlayerName);
	sPlayerName = string.gsub(sPlayerName, " "..INSTANCETIME_PARSER_LOOT_ITEM_OTHER.."(.+)%.", "");
	sPlayerName = string.gsub(sPlayerName, " "..INSTANCETIME_PARSER_LOOT_ITEM_SELF_2.."(.+)%.", "");
	sPlayerName = string.gsub(sPlayerName, " "..INSTANCETIME_PARSER_LOOT_ITEM_SELF_3.."(.+)%.", "");
					
	if(sPlayerName == INSTANCETIME_PARSER_PLAYER_NAME) then
		sPlayerName = UnitName("player");
	end
	-- DEFAULT_CHAT_FRAME:AddMessage("sPlayerName 2 nachher: "..sPlayerName);
		


			
	-- fill the lootlist				
	if(sPlayerName ~= nil) then
		if(FreierGeist_IT_Loot["index"] == nil) then FreierGeist_IT_Loot["index"] = {}; end
		if(FreierGeist_IT_Loot["item"] == nil) then FreierGeist_IT_Loot["item"] = {}; end
		if(FreierGeist_IT_Loot["unit"] == nil) then FreierGeist_IT_Loot["unit"] = {}; end
		if(FreierGeist_IT_Loot["player"] == nil) then FreierGeist_IT_Loot["player"] = {}; end
		if(FreierGeist_IT_Loot["index"][scrollBarHeight] == nil) then FreierGeist_IT_Loot["index"][scrollBarHeight] = 0; end
		if(FreierGeist_IT_Loot["item"][scrollBarHeight] == nil) then FreierGeist_IT_Loot["item"][scrollBarHeight] = {}; end
		if(FreierGeist_IT_Loot["unit"][scrollBarHeight] == nil) then FreierGeist_IT_Loot["unit"][scrollBarHeight] = {}; end
		if(FreierGeist_IT_Loot["player"][scrollBarHeight] == nil) then FreierGeist_IT_Loot["player"][scrollBarHeight] = {}; end
			
		FreierGeist_IT_Loot["index"][scrollBarHeight] = FreierGeist_IT_Loot["index"][scrollBarHeight]+1;
		FreierGeist_IT_Loot["item"][scrollBarHeight][FreierGeist_IT_Loot["index"][scrollBarHeight]] = sItem;
		FreierGeist_IT_Loot["unit"][scrollBarHeight][FreierGeist_IT_Loot["index"][scrollBarHeight]] = unit;
		FreierGeist_IT_Loot["player"][scrollBarHeight][FreierGeist_IT_Loot["index"][scrollBarHeight]] = sPlayerName;
				
		-- refresh the lootlist
		FreierGeist_IT_LootScrollBarUpdate();
	end
end



-----------------------------------------------
--          fill the clipboard-box           --
-----------------------------------------------
function FreierGeist_IT_FillClipboard()
	local tmp_dateFormat = FreierGeist_IT_DateFormat;
	local clipboard_string = "";
	local tmp_loot = "";
	local tmp_starttime;
	local tmp_stoptime;
	


	if(timerHasStarted) then
		InstanceTime_EditBox:SetText(INSTANCETIME_CLIPBOARD_NOT_POSSIBLE_TEXT_EDITFIELD);
		DEFAULT_CHAT_FRAME:AddMessage("|cffffd200<InstanceTime> |r"..INSTANCETIME_CHAT_CLIPBOARD_NOT_POSSIBLE_TEXT);
	else
		FauxScrollFrame_Update(InstanceTimeScrollBar,scrollBarHeight,9,16);
		lineplusoffset = selectedEntry + FauxScrollFrame_GetOffset(InstanceTimeScrollBar);
		if (FreierGeist_IT_Config["FreierGeist_IT_Reverse"]) then
			lineplusoffset = scrollBarHeight-lineplusoffset;
		end

		
		-- strip down date-string
		local tmp_instance_run_day = string.sub(FreierGeist_IT_Data[lineplusoffset]["date"], 1, 2);
		local tmp_instance_run_month = string.sub(FreierGeist_IT_Data[lineplusoffset]["date"], 4, 5);
		local tmp_instance_run_year = string.sub(FreierGeist_IT_Data[lineplusoffset]["date"], 7, 8);
		
		
		-- format date
		tmp_dateFormat = string.gsub(tmp_dateFormat, "DD", tmp_instance_run_day);
		tmp_dateFormat = string.gsub(tmp_dateFormat, "MM", tmp_instance_run_month);
		tmp_dateFormat = string.gsub(tmp_dateFormat, "YYYY", "20"..tmp_instance_run_year);
		tmp_dateFormat = string.gsub(tmp_dateFormat, "YY", tmp_instance_run_year);
		
		
		-- format duration
		tmp_duration = SecondsToTime(FreierGeist_IT_Data[lineplusoffset]["stoptime"] - FreierGeist_IT_Data[lineplusoffset]["starttime"]);
		num = string.match(tmp_duration, "(%d+) |4");
		if (num == nil) then num = 0; end
		if (tonumber(num) <= 1) then
			tmp_duration = gsub(tmp_duration, "|4(.-):.-;", "%1");
		else
			tmp_duration = gsub(tmp_duration, "|4.-:(.-);", "%1");
		end
		
	
		-- create the loot/boss/player -list for the clipboard
		if (FreierGeist_IT_Loot["index"] ~= nil) then
			if (FreierGeist_IT_Loot["index"][lineplusoffset] ~= nil) then
				tmp_index = FreierGeist_IT_Loot["index"][lineplusoffset];
				for i=1, tmp_index, 1 do
					FreierGeist_IT_Loot["item"][lineplusoffset][i] = gsub(FreierGeist_IT_Loot["item"][lineplusoffset][i], "%[", "");
					FreierGeist_IT_Loot["item"][lineplusoffset][i] = gsub(FreierGeist_IT_Loot["item"][lineplusoffset][i], "%]", "");
				
					if(FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"]) or (FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"]) or (FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"]) then
						tmp_loot = tmp_loot.."\n--------------------";
					end
					if(FreierGeist_IT_Config["FreierGeist_IT_BosslistClipboardOutput"] == true) then
						tmp_loot = tmp_loot.."\n"..INSTANCETIME_CLIPBOARD_UNIT.." "..FreierGeist_IT_Loot["unit"][lineplusoffset][i];
					end
					if(FreierGeist_IT_Config["FreierGeist_IT_LootlistClipboardOutput"]) then
						tmp_loot = tmp_loot.."\n"..INSTANCETIME_CLIPBOARD_LOOT..""..FreierGeist_IT_Loot["item"][lineplusoffset][i];
					end
					if(FreierGeist_IT_Config["FreierGeist_IT_GrouplistClipboardOutput"]) then
						tmp_loot = tmp_loot.."\n"..INSTANCETIME_CLIPBOARD_PLAYER.." "..FreierGeist_IT_Loot["player"][lineplusoffset][i];
					end
				end
			end
		end
	
	
		clipboard_string = clipboard_string.."--"..FreierGeist_IT_Data[lineplusoffset]["zone"].."--"
		if(FreierGeist_IT_Config["FreierGeist_IT_StandardClipboardOutput"]) then
			clipboard_string = clipboard_string.."\n\n"..INSTANCETIME_CLIPBOARD_DATE.." "..tmp_dateFormat
			clipboard_string = clipboard_string.."\n"..INSTANCETIME_CLIPBOARD_START.." "..FreierGeist_IT_Data[lineplusoffset]["start"]
			clipboard_string = clipboard_string.."\n"..INSTANCETIME_CLIPBOARD_STOP.." "..FreierGeist_IT_Data[lineplusoffset]["stop"]
			clipboard_string = clipboard_string.."\n"..INSTANCETIME_CLIPBOARD_DURATION.." "..tmp_duration
		end
			clipboard_string = clipboard_string.."\n"..tmp_loot;
		
	
		InstanceTime_EditBox:SetText(clipboard_string);
	end
end



-----------------------------------------------------------
----------           helper functions           -----------
-----------------------------------------------------------


--------------------------------------------
--     leave the specified channels       --
--------------------------------------------
function FreierGeist_IT_LeaveTheseChannels()
	-- leave the channnels
	
    for word in string.gmatch(FreierGeist_IT_Config["FreierGeist_IT_LeaveChannels"], "%d") do
		id, name = GetChannelName(word);
		
		if(name ~= nil) then
			-- temporarily save the channel-name for re-joining after the instance
			channelIndex = channelIndex + 1;
			
			-- it didn't work with Join "General - Stormwind" but with: Join "General", so only save "General"
			channelNames[channelIndex] = string.sub(name, 0, string.find(name, " ")-1);
	
			-- leave the channel (We need to leave "General - Stormwind")
			LeaveChannelByName(name);
		end
	end
end


-------------------------------------------
--     join the specified channels       --
-------------------------------------------
function FreierGeist_IT_JoinTheseChannels()
	-- re-join the channels
    for i=1, channelIndex, 1 do
		JoinChannelByName(channelNames[i], "", 1);
	end
	
	-- Reset the counter
	channelIndex = 0;
end


--------------------------------------
--      set the output data         --
--------------------------------------
function FreierGeist_IT_SetDataOutput(_actualDate, _zoneName, _mode, _duration, _start, _stop, _XP, _reputation1, _reputation2, _reputation3, _fraction1, _fraction2, _fraction3, _gold, _silver, _copper, _gold_repair, _silver_repair, _copper_repair, _deaths, _justice_points, _valor_points)
	
	if(_actualDate == nil) then _actualDate = "-nodate-"; end
	if(_zoneName == nil) then _zoneName = "-"; end
	if(_mode == nil) then _mode = "-"; end
	if(_duration == nil) then _duration = "-noduration-"; end
	if(_start == nil) then _start = 0; end
	if(_stop == nil) then _stop = 0; end
	if(_XP == nil) then _XP = 0; end
	if(_deaths == nil) then _deaths = 0; end
	if(_justice_points == nil) then _justice_points = 0; end		-- currently no justice points are told to channel
	if(_valor_points == nil) then _valor_points = 0; end			-- currently no valor points are told to channel
	if(_reputation1 == nil) then _reputation1 = 0; end
	if(_reputation2 == nil) then _reputation2 = 0; end
	if(_reputation3 == nil) then _reputation3 = 0; end
	if(_fraction1 == nil) then _fraction1 = "-"; end
	if(_fraction2 == nil) then _fraction2 = "-"; end
	if(_fraction3 == nil) then _fraction3 = "-"; end
	if(_gold == nil) then _gold = 0; end
	if(_silver == nil) then _silver = 0; end
	if(_copper == nil) then _copper = 0; end
	if(_gold_repair == nil) then _gold_repair = 0; end
	if(_silver_repair == nil) then _silver_repair = 0; end
	if(_copper_repair == nil) then _copper_repair = 0; end
	
	
	
	-- set the entry for use in whisper, group, etc
	if((_actualDate == "") and (_zoneName == "") and (_mode == "")
		and (_duration == "") and (_start == "") and (_stop == "")
		and (_XP == "") and (_reputation1 == "") and (_reputation2 == "") and (_reputation3 == "")
		and (_fraction1 == "") and (_fraction2 == "") and (_fraction3 == "")
		and (_gold == "") and (_silver == "") and (_copper == "")
		and (_gold_repair == "") and (_silver_repair == "") and (_copper_repair == "") and (_deaths == "")) then
		FreierGeist_IT_DataOutput[1] = "";
		FreierGeist_IT_DataOutput[2] = "";
		FreierGeist_IT_DataOutput[3] = "";
		FreierGeist_IT_DataOutput[4] = "";
		FreierGeist_IT_DataOutput[5] = "";
		FreierGeist_IT_DataOutput[6] = "";
		FreierGeist_IT_DataOutput[7] = "";
		FreierGeist_IT_DataOutput[8] = "";
		FreierGeist_IT_DataOutput[9] = "";
	else
		-- post all/post selected
		if(_postAllOfThisInstance == 1) then
			FreierGeist_IT_DataOutput[1] = INSTANCETIME_MAIN_DISPLAY_SUMMARY_HEADLINE;
		else
			FreierGeist_IT_DataOutput[1] = _actualDate.."    (".._start.."  -  ".._stop..")";
		end
		
		
		-- post all/post selected
		if(_postAllOfThisInstance == 1) then
			FreierGeist_IT_DataOutput[2] = _zoneName.." (".._mode..") - Runs: ".._instance_count;
		else
			FreierGeist_IT_DataOutput[2] = _zoneName.." (".._mode..") - ".._duration;
		end
		
		
		-- post all/post selected
		local xpText = "";
		local repText = "";
		local moneyText = "";
		if(_postAllOfThisInstance == 1) then
			xpText = INSTANCETIME_MAIN_XP_GAINED_ALL;
			repText = INSTANCETIME_MAIN_REP_GAINED_ALL;
			moneyText = INSTANCETIME_MAIN_MONEY_GAINED_ALL;
			repairText = INSTANCETIME_MAIN_MONEY_REPAIRED_ALL;
		else
			xpText = INSTANCETIME_MAIN_XP_GAINED;
			repText = INSTANCETIME_MAIN_REP_GAINED;
			moneyText = INSTANCETIME_MAIN_MONEY_GAINED;
			repairText = INSTANCETIME_MAIN_MONEY_REPAIRED;
		end
		
		
		FreierGeist_IT_DataOutput[3] = xpText.._XP;
		
		
		if((race == INSTANCETIME_MAIN_STRING_HUMAN) and	(_reputation1 > 0)) then
			FreierGeist_IT_DataOutput[4] = repText.._reputation1.." (".._fraction1..") ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((_reputation1/(1.1))+0.5)..")";
		else
			FreierGeist_IT_DataOutput[4] = repText.._reputation1.." (".._fraction1..") ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((_reputation1*(1.1))+0.5)..")";
		end

		
		if(_fraction2 ~= "-") then
			if((race == INSTANCETIME_MAIN_STRING_HUMAN) and	(_reputation2  > 0)) then
				FreierGeist_IT_DataOutput[5] = repText.._reputation2.." (".._fraction2..") ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((_reputation2/(1.1))+0.5)..")";
			else
				FreierGeist_IT_DataOutput[5] = repText.._reputation2.." (".._fraction2..") ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((_reputation2*(1.1))+0.5)..")";
			end
		else
			FreierGeist_IT_DataOutput[5] = "";
		end
		
		
		if(_fraction3 ~= "-") then
			if((race == INSTANCETIME_MAIN_STRING_HUMAN) and	(_reputation3  > 0)) then
				FreierGeist_IT_DataOutput[6] = repText.._reputation3.." (".._fraction3..") ("..INSTANCETIME_MAIN_STRING_NON_HUMAN..": "..math.floor((_reputation3/(1.1))+0.5)..")";
			else
				FreierGeist_IT_DataOutput[6] = repText.._reputation3.." (".._fraction3..") ("..INSTANCETIME_MAIN_STRING_HUMAN..": "..math.floor((_reputation3*(1.1))+0.5)..")";
			end
		else
			FreierGeist_IT_DataOutput[6] = "";
		end
		
		
		FreierGeist_IT_DataOutput[7] = moneyText.." ".._gold.." "..INSTANCETIME_MAIN_MONEY_GOLD..", ".._silver.." "..INSTANCETIME_MAIN_MONEY_SILVER..", ".._copper.." "..INSTANCETIME_MAIN_MONEY_COPPER;
		FreierGeist_IT_DataOutput[8] = repairText.." ".._gold_repair.." "..INSTANCETIME_MAIN_MONEY_GOLD..", ".._silver_repair.." "..INSTANCETIME_MAIN_MONEY_SILVER..", ".._copper_repair.." "..INSTANCETIME_MAIN_MONEY_COPPER;
		FreierGeist_IT_DataOutput[9] = INSTANCETIME_MAIN_DEATHS.._deaths;
	end
end


---------------------------------------------------------
--              get date as number                     --
---------------------------------------------------------
function FreierGeist_IT_ConvertDateToNumbers(_dateString)
	local tmp_day, tmp_month, tmp_year, numberOfDays;
	local month_multiplier, year_multiplier;
	
	tmp_day = string.gsub(_dateString, "(%d+).(%d+).(%d+)", "%1");
	tmp_month = string.gsub(_dateString, "(%d+).(%d+).(%d+)", "%2");
	tmp_year = string.gsub(_dateString, "(%d+).(%d+).(%d+)", "%3");
	
	if(tonumber(tmp_year)/4 == 0) then
		year_multiplier = 366;
		if(tonumber(tmp_month) == 2) then
			month_multiplier = 29;
		else
			month_multiplier = tonumber(InstanceTime_Month[tonumber(tmp_month)]);
		end
	else
		year_multiplier = 365;
		month_multiplier = tonumber(InstanceTime_Month[tonumber(tmp_month)]);
	end
	
	return tonumber(tmp_year)*100*year_multiplier+tonumber(tmp_month)*10*month_multiplier+tonumber(tmp_day);
end


-----------------------------------------------------------
--                 for a new popup                       --
-- (add an entry to the global StaticPopupDialogs table) --
-----------------------------------------------------------
StaticPopupDialogs["DELETE_LIST"] = {
	text = INSTANCETIME_CHAT_REALLY_DELETE_QUESTION,
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		FreierGeist_IT_DeleteList();
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};


StaticPopupDialogs["CHANGE_SLIDER"] = {
	text = INSTANCETIME_CHAT_REALLY_SLIDER_CHANGE_QUESTION,
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		FreierGeist_IT_OptionSliderChanged();
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};


StaticPopupDialogs["DELETE_ENTRY"] = {
	text = INSTANCETIME_CHAT_REALLY_DELETE_ENTRY_QUESTION,
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		FreierGeist_IT_DeleteEntry();
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};


StaticPopupDialogs["MERGE_FAILED"] = {
	text = INSTANCETIME_CHAT_MERGE_FAILED,
	button1 = "Ok",
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};


StaticPopupDialogs["MERGE_ENTRIES"] = {
	text = INSTANCETIME_CHAT_REALLY_MERGE_ENTRY_QUESTION,
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		FreierGeist_IT_MergeEntries();
	end,
	OnCancel = function()
		markedIndexToMerge[1] = 0;
		markedIndexToMerge[2] = 0;
		FreierGeist_IT_ScrollBarUpdate();
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};


StaticPopupDialogs["END_INSTANCE"] = {
	text = INSTANCETIME_CHAT_REALLY_END_INSTANCE_QUESTION,
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		FreierGeist_IT_Stop();
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};



-----------------------------------------------------------
----------       for all bars using LDB          ----------
----------       		e.g. TitanPanel         	 ----------
-----------------------------------------------------------


-----------------------------------
--      fill the tooltip         --
-----------------------------------
function IT_dataobj:OnTooltipShow()
    local tmpTooltipText = INSTANCETIME_TOOLTIP_BAR.."\n\n";
    
    
    self:AddLine("|cccffffffInstanceTime|r");
	
	if (string.match(FreierGeist_IT_DataOutput[2], "%(%)") ~= nil) then
		tmpTooltipText = tmpTooltipText..INSTANCETIME_TOOLTIP_BAR_2;
	else
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[1].."\n"..FreierGeist_IT_DataOutput[2];
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[3];		
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[4];
		if(FreierGeist_IT_DataOutput[5] ~= "") then
			tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[5];
		end
		if(FreierGeist_IT_DataOutput[6] ~= "") then
			tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[6];
		end
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[7];
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[8];
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[9];
	end

	self:AddLine(tmpTooltipText);
end


---------------------------------
--     show the tooltip        --
---------------------------------
function IT_dataobj.OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
    GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
    GameTooltip:ClearLines();
    IT_dataobj.OnTooltipShow(GameTooltip);
    GameTooltip:Show();
end


-----------------------------
--    hide the tooltip     --
-----------------------------
function IT_dataobj.OnLeave()
	GameTooltip:Hide();
end


-------------------------------------------
--           handle buttons              --
-------------------------------------------
function IT_dataobj.OnClick(_self, _button)
	if((_button == "LeftButton") and (IsShiftKeyDown())) then
		FreierGeist_IT_Help();
	elseif((_button == "LeftButton") and (IsAltKeyDown())) then
		FreierGeist_IT_ShowTimer();
	elseif((_button == "RightButton") and (IsAltKeyDown())) then
		FreierGeist_IT_ShowXP();
		FreierGeist_IT_ShowRep();
	elseif((_button == "LeftButton") and (IsControlKeyDown())) then
		if(timerHasStarted) then
			FreierGeist_IT_Stop();
		else
			FreierGeist_IT_Start();
		end
	elseif(_button == "RightButton") then
		FreierGeist_IT_ShowOptions();
	else
		FreierGeist_IT_ShowList();
	end
end